import java.util.*;
import java.util.function.Supplier;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class A {

    static void rec(List<Integer> seq, int number, int dep, int maxDep) {
        if (dep == maxDep) {
            seq.add(number);
            return;
        }

        rec(seq, number, dep + 1, maxDep);
        rec(seq, number + (1 << dep), dep + 1, maxDep);
    }

    static List<Integer> getSeq(int level) {
        List<Integer> list = new ArrayList<>();
        int number = 1 << (level - 1);
        int maxDep = level - 1;
        rec(list, number, 0, maxDep);
        return list;
    }

    static void solve() {
        Scanner sc = new Scanner(System.in);
        int a = sc.nextInt();
        int b = sc.nextInt();
        int all = a + b;
        int[] weights = new int[all + 1];
        List<List<Integer>> g = Stream.generate((Supplier<ArrayList<Integer>>) ArrayList::new)
                .limit(all + 1)
                .collect(Collectors.toList());
        Arrays.fill(weights, 1);


        int maxLevel = 0;
        while ((1 << maxLevel) - 1 <= all) {
            ++maxLevel;
        }
        --maxLevel;

        int fullTree = (1 << maxLevel) - 1;
        int rem = all - fullTree;
        int remA = fullTree;
        int remB = b;

        for (int i = 0; i < maxLevel - 1; ++i) {
            int node = (1 << i);
            for (int j = node; j < (1 << (i + 1)); ++j) {
                g.get(j).add(j * 2);
                g.get(j).add(j * 2 + 1);
            }
        }

        for (int i = maxLevel; i >= 1; --i) {
            var seq = getSeq(i);

            for (int j = 0; j < seq.size(); j++) {
                if (remB == 0) break;
                int cur = seq.get(j);
                weights[cur] = 2;
                --remB;
                --remA;
            }
            if (remB == 0) break;
        }

        if (rem > 0) {
            var seq = getSeq(maxLevel + 1);
            Collections.reverse(seq);
            int currentNode = fullTree + 1;
            int shouldTakeA = a - remA;

            for (int i = 0; i < seq.size(); i++) {
                int cur = seq.get(i);
                int parent = cur / 2;
                if (cur % 2 == 0) {
                    g.get(parent).add(currentNode++);
                    g.get(parent).add(0);
                } else {
                    g.get(parent).add(0);
                    g.get(parent).add(currentNode++);
                }
                --shouldTakeA;
                if (shouldTakeA == 0) {
                    break;
                }
            }
        }

        if (remB > 0) {
            System.out.print("-1");
        } else {
            for (int i = 1; i <= all; ++i) {
                if (g.get(i).size() == 0) {
                    System.out.printf("%d 0 0%n", weights[i]);
                } else {
                    int left = g.get(i).get(0);
                    int right = g.get(i).get(1);
                    System.out.printf("%d %d %d%n", weights[i], left, right);
                }
            }
        }
    }

    public static void main(String[] args) {
        solve();
    }
}
