#include <iostream>
#include <algorithm>
using namespace std;


struct coord {
	int x, y;
};

struct triangle {
	coord a, b, c;
	int sum;
};

int pascal(int i, int j) {
	if (i == j || -i == j) return 1;
	return pascal(i - 1, j - 1) + pascal(i + 1, j - 1);
}

bool is_included(triangle t, coord z) {

	int a = (t.a.x - z.x) * (t.b.y - t.a.y) - (t.b.x - t.a.x) * (t.a.y - z.y);
	int b = (t.b.x - z.x) * (t.c.y - t.b.y) - (t.c.x - t.b.x) * (t.b.y - z.y);
	int c = (t.c.x - z.x) * (t.a.y - t.c.y) - (t.a.x - t.c.x) * (t.c.y - z.y);

	if ((a >= 0 && b >= 0 && c >= 0) || (a <= 0 && b <= 0 && c <= 0)) return true;
	else return false;
}

int counter(triangle t) {

	int sum = 0;

	int x_min = min(t.a.x, min(t.b.x, t.c.x));
	int x_max = max(t.a.x, max(t.b.x, t.c.x));

	int y_min = min(t.a.y, min(t.b.y, t.c.y));
	int y_max = max(t.a.y, max(t.b.y, t.c.y));

	int border_right = min(x_max, y_max);

	int border_left = -min(-x_min, y_max);

	int border = max(border_right, -border_left);

	for (int i = 0; i <= border; ++i) {
		for (int j = -i; j <= i; j+=2) {
			coord z;
			z.x = j; z.y = i;
			if (is_included(t, z)) {
				sum += pascal(j, i);
			}
		}
	}

	return sum;
}

int main() {

	int n;

	cin >> n;

	triangle t;

	for (int i = 0; i < n; ++i) {
		cin >> t.a.x >> t.a.y;
		cin >> t.b.x >> t.b.y;
		cin >> t.c.x >> t.c.y;

		//cout>>
		cout << counter(t) << endl;
	}



	return 0;
}