#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

long long gcd(long long a, long long b, long long& x, long long& y) {
	if (a == 0) {
		x = 0;
		y = 1;
		return b;
	}
	long long x_ = 0, y_ = 0;
	long long d = gcd(b % a, a, x_, y_);
	x = y_ - (b / a) * x_;
	y = x_;
	return d;
}

bool find_solution(long long a, long long b, long long c, long long& x0, long long& y0, long long& g) {
	g = gcd(a, b, x0, y0);
	if (c % g != 0) {
		return false;
	}
	x0 *= c / g;
	y0 *= c / g;
	return true;
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		long long b, d;
		scanf("%lld%lld", &b, &d);
		long long x0 = 0, y0 = 0, g = 0;
		if (!find_solution(d, b, b * b, x0, y0, g)) {
			printf("0\n");
		}
		else {
			long long change_x = b / g;
			long long change_y = d / g;
			long long possible_k_from, possible_k_to;
			if (x0 > 0) {
				possible_k_to = ceil(x0 * 1.0 / change_x) - 1;
				possible_k_from = floor(-y0 * 1.0 / change_y) + 1;
			}
			else {
				possible_k_from = floor(-x0 * 1.0 / change_x) + 1;
				possible_k_to = ceil(y0 * 1.0 / change_y) - 1;
			}
			printf("%lld\n", possible_k_to - possible_k_from + 1);
		}
	}
	return 0;
}