#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <climits>
#include <cstdint>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <iostream>
#include <iomanip>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <sstream>
#include <tuple>
#include <vector>

using namespace std;
using namespace chrono;

#ifdef DEBUG
	//~ #define LOCAL_INPUT_FILE
#else
	//~ #define USE_FILE_IO
#endif

#ifdef USE_FILE_IO
	#define INPUT_FILE "input.txt"
	#define OUTPUT_FILE "output.txt"
	#define cin ____cin
	#define cout ____cout
	ifstream cin(INPUT_FILE);
	ofstream cout(OUTPUT_FILE);
#else
	#ifdef LOCAL_INPUT_FILE
		#define cin ____cin
		ifstream cin("input.txt");
	#endif
#endif

const int infinity = (int)1e9 + 42;
const int64_t llInfinity = (int64_t)1e18 + 256;
const int module = (int)1e9 + 7; 
const long double eps = 1e-8;

mt19937_64 randGen(system_clock().now().time_since_epoch().count());

inline void raiseError(string errorCode) {
	cerr << "Error : " << errorCode << endl;
	exit(42);
}

inline int nu(int x) {
	int w = 0;
	while (w < x) {
		w *= 2;
		++w;
	}
	return w;
}

inline void solve(int a, int b) {
	if (a < nu(b) - b) {
		cout << -1 << endl;
		return;
	}
	vector<tuple<int, int, int>> res;
	
	function<int(int, int)> rec = [&](int a, int b) {
		assert(a >= 0 && b >= 0);
		assert(a >= nu(b) - b);
		if (a == 0 && b == 0) {
			return -1;
		}
		int w = (b % 2 == 0) ? 1 : 2;
		--(w == 1 ? a : b);
		assert(a >= 0 && b >= 0);
		assert(b % 2 == 0);
		int ret = res.size();
		res.emplace_back(w, -1, -1);
		get<1>(res[ret]) = rec(a/2, b/2);
		get<2>(res[ret]) = rec((a+1)/2, b/2);
		return ret;
	};
	rec(a, b);
	
	for (auto [w, l, r] : res) {
		cout << w << " " << l+1 << " " << r+1 << "\n";
	}
}

signed main() {
	#ifndef USE_FILE_IO
		ios_base::sync_with_stdio(false);
	#endif
	int a, b; cin >> a >> b;
	solve(a, b);
	return 0;
}
