#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <climits>
#include <cstdint>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <iostream>
#include <iomanip>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <sstream>
#include <tuple>
#include <vector>

using namespace std;
using namespace chrono;

#ifdef DEBUG
	#define LOCAL_INPUT_FILE
#else
	//~ #define USE_FILE_IO
#endif

#ifdef USE_FILE_IO
	#define INPUT_FILE "input.txt"
	#define OUTPUT_FILE "output.txt"
	#define cin ____cin
	#define cout ____cout
	ifstream cin(INPUT_FILE);
	ofstream cout(OUTPUT_FILE);
#else
	#ifdef LOCAL_INPUT_FILE
		#define cin ____cin
		ifstream cin("brainteaser2.in");
	#endif
#endif

const int infinity = (int)1e9 + 42;
const int64_t llInfinity = (int64_t)1e18 + 256;
const int module = (int)1e9 + 7; 
const long double eps = 1e-8;

mt19937_64 randGen(system_clock().now().time_since_epoch().count());

inline void raiseError(string errorCode) {
	cerr << "Error : " << errorCode << endl;
	exit(42);
}

bool doCheck(string a, string b, const string &c) {
	int lmin = max(a.size(), b.size()), lmax = lmin+1;
	if (!(lmin <= (int)c.size() && (int)c.size() <= lmax)) {
		return false;
	}
	
	int umask = 0;
	for (char ch : a) umask |= 1 << (ch - 'A');
	for (char ch : b) umask |= 1 << (ch - 'A');
	for (char ch : c) umask |= 1 << (ch - 'A');
	if (__builtin_popcount(umask) > 10) {
		return false;
	}
	
	a = string(c.size() - a.size(), '[') + a;
	b = string(c.size() - b.size(), '[') + b;
	
	vector<int> mt(26, -1);
	int counts = 0;
	
	//~ string ta(c.size(), ' '), tb(c.size(), ' '), tc(c.size(), ' ');
	
	function<void(int, int, int, int)> rec = [&](int pos, int msk, int carry, int pcarry) {
		if (pos == (int)c.size()) {
			counts += carry == 0 && pcarry == 0;
			return;
		}
		const bool fa = a[pos] != '[' && (pos == 0 || a[pos-1] == '[');
		const bool fb = b[pos] != '[' && (pos == 0 || b[pos-1] == '[');
		const bool fc = pos == 0;
		const int ap = a[pos] - 'A';
		const int bp = b[pos] - 'A';
		const int cp = c[pos] - 'A';
		
		auto tryC = [&](int a, int b) {
			if (fb && !b) {
				return;
			}
			int c = a + b + carry - pcarry*10;
			if (!(0 <= c && c < 10)) {
				return;
			}
			if (fc && !c) {
				return;
			}
			//~ ta[pos] = a + '0'; // DBG
			//~ tb[pos] = b + '0'; // DBG
			//~ tc[pos] = c + '0'; // DBG
			if (mt[cp] >= 0) {
				if (c == mt[cp]) {
					rec(pos+1, msk, 0, carry);
					rec(pos+1, msk, 1, carry);
				}
				return;
			}
			if (!(msk & (1 << c))) {
				return;
			}
			mt[cp] = c;
			msk ^= (1 << c);
			rec(pos+1, msk, 0, carry);
			rec(pos+1, msk, 1, carry);
			msk ^= (1 << c);
			mt[cp] = -1;
		};
		
		auto tryB = [&](int a) {
			if (fa && !a) {
				return;
			}
			if (bp == 26) {
				tryC(a, 0);
				return;
			}
			if (mt[bp] >= 0) {
				tryC(a, mt[bp]);
				return;
			}
			for (int i = 0; i < 10; ++i) {
				if (!(msk & (1 << i))) {
					continue;
				}
				mt[bp] = i;
				msk ^= (1 << i);
				tryC(a, i);
				msk ^= (1 << i);
				mt[bp] = -1;
			}
		};
		
		auto tryA = [&]() {
			if (ap == 26) {
				tryB(0);
				return;
			}
			if (mt[ap] >= 0) {
				tryB(mt[ap]);
				return;
			}
			for (int i = 0; i < 10; ++i) {
				if (!(msk & (1 << i))) {
					continue;
				}
				mt[ap] = i;
				msk ^= (1 << i);
				tryB(i);
				msk ^= (1 << i);
				mt[ap] = -1;
			}
		};
		
		tryA();
	};
	rec(0, 1023, 0, 0);
	rec(0, 1023, 1, 0);
	
	return counts == 1;
}

signed main() {
	#ifndef USE_FILE_IO
		ios_base::sync_with_stdio(false);
	#endif
	
	string a; cin >> a;
	string b; cin >> b;
	int n; cin >> n;
	vector<string> ans;
	for (int i = 0; i < n; ++i) {
		string wrd; cin >> wrd;
		if (doCheck(a, b, wrd)) {
			ans.push_back(wrd);
		}
	}
	cout << ans.size() << "\n";
	for (string s : ans) {
		cout << s << "\n";
	}
	
	return 0;
}
