#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <climits>
#include <cstdint>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <iostream>
#include <iomanip>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <sstream>
#include <tuple>
#include <vector>

using namespace std;
using namespace chrono;

#ifdef DEBUG
	//~ #define LOCAL_INPUT_FILE
#else
	//~ #define USE_FILE_IO
#endif

#ifdef USE_FILE_IO
	#define INPUT_FILE "input.txt"
	#define OUTPUT_FILE "output.txt"
	#define cin ____cin
	#define cout ____cout
	ifstream cin(INPUT_FILE);
	ofstream cout(OUTPUT_FILE);
#else
	#ifdef LOCAL_INPUT_FILE
		#define cin ____cin
		ifstream cin("input.txt");
	#endif
#endif

const int infinity = (int)1e9 + 42;
const int64_t llInfinity = (int64_t)1e18 + 256;
const int module = (int)1e9 + 7; 
const long double eps = 1e-8;

mt19937_64 randGen(system_clock().now().time_since_epoch().count());

inline void raiseError(string errorCode) {
	cerr << "Error : " << errorCode << endl;
	exit(42);
}

using Vit = vector<vector<int>>::iterator;

inline vector<int> combine(Vit first, Vit last) {
	if (first == last) {
		return {};
	}
	vector<int> comb = combine(first + 1, last);
	auto rcomb = comb;
	reverse(begin(rcomb), end(rcomb));
	vector<int> res = comb;
	bool rev = true;
	for (int val : *first) {
		res.push_back(val);
		const auto &add = rev ? rcomb : comb;
		res.insert(end(res), begin(add), end(add));
		rev ^= 1;
	}
	return res;
}

signed main() {
	#ifndef USE_FILE_IO
		ios_base::sync_with_stdio(false);
	#endif
	int n; cin >> n;
	vector<vector<int>> g(n);
	for (int i = 1; i < n; ++i) {
		int p; cin >> p; --p;
		g[p].push_back(i);
	}
	
	function<vector<int>(int)> dfs = [&](int v) -> vector<int> {
		vector<vector<int>> vecs;
		for (int to : g[v]) {
			vecs.push_back(dfs(to));
			vecs.back().insert(begin(vecs.back()), to);
		}
		return combine(vecs.begin(), vecs.end());
	};
	
	auto res = dfs(0);
	cout << res.size() << endl;
	for (int i : res) {
		cout << i+1 << " ";
	}
	cout << endl;
	
	return 0;
}
