// template text {{{1
#include <bits/stdc++.h>
using namespace std;

typedef long long llint;

#define fir first
#define sec second

#define len(v) (int)((v).size())

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rnd64(chrono::steady_clock::now().time_since_epoch().count());

#ifdef LOCAL

string to_string(string s);
string to_string(const char* s);
string to_string(char c);
string to_string(bool b);
template<class C>
string to_string(C c);
template<class A, class B>
string to_string(pair<A, B> p);
template<size_t N>
string to_string(bitset<N> b);
template<class A>
string to_string(A* a, int begin, int end);

string to_string(string s) {
  return string("\"") + s + "\"";
}

string to_string(const char* s) {
  return string("\"") + s + "\"";
}

string to_string(char c) {
  return string("\'") + c + "\'";
}

string to_string(bool b) {
  return b ? "True" : "False";
}

template<class C>
string to_string(C c) {
  bool f = false;
  stringstream s;
  s << "{";
  for (auto i: c) {
    if (f) s << ", ";
    f = true;
    s << to_string(i);
  }
  s << "}";
  return s.str();
}

template<class A, class B>
string to_string(pair<A, B> p) {
  return "(" + to_string(p.fir) + ", " + to_string(p.sec) + ")";
}

template<size_t N>
string to_string(bitset<N> b) {
  return b.to_string();
}

template<class A>
string to_string(A* a, int begin, int end) {
  bool f = false;
  stringstream s;
  s << "{";
  for (int i = begin; i < end; i++) {
    if (f) s << ", ";
    f = true;
    s << to_string(a[i]);
  }
  s << "}";
  return s.str();
}


template<class T>
void watch_output(T v) {
  cerr << "    " << to_string(v) << endl;
}

template<class T>
void watch_output(T* a, int begin, int end) {
  cerr << "    " << to_string(a, begin, end) << endl;
}

template<class T, class... Args>
void watch_output(T v, Args... args) {
  cerr << "    " << to_string(v) << ",\n";
  watch_output(args...);
}

#define watch(...) cerr << "[" << __func__ << ":"<< __LINE__ << "]: " #__VA_ARGS__ ":\n", watch_output(__VA_ARGS__)

#else 
#define watch(...) 
#endif
//}}}1

const int N = 4e6 + 10;
const int M = 1e9 + 7;

int f[N];
int rf[N];

int pw(int x, int n, int M) {
  if (!n) return 1;
  if (n % 2) return (1ll * x * pw(x, n - 1, M)) % M;
  return pw((1ll * x * x) % M, n / 2, M);
}

int rev(int x, int M) {
  return pw(x, M - 2, M);
}

int Calc(int n, int k) {
  if (k > n) {
    return 0;
  }
  return (((1ll * f[n] * rf[k]) % M) * rf[n - k] % M);
}

int pref_c(int n, int k) {
  if (n < 0) return 0;
  return Calc(n + 1, k + 1);
}

int Calc(int l, int r, int k) {
  l /= 2;
  r /= 2;
  k /= 2;
  return pref_c(r, k) - pref_c(l - 1, k);
}

void Init() {
  f[0] = 1;
  for (int i = 1; i < N; ++i) f[i] = (1ll * f[i - 1] * i) % M;
  rf[N - 1] = rev(f[N - 1], M);
  for (int i = N - 2; i >= 0; --i) {
    rf[i] = (1ll * rf[i + 1] * (i + 1)) % M;
  }
}

llint ans;
const llint mod(llint x) {
  x %= M;
  if (x < 0) {
    x += M;
  }
  return x;
}

struct Point {
  int x;
  int y;
};

int Sign(llint x) {
  return x < 0 ? -1 : 1;
}

int IntersectDown(Point a, Point b, int x) {
  int dx = b.x - a.x;
  llint up = 1LL * (x - a.x) * (b.y - a.y);
  int sign = Sign(dx) * Sign(up);
  up = abs(up);
  dx = abs(dx);
  return ((up + (sign < 0) * (dx - 1)) / dx) * sign + a.y;
}
int IntersectUp(Point a, Point b, int x) {
  int dx = b.x - a.x;
  llint up = 1LL * (x - a.x) * (b.y - a.y);
  int sign = Sign(dx) * Sign(up);
  up = abs(up);
  dx = abs(dx);
  return ((up + (sign > 0) * (dx - 1)) / dx) * sign + a.y;
}

void ScanLine(Point a, Point b, Point c) {
  int max_x = max({a.x, b.x, c.x});
  int min_x = min({a.x, b.x, c.x});
  if (b.x == min_x) {
    swap(a, b);
  }
  if (c.x == min_x) {
    swap(a, c);
  }
  if (c.x == max_x) {
    swap(b, c);
  }
  int start = max(0, a.x);
  start += start & 1;
  if (start != c.x) {
    for (int x = start; x <= c.x; x += 2) {
      int y_0, y_1;
      if (b.y > c.y) {
        y_0 = IntersectDown(a, b, x);
        y_1 = IntersectUp(a, c, x);
      } else {
        y_0 = IntersectDown(a, c, x);
        y_1 = IntersectUp(a, b, x);
      }
//      cerr << x << " " << y_1 << "\n" << x << " " << y_0 << "\n";
      ans = mod(1LL * ans + Calc(x+y_1, x+y_0, x));
    }
    start = c.x+1;
    start += start & 1;
  }
  for (int x = start; x <= b.x; x += 2) {
    int y_0, y_1;
    if (a.y > c.y) {
      y_0 = IntersectDown(a, b, x);
      y_1 = IntersectUp(c, b, x);
    } else {
      y_0 = IntersectDown(c, b, x);
      y_1 = IntersectUp(a, b, x);
    }
//    cerr << x << " " << y_1 << "\n" << x << " " << y_0 << "\n";
    ans = mod(1LL * ans + Calc(x+y_1, x+y_0, x));
  }
}

void Solve() {
  Point a, b, c;
  cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
  tie(a.x, a.y) = pair(a.x + a.y, a.y - a.x);
  tie(b.x, b.y) = pair(b.x + b.y, b.y - b.x);
  tie(c.x, c.y) = pair(c.x + c.y, c.y - c.x);
//  cerr << a.x << " " << a.y << " " << b.x << " " << b.y << "\n";
//  cerr << a.x << " " << a.y << " " << c.x << " " << c.y << "\n";
//  cerr << b.x << " " << b.y << " " << c.x << " " << c.y << "\n";
  ans = 0;
  ScanLine(a, b, c);
  cout << ans << "\n";
  watch(ans);
  cerr << "\n";
}

int main() {
#ifdef LOCAL
  freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#endif
  ios_base::sync_with_stdio(false); cin.tie(nullptr);
  Init();
  int t;
  cin >> t;
  while (t--) {
    Solve();
  }
  return 0;
}


