﻿#include <Math.h>
#include <iostream>

using namespace std;
long long min(long long x, long long y)
{
	return x < y ? x : y;
}
long long max(long long x, long long y)
{
	return x > y ? x : y;
}
long long gcd(long long a, long long b, long long& x, long long& y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	long long x1, y1;
	long long d = gcd(b % a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

bool find_any_solution(long long a, long long b, long long c, long long& x0, long long& y0, long long& g) {
	g = gcd(abs(a), abs(b), x0, y0);
	if (c % g != 0)
		return false;
	x0 *= c / g;
	y0 *= c / g;
	if (a < 0)   x0 *= -1;
	if (b < 0)   y0 *= -1;
	return true;
}
void shift_solution(long long& x, long long& y, long long a, long long b, long long cnt) {
	x += cnt * b;
	y -= cnt * a;
}

long long find_all_solutions(long long a, long long b, long long c, long long minx, long long maxx, long long miny, long long maxy) {
	long long x, y, g;
	if (!find_any_solution(a, b, c, x, y, g))
		return 0;
	a /= g;  b /= g;

	long long sign_a = a > 0 ? +1 : -1;
	long long sign_b = b > 0 ? +1 : -1;

	shift_solution(x, y, a, b, (minx - x) / b);
	if (x < minx)
		shift_solution(x, y, a, b, sign_b);
	if (x > maxx)
		return 0;
	long long lx1 = x;

	shift_solution(x, y, a, b, (maxx - x) / b);
	if (x > maxx)
		shift_solution(x, y, a, b, -sign_b);
	long long rx1 = x;

	shift_solution(x, y, a, b, -(miny - y) / a);
	if (y < miny)
		shift_solution(x, y, a, b, -sign_a);
	if (y > maxy)
		return 0;
	long long lx2 = x;

	shift_solution(x, y, a, b, -(maxy - y) / a);
	if (y > maxy)
		shift_solution(x, y, a, b, sign_a);
	long long rx2 = x;

	if (lx2 > rx2)
		swap(lx2, rx2);
	long long lx = max(lx1, lx2);
	long long rx = min(rx1, rx2);

	return (rx - lx) / abs(b) + 1;
}

int main()
{
	long long n;
	cin >> n;
	while (n--)
	{
		long long b, d;
		cin >> b >> d;
		long long A = d, B = b, C = b * b;
		long long sols = find_all_solutions(A, B, C, 1, 1000000000000000010, 1, 1000000000000000010);
		if (sols < 0) cout << 0 << endl;
		else cout << sols << endl;
	}
	return 0;
}