#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <list>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <utility>
using namespace std;

typedef unsigned int uint;
typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> ii;
typedef pair<int64, int64> int64int64;
typedef vector<int> vint;
typedef vector<int64> vint64;
typedef vector<uint64> vuint64;
typedef vector<vint> vvint;
typedef vector<vint64> vvint64;
typedef vector<vuint64> vvuint64;
typedef vector<ii> vii;
typedef vector<vector<ii>> vvii;

#define mp make_pair
#define pb push_back
#define ALL(a) a.begin(), a.end()
#define fi first
#define se second
#define fori(n) for(int i = 0; i < n; ++i)
#define forj(n) for(int j = 0; j < n; ++j)
#define fork(n) for(int k = 0; k < n; ++k)
#define INF9 (int64)(1e9)
#define INF18 (int64)(1e18)

template<typename T>
struct compF{
	bool operator()(const pair<T, T> &a, const pair<T, T> &b){
		return a.first < b.first;
	}
};

template<typename T>
struct compS{
	bool operator()(const pair<T, T> &a, const pair<T, T> &b){
		return a.second < b.second;
	}
};

template<typename T>
void printMatrix(const string &txt, vector<vector<T>> &a){
	cout << txt;
	fori(a.size()){
		forj(a[i].size())
			cout << a[i][j] << ' ';

		cout << endl;
	}
}

template<typename T>
void printVector(const string &txt, vector<T> &a){
	cout << txt;
	for (int i = 0; i < a.size(); ++i)
		cout << a[i] << ' ';
	cout << endl;
}

template<typename T>
void readVector(int n, vector<T> &a){
	if (a.size() < n)
		a.resize(n);

	fori(n) cin >> a[i];
}

template<typename T1, typename T2>
bool exist(map<T1, T2> &m, T1 x){
	if (m.find(x) == m.end())
		return false;

	return true;
}

int64 gcd_(int64 a, int64 b){
	while (a != 0 && b != 0){
		if (b > a)
			b %= a;
		else
			a %= b;
	}

	return a + b;
}

int64 minFactor(int64 x){
	for (int64 i = 2; i * i <= x; ++i)
		if (x % i == 0)
			return i;

	return x;
}

int64 allFactors(int64 x, vint64 &prms, vint64 &prm_cnt){
	prms.clear();
	prm_cnt.clear();
	while (x > 1){
		int64 t = minFactor(x);
		prms.push_back(t);
		int s = prms.size() - 1;
		prm_cnt.push_back(0);
		while (x % t == 0){
			x /= t;
			++prm_cnt[s];
		}
	}

	return 0;
}

int64 gcd(int64 a, int64 b, int64 & x, int64 & y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	int64 x1, y1;
	int64 g = gcd(b%a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return g;
}

int64 solCnt(int64 b, int64 d, int64 b2){
	int64 a, c;
	int64 g = gcd(d, b, a, c);

	a *= b2 / g;
	c *= b2 / g;

	int64 l, r;

	if (a < 0)
		l = ((abs(a) * g) / b);
	else
		l = -((a * g + b - 1) / b);

	if (c > 0)
		r = (c * g + d - 1) / d;
	else
		r = -((abs(c) * g) / d);

	return max(r - l - 1, 0ll);
}

bool find_any_solution(int64 a, int64 b, int64 c, int64 & x0, int64 & y0, int64 & g) {
	g = gcd(abs(a), abs(b), x0, y0);
	if (c % g != 0)
		return false;
	x0 *= c / g;
	y0 *= c / g;
	if (a < 0)   x0 *= -1;
	if (b < 0)   y0 *= -1;
	return true;
}

void shift_solution(int64 & x, int64 & y, int64 a, int64 b, int64 cnt) {
	x += cnt * b;
	y -= cnt * a;
}

int64 find_all_solutions(int64 a, int64 b, int64 c, int64 minx, int64 maxx, int64 miny, int64 maxy) {
	int64 x, y, g;
	if (!find_any_solution(a, b, c, x, y, g))
		return 0;
	a /= g;
	b /= g;

	int64 sign_a = a > 0 ? +1 : -1;
	int64 sign_b = b > 0 ? +1 : -1;

	shift_solution(x, y, a, b, (minx - x) / b);
	if (x < minx)
		shift_solution(x, y, a, b, sign_b);
	if (x > maxx)
		return 0;
	int64 lx1 = x;

	shift_solution(x, y, a, b, (maxx - x) / b);
	if (x > maxx)
		shift_solution(x, y, a, b, -sign_b);
	int64 rx1 = x;

	shift_solution(x, y, a, b, -(miny - y) / a);
	if (y < miny)
		shift_solution(x, y, a, b, -sign_a);
	if (y > maxy)
		return 0;
	int64 lx2 = x;

	shift_solution(x, y, a, b, -(maxy - y) / a);
	if (y > maxy)
		shift_solution(x, y, a, b, sign_a);
	int64 rx2 = x;

	if (lx2 > rx2)
		swap(lx2, rx2);
	int64 lx = max(lx1, lx2);
	int64 rx = min(rx1, rx2);

	if (lx > rx)
		return 0;
	return (rx - lx) / abs(b) + 1;
}

int n;

int main(){

	ios_base::sync_with_stdio(0);
	cin.tie();

//#define TEST
#ifndef TEST
	cin >> n;
	fori(n){
		int64 b, d;
		cin >> b >> d;
		int64 a, c;
		solCnt(b, d, b * b);
		cout << find_all_solutions(d, b, b*b, 1, INF9 * 1000, 1, INF9 * 1000) << endl;
	
	}
	
#else
	
	cout << "TEST" << endl;
	fori(100){
		int64 b = rand() % 1000, d = rand() % 1000;
		int64 my = solCnt(b, d, b * b);
		int64 notmy = find_all_solutions(d, b, b*b, 1, INF9 * 1000, 1, INF9 * 1000);
		char *verdict = my == notmy ? "OK" : "WRONG";
		//printf("============================\nb = %I64   d = %I64\n my = %I64    notmy = %I64\n%s\n", b, d, my, notmy, verdict);
		cout << "============================" << endl;
		cout << "b = " << b << "   d = " << d << endl;
		cout << "my = " << my << "   notmy = " << notmy << endl;
		cout << verdict << endl;

	}
	
#endif
	return 0;
}
