#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
#include <set>
#include <vector>

using namespace std;

int CUR_V = 1;
vector<vector<int>> G;
vector<int> A;

bool dfs(int cnt1, int cnt2, int prev_v) {
    int cur_v = CUR_V;
    CUR_V++;
    if (prev_v != -1) {
        G[prev_v].push_back(cur_v);
    }
    // cout << cur_v << " " << cnt1 << "-" << cnt2 << " " << prev_v << endl;

    int left_v = 0;
    int right_v = 0;
    int left_cnt1, left_cnt2, right_cnt1, right_cnt2;

    if (cnt2 % 2 == 1) {
        left_cnt1 = cnt1 / 2;
        right_cnt1 = cnt1 - left_cnt1;

        cnt2--;
        left_cnt2 = cnt2 / 2;
        right_cnt2 = cnt2 - left_cnt2;

        if (left_cnt1 || left_cnt2) {
            left_v = cur_v + 1;
        }
        if (right_cnt1 || right_cnt2) {
            right_v = cur_v + 2;
        }
        
        A[cur_v] = 2;
        bool res = true;
        if (left_v) {
            res &= dfs(left_cnt1, left_cnt2, cur_v);
        }
        if (right_v) {
            res &= dfs(right_cnt1, right_cnt2, cur_v);
        }
        return res;
    }
    
    // cnt2 % 2 == 0
    if (cnt1 == 0) {
        return false;
    }

    cnt1--;
    left_cnt1 = cnt1 / 2;
    right_cnt1 = cnt1 - left_cnt1;

    left_cnt2 = cnt2 / 2;
    right_cnt2 = cnt2 - left_cnt2;

    if (left_cnt1 || left_cnt2) {
        left_v = cur_v + 1;
    }
    if (right_cnt1 || right_cnt2) {
        right_v = cur_v + 2;
    }

    A[cur_v] = 1;
    bool res = true;
    if (left_v) {
        res &= dfs(left_cnt1, left_cnt2, cur_v);
    }
    if (right_v) {
        res &= dfs(right_cnt1, right_cnt2, cur_v);
    }
    return res;
}

int main() 
{
	// freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	ios::sync_with_stdio(0);
	cin.tie(0);

    int cnt1, cnt2;
    cin >> cnt1 >> cnt2;
    G.resize(cnt1 + cnt2 + 13);
    A.resize(cnt1 + cnt2 + 13);
    if (!dfs(cnt1, cnt2, -1)) {
        cout << -1;
        return 0;
    }

    // cout << "----" << endl;
    for (int i = 1; i <= cnt1 + cnt2; ++i) {
        cout << A[i] << " ";
        int j = 0;
        for (; j < G[i].size(); ++j) {
            cout << G[i][j] << " ";
        }
        for (; j < 2; ++j) {
            cout << 0 << " ";
        }
        cout << endl;
    }
    return 0;
}
