import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    static abstract class reader {
        static {
            Locale.setDefault(Locale.US);
        }

        static BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
        static StringTokenizer tokenizer;

        static String nextToken() {
            while (tokenizer == null || !tokenizer.hasMoreElements()) {
                try {
                    tokenizer = new StringTokenizer(bufferedReader.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return tokenizer.nextToken();
        }

        static int nextInt() {
            return Integer.parseInt(nextToken());
        }

        static double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        static long nextLong() {
            return Long.parseLong(nextToken());
        }

        static String nextLine() {
            String str = "";
            try {
                str = bufferedReader.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }
    }

    static class LongContainer {
        long value;

        public LongContainer(long value) {
            this.value = value;
        }

        public long get() {
            return value;
        }

        public void set(long value) {
            this.value = value;
        }
    }

    static long gcd(long a, long b, LongContainer x, LongContainer y) {
        if (a == 0) {
            x.set(0);
            y.set(1);
            return b;
        }
        LongContainer x1 = new LongContainer(0);
        LongContainer y1 = new LongContainer(0);
        long d = gcd(b % a, a, x1, y1);
        x.set(y1.get() - (b / a) * x1.get());
        y.set(x1.get());
        return d;
    }

    static boolean getAnySolution(long a, long b, long c, LongContainer x0, LongContainer y0, LongContainer g) {
        g.set(gcd(a, b, x0, y0));
        if (c % g.get() != 0)
            return false;
        long c0 = c / g.get();
        x0.set(x0.get() * c0);
        y0.set(y0.get() * c0);
        return true;
    }

    static void shiftSolution(LongContainer x, LongContainer y, long a, long b, long cnt) {
        x.set(x.get() + cnt * b);
        y.set(y.get() - cnt * a);
    }

    public static void main(String[] args) {
        int test = reader.nextInt();
        for (int i = 0; i < test; i++) {
            long b = reader.nextLong();
            long d = reader.nextLong();
            long z = b * b;
            LongContainer x = new LongContainer(0);
            LongContainer y = new LongContainer(0);
            LongContainer g = new LongContainer(gcd(d, b, x, y));
            x.set(0);
            y.set(b);
            long x1 = b/g.get();
            long y1 = b-d/g.get();
            if(y1<1)
                System.out.println(0);
            else {
                shiftSolution(x, y, d / g.get(), b / g.get(), (y.get() - 1) / (d / g.get()));
                if (y.get() < 1)
                    shiftSolution(x, y, d / g.get(), b / g.get(), -1);
                long x2 = x.get();
                long y2 = y.get();
                long result = 1 + (x2 - x1) / (b / g.get());
                //if(result<0)
                //    result=0;
                System.out.println(result);
            }
        }
    }
}