private val INF = 10000000

fun main() {
    val AB = readInts()
    try {
        val answer = makeTree(AB.first(), AB.last(), 1)
        for (node in answer) {
            if (node.weight != 0) println("${node.weight} ${node.left} ${node.right}")
        }
    } catch(e: IllegalStateException) {
        println(-1)
    }
}

private data class Node(val weight: Int, val left: Int, val right: Int)

private fun makeTree(A: Int, B: Int, startIndex: Int): MutableList<Node> {
    if (A%2==0 && B==0) throw IllegalStateException()
    var parentNode = if (A%2==1) {
        Node(2, startIndex *2, startIndex * 2+1)
    } else if (B>0) {
        Node(1, startIndex * 2, startIndex *2 +1)
    } else if (A>0){
        Node(2, startIndex * 2, startIndex *2 +1)
    } else {
        Node(0, 0 ,0)
    }

    return if (parentNode.weight == 0)  mutableListOf(parentNode)
    else {
        var a = A
        var b = B
        if (parentNode.weight == 1) b-- else a--
        val list = makeTree(a/2, b/2, startIndex*2)
        list.addAll(makeTree(a/2, b/2, startIndex*2 + 1))
        list
    }
}

private fun readInt(): Int= readLine()!!.toInt()
private fun readInts(): List<Int> = readLine()!!.split(" ").map { it.toInt() }
private fun readIntArray(): IntArray = readInts().toIntArray()
private fun readLongArray(): LongArray = readLine()!!.split(" ").map { it.toLong() }.toLongArray()

