#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

using ld = long double;

mt19937_64 mt(736736);

struct node
{
	int w, l, r, sum;
};

struct tree
{
	vector<node> nodes;

	void go_build (const int v, int ones)
	{
		if (ones == 0)
			return;

		nodes[v].sum -= ones;
		nodes[v].w = 1;
		ones--;
		go_build(2 * v + 1, ones / 2);
		go_build(2 * v + 2, (ones + 1) / 2);
	}

	tree (const int ones, const int twos)
	{
		nodes.resize(ones + twos);
		for (int i = int(nodes.size()) - 1; i >= 0; i--)
		{
			nodes[i] = node{2, -1, -1, 2};

			if (2 * i + 1 < int(nodes.size()))
			{
				assert(2 * i + 2 < int(nodes.size()));
				nodes[i].l = 2 * i + 1;
				nodes[i].r = 2 * i + 2;
				nodes[i].sum += nodes[2 * i + 1].sum;
				nodes[i].sum += nodes[2 * i + 2].sum;
			}
		}

		go_build(0, ones);
	}

	int extra_one ()
	{
		nodes.push_back(node{1, -1, -1, 1});
		return int(nodes.size()) - 1;
	}

	void add_one ()
	{
		int ver = 0;

		while (true)
		{
			nodes[ver].sum++;

			if (nodes[ver].l == -1)
			{
				const int x = extra_one();
				nodes[ver].l = x;
				break;
			}
			else if (nodes[ver].r == -1)
			{
				const int x = extra_one();
				nodes[ver].r = x;
				break;
			}
			else
			{
				const int l = nodes[ver].l, r = nodes[ver].r;
				if (nodes[l].sum <= nodes[r].sum)
					ver = l;
				else
					ver = r;
			}
		}
	}
};

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int ones, twos;
	cin >> ones >> twos;

	set<int> pws;
	for (int i = 1; i <= ones + twos; i = 2 * i + 1)
		pws.insert(i);

	int extra = 0;
	while (ones > 0 && !pws.count(ones + twos))
	{
		ones--;
		extra++;
	}

	if (ones == 0 && !pws.count(ones + twos))
	{
		cout << -1 << endl;
		return;
	}

	assert(pws.count(ones + twos));
	tree info(ones, twos);

	for (int i = 0; i < extra; i++)
		info.add_one();
	for (const auto &it : info.nodes)
		cout << it.w << ' ' << it.l + 1 << ' ' << it.r + 1 << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");
	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
