#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


void trans(unordered_map<char, char> &mp, string &str)
{
	for (auto &it : str)
	{
		if (!mp.count(it))
			mp[it] = char('A' + mp.size());
		it = mp[it];
	}
}


int fact(int n)
{
	return n <= 0 ? 1 : n * fact(n - 1);
}


pair<string, int> gen_canonical(unordered_map<char, char> mp, string str)
{
	trans(mp, str);

	return {str, fact(10 - (int)mp.size())};
}


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	string a, b;

	cin >> a >> b;

	unordered_map<char, char> mp;

	trans(mp, a);
	trans(mp, b);

	if (mp.size() > 10)
	{
		cout << 0 << endl;

		return;
	}

	int n;

	cin >> n;

	vector<string> arr(n);

	for (auto &row : arr)
		cin >> row;

	vector<pair<string, int>> can(arr.size());

	for (int i = 0; i < can.size(); i++)
		can[i] = gen_canonical(mp, arr[i]);

	vector<int> ord(10);
	iota(ord.begin(), ord.end(), 0);

	unordered_map<string, int> cnt;

	do
	{
		ll sa = 0, sb = 0;

		if (ord[a.front() - 'A'] != 0 && ord[b.front() - 'A'] != 0)
		{
			for (auto it : a)
			{
				sa *= 10;
				sa += ord[it - 'A'];
			}
			for (auto it : b)
			{
				sb *= 10;
				sb += ord[it - 'A'];
			}

			auto sc = sa + sb;

			string c;

			while (sc != 0)
			{
				c += char('A' + find(ord.begin(), ord.end(), sc % 10) - ord.begin());
				sc /= 10;
			}

			reverse(c.begin(), c.end());

			cnt[c]++;
		}
	} while (next_permutation(ord.begin(), ord.end()));

	vector<string> ans;

	for (int i = 0; i < can.size(); i++)
		if (cnt[can[i].first] == can[i].second)
			ans.push_back(arr[i]);

	cout << ans.size() << endl;

	for (const auto &it : ans)
		cout << it << '\n';
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
