#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forrn(i, s, n) for (int i = (int)(s); i < (int)(n); i++)
#define PYMOD(a, m) ((((a) % (m)) + (m)) % (m))
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define mp make_pair
#define ff first
#define ss second

const int mod = 1e9 + 7;
const int maxn = 1000179;

ll fct[2 * maxn];

ll fpow(ll a, ll n) {
    ll ret = 1;
    while (n != 0) {
        if (n & 1)
            ret = (ret * a) % mod;
        a = (a * a) % mod;
        n /= 2;
    }
    return ret;
}

ll inv(ll x) {
    return fpow(x, mod - 2);
}

ll cnk(int n, int k) {
    if (k > n || k < 0 || n < 0)
        return 0;
    return (fct[n] * inv((fct[k] * fct[n - k]) % mod)) % mod;
}

struct pt {
    ld x = 0, y = 0;
    pt() = default;
    pt(ld x, ld y): x(x), y(y) {}
    void read() {
        cin >> x >> y;
    }
    pt operator - (const pt &o) const {
        return pt(x - o.x, y - o.y);
    }
    pt operator + (const pt &o) const {
        return pt(x + o.x, y + o.y);
    }
    ld vector_mul(const pt &o) const {
        return x * o.y - o.x * y;
    }
    ld scalar_mul(const pt &o) const {
        return x * o.x + y * o.y;
    }
};

const double EPS = 1e-9;

double det (double a, double b, double c, double d) {
    return a * d - b * c;
}

struct line {
    double a, b, c;

    line(pt p, pt q) {
        a = p.y - q.y;
        b = q.x - p.x;
        c = -(a * p.x + b * p.y);
    }
};

bool intersect(line m, line n, pt & res) {
    double zn = det (m.a, m.b, n.a, n.b);
    if (abs (zn) < EPS)
        return false;
    res.x = - det (m.c, m.b, n.c, n.b) / zn;
    res.y = - det (m.a, m.c, n.a, n.c) / zn;
    return true;
}

ll solve_fast(pt a, pt b, pt c) {
    vector<pair<pt, pt>> segs = {
        {a, b},
        {b, c},
        {c, a}
    };

    ll ans = 0;
    for (int i = 0; i < maxn; i++) {
        pt d(-i, i);
        pt e(-i + 1, i + 1);
        int mn = maxn, mx = -maxn;
        for (auto [p, q] : segs) {
            pt r;
            if (intersect(line(d, e), line(p, q), r)) {
                if ((q - r).scalar_mul(p - r) <= 0) {
                    /* cout << r.x << " " << r.y << endl; */
                    mn = min<int>(mn, ceill(r.y));
                    mx = max<int>(mx, floorl(r.y));
                }
            }
        }
        mx = min(mx, maxn);
        if (mn <= mx) {

            ans = PYMOD(ans + cnk(mx + 1, i + 1) - cnk(mn, i + 1), mod);
        }
    }

    return ans;
}

bool is_in_angle(pt o, pt a, pt b, pt p) {
    ld v1 = (a - o).vector_mul(p - o);
    ld v2 = (p - o).vector_mul(b - o);
    return (v1 >= 0 && v2 >= 0) || (v1 <= 0 && v2 <= 0);
}

ll solve_slow(pt a, pt b, pt c) {
    ll ans = 0;
    for (int i = 0; i < 100; i++) {
        for (int j = 0; j <= i; j++) {
            pt q(-i + 2 * j, i);
            if (is_in_angle(a, b, c, q) && is_in_angle(b, a, c, q) && is_in_angle(c, a, b, q)) {
                ans = (ans + cnk(i, j)) % mod;
            }
        }
    }
    return ans;
}

mt19937 rnd(179);

void stress() {
    for (int tt = 1; tt <= 1000; tt++) {
        uniform_int_distribution dist(-10, 10);
        pt a, b, c;
        do {
            a.x = dist(rnd);
            a.y = dist(rnd);
            b.x = dist(rnd);
            b.y = dist(rnd);
            c.x = dist(rnd);
            c.y = dist(rnd);
        } while ((b - a).scalar_mul(c - b) == 0);
        ll ja = solve_slow(a, b, c);
        ll ca = solve_fast(a, b, c);
        if (ja != ca) {
            cout << "WA test " << tt << endl;
            cout << a.x << " " << a.y << " " << b.x << " " << b.y << " " << c.x << " " << c.y << endl;
            cout << "Expected: " << ja << endl;
            cout << "Found: " << ca << endl;
            return;
        }
    }
    cout << "OK" << endl;
}

void solve() {
    pt a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    cout << solve_fast(a, b, c) << endl;
}

int main() {
    fct[0] = 1;
    for (int i = 1; i < 2 * maxn; i++) {
        fct[i] = (i * fct[i - 1]) % mod;
    }

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    stress();
#endif
    // Code here:

    int t;
    cin >> t;

    for (int i = 0; i < t; i++) {
        solve();
    }

    return 0;
}
