﻿/*
X⣿⣷⡁⢆⠈⠕⢕⢂⢕⢂⢕⢂⢔⢂⢕⢄⠂⣂⠂⠆⢂⢕⢂⢕⢂⢕⢂⢕⢂
X⣿⣿⡷⠊⡢⡹⣦⡑⢂⢕⢂⢕⢂⢕⢂⠕⠔⠌⠝⠛⠶⠶⢶⣦⣄⢂⢕⢂⢕
X⣿⠏⣠⣾⣦⡐⢌⢿⣷⣦⣅⡑⠕⠡⠐⢿⠿⣛⠟⠛⠛⠛⠛⠡⢷⡈⢂⢕⢂
X⣡⣾⣿⣿⣿⣿⣦⣑⠝⢿⣿⣿⣿⣿⣿⡵⢁⣤⣶⣶⣿⢿⢿⢿⡟⢻⣤⢑⢂
X⣿⣿⡿⢟⣛⣻⣿⣿⣿⣦⣬⣙⣻⣿⣿⣷⣿⣿⢟⢝⢕⢕⢕⢕⢽⣿⣿⣷⣔
X⣿⠵⠚⠉⢀⣀⣀⣈⣿⣿⣿⣿⣿⣿⣿⣿⣿⣗⢕⢕⢕⢕⢕⢕⣽⣿⣿⣿⣿
X⣂⣠⣴⣾⡿⡿⡻⡻⣿⣿⣴⣿⣿⣿⣿⣿⣿⣷⣵⣵⣵⣷⣿⣿⣿⣿⣿⣿⡿
X⠻⣿⡿⡫⡪⡪⡪⡪⣺⣿⣿⣿⣿⣿⠿⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠃
X⡁⠹⡪⡪⡪⡪⣪⣾⣿⣿⣿⣿⠋⠐⢉⢍⢄⢌⠻⣿⣿⣿⣿⣿⣿⣿⣿⠏⠈
X⡘⢄⠙⣾⣾⣾⣿⣿⣿⣿⣿⣿⡀⢐⢕⢕⢕⢕⢕⡘⣿⣿⣿⣿⣿⣿⠏⠠⠈
X⢊⢂⢣⠹⣿⣿⣿⣿⣿⣿⣿⣿⣧⢐⢕⢕⢕⢕⢕⢅⣿⣿⣿⣿⡿⢋⢜⠠⠈
X⠁⠕⢝⡢⠈⠻⣿⣿⣿⣿⣿⣿⣿⣷⣕⣑⣑⣑⣵⣿⣿⣿⡿⢋⢔⢕⣿⠠⠈
X⡂⡀⢑⢕⡅⠂⠄⠉⠛⠻⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⡿⢋⢔⢕⢕⣿⣿⠠
*/

#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const ll mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

const ll P = 1e9 + 7;
const ll Q = 150001;

mt19937 rng(228);

vector<int> rabbit_hole(int s, vector<int> &children, vector<vector<int>> &chcodes) {
	if (s == sz(children) - 1) {
		vector<int> res(1, children[s]);
		for (auto el : chcodes[s]) res.pb(el);
		return res;
	}
	else {
		vector<int> res;
		auto seq = rabbit_hole(s + 1, children, chcodes);
		for (auto el : seq) res.pb(el);
		res.pb(children[s]);
		reverse(all(seq));
		for (auto el : seq) res.pb(el);
		for (auto el1 : chcodes[s]) {
			res.pb(el1);
			reverse(all(seq));
			for (auto el : seq) res.pb(el);
		}
		return res;
	}
}

vector<int> ctree(int v, vector<int> &p) {
	vector<int> children;
	for (int i = 0; i < sz(p); i++) if (p[i] == v) children.pb(i);
	
	vector<int> seq;
	if (sz(children) == 0) return seq;

	vector<vector<int>> chcodes;
	for (auto ch : children) chcodes.pb(ctree(ch, p));

	seq = rabbit_hole(0, children, chcodes);

	return seq;
}

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

void process_all_digits(int pos, int v, vector<int> &nums, vector<char> &dir_mtch, vector<int> &rev_mtch, vector<vector<int>> &dictree, vector<int> &amt, vector<int> &lnk, vector<int> &occ_cnt) {
	if (pos == sz(nums)) {
		if (lnk[v] != -1) occ_cnt[lnk[v]]++;
	}
	else {
		if (dir_mtch[nums[pos]] != ' ') {
			if (dictree[v][dir_mtch[nums[pos]] - 'A'] != -1)
				process_all_digits(pos + 1, dictree[v][dir_mtch[nums[pos]] - 'A'], nums, dir_mtch, rev_mtch, dictree, amt, lnk, occ_cnt);
		}
		else {
			for (char ch = 'A'; ch <= 'Z'; ch++) {
				if (rev_mtch[ch - 'A'] == -1 && dictree[v][ch - 'A'] != -1) {
					dir_mtch[nums[pos]] = ch;
					rev_mtch[ch - 'A'] = nums[pos];
					process_all_digits(pos + 1, dictree[v][dir_mtch[nums[pos]] - 'A'], nums, dir_mtch, rev_mtch, dictree, amt, lnk, occ_cnt);
					dir_mtch[nums[pos]] = ' ';
					rev_mtch[ch - 'A'] = -1;
				}
			}
		}
	}
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	string a, b;
	cin >> a >> b;

	int n;
	cin >> n;
	vector<string> dict(n);
	for (int i = 0; i < n; i++) cin >> dict[i];

	vector<string> reduced_dict;
	for (auto w : dict) {
		if (sz(w) == max(sz(a), sz(b)) || sz(w) == max(sz(a), sz(b)) + 1) reduced_dict.pb(w);
	}

	vector<vector<int>> dictree(1, vector<int>(26, -1));
	vector<int> amt(1, sz(reduced_dict));
	vector<int> lnk(1, -1);

	for (int i = 0; i < sz(reduced_dict); i++) {
		int x = 0;
		for (auto ch : reduced_dict[i]) {
			if (dictree[x][ch - 'A'] == -1) {
				dictree[x][ch - 'A'] = sz(dictree);
				dictree.emplace_back(26, -1);
				amt.pb(0);
				lnk.pb(-1);
			}
			x = dictree[x][ch - 'A'];
			amt[x]++;
		}
		lnk[x] = i;
	}

	vector<bool> in_here(26);
	for (auto ch : a) in_here[ch - 'A'] = true;
	for (auto ch : b) in_here[ch - 'A'] = true;

	string uniq_letters = "";
	for (int i = 0; i < 26; i++) if (in_here[i]) uniq_letters.pb(i + 'A');

	vector<int> uniq_rev(26, -1);
	for (int i = 0; i < sz(uniq_letters); i++) uniq_rev[uniq_letters[i] - 'A'] = i;

	vector<int> occ_cnt(sz(reduced_dict));

	if (sz(uniq_letters) > 10) cout << 0 << endl;
	else {
		for (int msk = 0; msk < (1 << 10); msk++) {
			vector<bool> decrypt(10);
			int cnt = 0;
			int x = msk;
			for (int i = 0; i < 10; i++) {
				if (x % 2 == 1) {
					decrypt[i] = true;
					cnt++;
				}
				x /= 2;
			}
			if (cnt != sz(uniq_letters)) continue;

			vector<int> perm;
			for (int i = 0; i < 10; i++) if (decrypt[i]) perm.pb(i);

			do {
				vector<char> dir_mtch(10, ' ');
				for (int i = 0; i < sz(uniq_letters); i++) dir_mtch[perm[i]] = uniq_letters[i];
				vector<int> rev_mtch(26, -1);
				for (int i = 0; i < sz(uniq_letters); i++) rev_mtch[uniq_letters[i] - 'A'] = perm[i];

				if (rev_mtch[a[0] - 'A'] == 0 || rev_mtch[b[0] - 'A'] == 0) continue;

				int num_a = 0, num_b = 0;
				for (auto ch : a) num_a = num_a * 10 + rev_mtch[ch - 'A'];
				for (auto ch : b) num_b = num_b * 10 + rev_mtch[ch - 'A'];

				int num = num_a + num_b;
				vector<int> nums;
				while (num > 0) {
					nums.pb(num % 10);
					num /= 10;
				}
				reverse(all(nums));

				process_all_digits(0, 0, nums, dir_mtch, rev_mtch, dictree, amt, lnk, occ_cnt);
			} while (next_permutation(all(perm)));
		}

		vector<string> good_words;
		for (int i = 0; i < sz(reduced_dict); i++) {
			if (occ_cnt[i] == 1) good_words.pb(reduced_dict[i]);
		}

		cout << sz(good_words) << endl;
		for (auto w : good_words) cout << w << endl;
	}
}