﻿/*
X⣿⣷⡁⢆⠈⠕⢕⢂⢕⢂⢕⢂⢔⢂⢕⢄⠂⣂⠂⠆⢂⢕⢂⢕⢂⢕⢂⢕⢂
X⣿⣿⡷⠊⡢⡹⣦⡑⢂⢕⢂⢕⢂⢕⢂⠕⠔⠌⠝⠛⠶⠶⢶⣦⣄⢂⢕⢂⢕
X⣿⠏⣠⣾⣦⡐⢌⢿⣷⣦⣅⡑⠕⠡⠐⢿⠿⣛⠟⠛⠛⠛⠛⠡⢷⡈⢂⢕⢂
X⣡⣾⣿⣿⣿⣿⣦⣑⠝⢿⣿⣿⣿⣿⣿⡵⢁⣤⣶⣶⣿⢿⢿⢿⡟⢻⣤⢑⢂
X⣿⣿⡿⢟⣛⣻⣿⣿⣿⣦⣬⣙⣻⣿⣿⣷⣿⣿⢟⢝⢕⢕⢕⢕⢽⣿⣿⣷⣔
X⣿⠵⠚⠉⢀⣀⣀⣈⣿⣿⣿⣿⣿⣿⣿⣿⣿⣗⢕⢕⢕⢕⢕⢕⣽⣿⣿⣿⣿
X⣂⣠⣴⣾⡿⡿⡻⡻⣿⣿⣴⣿⣿⣿⣿⣿⣿⣷⣵⣵⣵⣷⣿⣿⣿⣿⣿⣿⡿
X⠻⣿⡿⡫⡪⡪⡪⡪⣺⣿⣿⣿⣿⣿⠿⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠃
X⡁⠹⡪⡪⡪⡪⣪⣾⣿⣿⣿⣿⠋⠐⢉⢍⢄⢌⠻⣿⣿⣿⣿⣿⣿⣿⣿⠏⠈
X⡘⢄⠙⣾⣾⣾⣿⣿⣿⣿⣿⣿⡀⢐⢕⢕⢕⢕⢕⡘⣿⣿⣿⣿⣿⣿⠏⠠⠈
X⢊⢂⢣⠹⣿⣿⣿⣿⣿⣿⣿⣿⣧⢐⢕⢕⢕⢕⢕⢅⣿⣿⣿⣿⡿⢋⢜⠠⠈
X⠁⠕⢝⡢⠈⠻⣿⣿⣿⣿⣿⣿⣿⣷⣕⣑⣑⣑⣵⣿⣿⣿⡿⢋⢔⢕⣿⠠⠈
X⡂⡀⢑⢕⡅⠂⠄⠉⠛⠻⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⡿⢋⢔⢕⢕⣿⣿⠠
*/

#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const ll mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;

const ll P = 1e9 + 7;
const ll Q = 150001;

mt19937 rng(999);

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll sqr(ll a) {
	return a * a;
}

ll powmod(ll a, ll n, ll mod) {
	if (n <= 0) return 1;
	if (n % 2 == 0) return sqr(powmod(a, n / 2, mod)) % mod;
	return (a * powmod(a, n - 1, mod)) % mod;
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	ll a, b, c, n;
	cin >> a >> b >> c >> n;

	int N = 20000000;
	vector<int> sieve(N, -1);
	for (ll i = 2; i < N; i++) {
		if (sieve[i] != -1) continue;
		for (ll j = i * i; j < N; j += i) sieve[j] = i;
	}

	vector<int> primes;
	for (int i = 2; i < N; i++) if (sieve[i] == -1) primes.pb(i);

	ll res = 1;

	map<ll, int> el;

	for (ll x = 0; x < n; x++) {
		ll poly = a * x * x + b * x + c;

		for (auto p : primes) {
			if (poly < N) break;
			if (poly % p == 0) {
				int st = 0;
				while (poly % p == 0) {
					poly /= p;
					st++;
				}
				el[p] += st;
			}
		}

		for (ll p = N; p * p <= poly; p++) {
			if (poly % p == 0) {
				int st = 0;
				while (poly % p == 0) {
					poly /= p;
					st++;
				}
				el[p] += st;
			}
		}

		if (poly >= N) {
			el[poly]++;
		}
		else {
			while (sieve[poly] > 1) {
				el[sieve[poly]]++;
				poly /= sieve[poly];
			}
			if (poly > 1) el[poly]++;
		}
	}

	for (auto e : el) {
		//cout << e.first << ' ' << e.second << endl;
		res *= powmod(e.first, (e.second / 2) * 2, P);
		res %= P;
	}

	cout << res << endl;
}