#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <unordered_map>

using namespace std;

const int MAXN = 279497;

vector <string> dict;
bool was[1000];
vector <char> p;
bool used[10];
int num[1000];

int n;
string s1, s2;

bool is_not_zero[MAXN];
char inv_num[MAXN];
	
unordered_map <char, int> go[MAXN];
int root, cnt;
int index_[MAXN];

int has_solution[MAXN];

	int index(int v) {
		return index_[v];
	}
	void add(string s, int index) {
		int x = root;
		for (char c : s) {
			if (go[x].count(c))
				x = go[x][c];
			else {
				go[x][c] = cnt++;
				x = go[x][c];
			}
		}
		index_[x] = index;
	}
	void init(vector <string> &s) {
		root = 0;
		cnt = 1;
		for (int i = 0; i < (int)s.size(); i++)
			add(s[i], i);
	}

vector <int> find_kek(long long num1, long long num2) {
	long long num3 = num1 + num2;
	vector <int> kek;
	if (num3 == 0) {
		kek.push_back(0);
	}
	while (num3 != 0) {
		kek.push_back(num3 % 10);
		num3 /= 10;
	}
	for (int i = 0; i < (int)kek.size() - i - 1; i++)
		swap(kek[i], kek[(int)kek.size() - i - 1]);
	
	vector <int> cur_kek = {root}, new_kek;
	for (int k : kek) {
		new_kek.clear();
		bool is_star = !used[k];
		
		for (int v : cur_kek) {
			if (is_star) {
				for (pair <char, int> to : go[v])
					new_kek.push_back(to.second);
			}
			if (go[v].count(inv_num[k]))
				new_kek.push_back(go[v][inv_num[k]]);
		}
		swap(cur_kek, new_kek);

	}
	for (int i = 0; i < (int)cur_kek.size(); i++)
		cur_kek[i] = index(cur_kek[i]);
	return cur_kek;
}

void check() {
	long long num1 = 0, num2 = 0;
	for (char c : s1) {
		num1 = (10ll * (long long)num1 + (long long)num[int(c)]);
	}
	for (char c : s2) {
		num2 = (10ll * (long long)num2 + (long long)num[int(c)]);
	}
	
	
	vector <int> indexes = find_kek(num1, num2);

	long long num3 = num1 + num2;
	vector <int> kek;
	if (num3 == 0) {
		kek.push_back(0);
	}
	while (num3 != 0) {
		kek.push_back(num3 % 10);
		num3 /= 10;
	}
	num3 = num1 + num2;
	for (int i = 0; i < (int)kek.size() - i - 1; i++)
		swap(kek[i], kek[(int)kek.size() - i - 1]);
	
	for (int i : indexes) {
		if (int(kek.size()) != int(dict[i].length()))
			continue;
		
		bool sol = true;
		for (int j = 0; j < (int)dict[i].length(); j++) {
			if ((num[int(dict[i][j])] == -1 && used[kek[j]]) || (num[int(dict[i][j])] != -1 && num[int(dict[i][j])] != kek[j])) {
				sol = false;
				break;
			}
		}
		if (num[int(dict[i][0])] == -1 && used[0] == false) {
			 
			bool flag = true;
			for (int k = 1; k < 10; k++)
				if (!used[k]) {
					flag = false;
					break;
				}
			if (flag) {
				sol = false;
			}
		}
		 
		if (!sol)
			continue;
		
		has_solution[i]++;
	}
}

void gen(int i) {
	if (i == (int)p.size()) {
		check();
	}
	for (int j = (is_not_zero[int(p[i])] ? 1 : 0); j < 10; j++)
		if (!used[j]) {
			used[j] = true;
			num[int(p[i])] = j;
			inv_num[j] = p[i];
			gen(i + 1);
			num[int(p[i])] = -1;
			used[j] = false;
		}
}

int32_t main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	
	ios_base::sync_with_stdio(false);
	
	cin >> s1 >> s2;
	
	is_not_zero[int(s1[0])] = true;
	is_not_zero[int(s2[0])] = true;
	
	cin >> n;
	dict.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> dict[i];
		if (int(dict[i].length()) > max(int(s1.length()), int(s2.length())) + 1) {
			n--;
			i--;
			continue;
		}
		if (int(dict[i].length()) < max(int(s1.length()), int(s2.length()))) {
			n--;
			i--;
			continue;
		}
		for (char c = 'A'; c <= 'Z'; c++) {
			was[int(c)] = false;
		}
		for (char c : s1)
			was[int(c)] = true;
		for (char c : s2)
			was[int(c)] = true;
		for (char c : dict[i])
			was[int(c)] = true;
		int kek = 0;
		for (char c = 'A'; c <= 'Z'; c++)
			if (was[int(c)])
				kek++;
		if (kek > 10) {
			n--;
			i--;
			continue;
		}
		
	}
	
	dict.resize(n);
	
	
	init(dict);
	
	for (char c = 'A'; c <= 'Z'; c++) {
		was[int(c)] = false;
	}
	for (char c : s1)
		was[int(c)] = true;
	for (char c : s2)
		was[int(c)] = true;
	
	for (char c = 'A'; c <= 'Z'; c++) {
		if (was[int(c)])
			p.push_back(c);
		num[int(c)] = -1;
	}
	
	gen(0);
	
	int pidor = 0;
	for (int i = 0; i < n; i++)
		if (has_solution[i] == 1)
			pidor++;
	
	cout << pidor << endl;
	for (int i = 0; i < n; i++)
		if (has_solution[i] == 1)
			cout << dict[i] << endl;
	
	return 0;
}
