#include <bits/stdc++.h>
#define int long long
//
using namespace std;

const int N = 1e6 + 7, M = 1e9 + 7;
const long double eps = 1e-7;

int bpow(int x, int n) {
    if (n == 0)
        return 1;
    if (n == 1)
        return x % M;
    if (n % 2 == 0) {
        int mem = bpow(x, n / 2);
        return (mem * mem) % M;
    }
    return (bpow(x, n - 1) * x) % M;
}

int fact[N], obr[N];

void init() {
    fact[0] = 1;
    for (int i = 1; i < N; i++)
        fact[i] = (fact[i - 1] * i) % M;
    obr[N - 1] = bpow(fact[N - 1], M - 2);
    for (int i = N - 2; i >= 0; i--) {
        obr[i] = (obr[i + 1] * (i + 1)) % M;
    }
    //cout << fact[1] << ' ' << obr[1] << ' ' << obr[N - 1] << endl;
}

int cnk(int n, int k) {
    /*if (n < 0)
        return 0;
    k += n;
    if (k % 2 == 1)
        return 0;
    k /= 2;*/
    if (k > n || k < 0)
        return 0;
    //cout << "YEP" << ' ' << n << ' ' << k << ' ' <<  fact[n] << ' ' << obr[k] << ' ' << obr[n - k] << endl;
    return (((fact[n] * obr[k]) % M) * obr[n - k]) % M;
}

struct point{
    int x, y;
    point() {}
    point(int x, int y): x(x), y(y) {}
    void init() {
        cin >> x >> y;
    }
    void print() {
        cout << fixed << x << ' ' << y << endl;
    }
    long double len() {
        return sqrt(x * x + y * y);
    }
    point operator + (point a) {
        return point(x + a.x, y + a.y);
    }
    point operator - (point a) {
        return point(x - a.x, y - a.y);
    }
    point norma() {
        return point(-y, x);
    }
    int operator * (point a) {
        return x * a.x + y * a.y;
    }
    int operator ^ (point a) {
        return x * a.y - y * a.x;
    }
};

point a, b, c;
int etalon_s;
vector <pair <point, point>> segms;

int find_s(point a, point b, point c) {
    return abs((a ^ b) + (b ^ c) + (c ^ a));
}

bool is_inside(int xx, int yy) {
    point x(xx, yy);
    int s = find_s(a, b, x) + find_s(a, c, x) + find_s(b, c, x);
    return (s == etalon_s);
}

pair <int, int> get_lr(int y, int l, int r) {
    if (y < 0)
        return {1, 0};
    l += y;
    r += y;
    if (l < 0)
        l = 0;
    else
        l = (l + 1) / 2;
    if (r < 0)
        return {1, 0};
    else
        r = r / 2;
    return {l, r};
}

pair <int, int> get_sec(int y) {
    long double ll = N, rr = -N;
    for (auto elem : segms) {
        if (elem.first.y == elem.second.y)
            continue;
        if (elem.first.y <= y && y <= elem.second.y) {
            long double xx = elem.first.x + (1.0l * (elem.second.x - elem.first.x) * (y - elem.first.y) / (elem.second.y - elem.first.y));
            ll = min(ll, xx);
            rr = max(rr, xx);
            //cout << ll << ' ' << rr << endl;
        }
    }
    int l = ceil(ll);
    if (abs(round(ll) - ll) < eps)
        l = round(ll);
    int r = floor(rr);
    if (abs(round(rr) - rr) < eps)
        r = round(rr);
    return {l, r};
}

void solve() {
    etalon_s = find_s(a, b, c);
    segms.clear();
    segms.push_back({a, b});
    segms.push_back({c, b});
    segms.push_back({c, a});
    for (auto &elem : segms) {
        if (elem.first.y > elem.second.y)
            swap(elem.first, elem.second);
    }
    int min_y = min(min(a.y, b.y), c.y);
    int max_y = max(max(a.y, b.y), c.y);
    int lx = 1, rx = 0;
    /*int lx = N;
    int rx = -N;
    if (a.y == min_y) {
        lx = min(lx, a.x);
        rx = max(rx, a.x);
    }
    if (b.y == min_y) {
        lx = min(lx, b.x);
        rx = max(rx, b.x);
    }
    if (c.y == min_y) {
        lx = min(lx, c.x);
        rx = max(rx, c.x);
    }*/
    int ans = 0;
    int cur_val = 0;
    for (int y = min_y + 1; y <= max_y; y++) {
        if (lx <= rx) {
            cur_val = (cur_val * 2) % M;
            cur_val = (cur_val - cnk(y - 1, lx) + M) % M;
            cur_val = (cur_val - cnk(y - 1, rx) + M) % M;
            lx++;
        } else {
            cur_val = 0;
        }
        auto [ll, rr] = get_sec(y); 
        /*cout << y << ' ' << ll << ' ' << rr << endl;
        cout << endl << endl;*/
        auto [l, r] = get_lr(y, ll, rr);
        //cout << l << ' ' << r << endl;
        if (lx > rx) {
            for (int i = l; i <= r; i++) {
                cur_val = (cur_val + cnk(y, i)) % M;
            }
            lx = l;
            rx = r;
            //cout << 183 << ' ' << y << ' ' << lx << ' ' << rx << endl;
        } else {
            while (lx > l) {
                lx--;
                cur_val = (cur_val + cnk(y, lx)) % M;
            }
            while (lx < l) {
                cur_val = (cur_val - cnk(y, lx) + M) % M;
                lx++;
            }
            while (rx < r) {
                rx++;
                //cout << y << ' ' << rx << ' ' << cnk(y, rx) << endl;
                cur_val = (cur_val + cnk(y, rx)) % M;
            }
            while (rx > r) {
                cur_val = (cur_val - cnk(y, rx) + M) % M;
                rx--;
            }
        }
        //cout << y << ' ' << cur_val << endl;
        ans = (ans + cur_val) % M;
    }
    cout << ans << endl;
}


signed main() {
    init();
    //freopen("Desktop/input.txt", "r", stdin);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        a.init();
        b.init();
        c.init();
        solve();
    }
}
