// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238;
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 300100;

char a[N][8];
std::vector<int> moves[N];
int ans[2][1 << 8];
int state[N];

int dist(int i, int j) {
    int d = 0;
    for (int k = 0; k < 8; ++k) {
        if (a[i][k] == a[j][k]) {
            ++d;
        }
    }
    return d;
}

void solveStupid(int pref) {
    state[pref] = 0;

    for (int i = pref - 1; i >= 0; --i) {
        state[i] = 0;
        for (auto to : moves[i]) {
            if (to > pref) {
                continue;
            }
            if (state[to] == 0) {
                state[i] = 1;
            }
        }
    }

    if (state[0] == 0) {
        printf("2");
    } else {
        printf("1");
    }
}

void run() {
    int n;
    scanf("%d", &n);

    for (int i = 0; i < n; ++i) {
        scanf("\n%s", a[i]);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < std::min(n, i + 10); ++j) {
            if (j - i <= dist(i, j)) {
                moves[i].push_back(j);
            }
        }
    }

    for (int i = 0; i < std::min(8, n); ++i) {
        solveStupid(i);
    }

    for (int mask = 0; mask < (1 << 8); ++mask) {
        ans[0][mask] = (mask >> 7);
        // ans[0][mask] = 0;
        // for (auto to : moves[0]) {
        //     if ((mask >> (7 - to)) == 0) {
        //         ans[0][mask] = 1;
        //     }
        // }
    }

    int s = 0, t = 1;
    // 0 - lose
    // 1 - win
    for (int i = 8; i < n; ++i) {
        for (int mask = 0; mask < (1 << 8); ++mask) {
            int newMask = mask / 2;
            int from = i - 8;
            int bit = 0;
            for (auto to : moves[from]) {
                assert(to <= i);
                if (((mask >> (7 - (to - from - 1))) & 1) == 0) {
                    bit = 1;
                }
            }
            if (bit == 1) {
                newMask |= 1 << 7;
            }

            ans[t][mask] = ans[s][newMask];
        }

        int realMask = 0;
        state[i] = 0;
        for (int j = i - 1; j > i - 8; --j) {
            state[j] = 0;
            for (auto to : moves[j]) {
                if (to > i) {
                    continue;
                }
                if (state[to] == 0) {
                    state[j] = 1;
                }
            }
        }
        for (int j = i - 7; j <= i; ++j) {
            realMask *= 2;
            realMask += state[j];
        }

        if (ans[t][realMask] == 0) {
            printf("2");
        } else {
            printf("1");
        }

        std::swap(s, t);
    }

    printf("\n");
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    auto start = std::chrono::high_resolution_clock::now();
    run();
    auto end = std::chrono::high_resolution_clock::now();

    #ifdef PERVEEVM_LOCAL
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
