// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238;
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

// #ifdef PERVEEVM_LOCAL
//     std::mt19937 rnd(238);
// #else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
// #endif

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int dx[6] = {1, 0, -1, -1, 0, 1};
const int dy[6] = {0, 1, 1, 0, -1, -1};
int N = 20;

class Position {
public:
    int x, y;

    Position() = default;

    Position(int x, int y) : x(x), y(y) {}

    Position move(int i) {
        return Position(x + dx[i], y + dy[i]);
    }

    bool operator<(const Position& other) const {
        return x < other.x || (x == other.x && y < other.y);
    }

    bool operator==(const Position& other) const {
        return x == other.x && y == other.y;
    }

    bool operator!=(const Position& other) const {
        return !(*this == other);
    }

    bool isCorrect() {
        return abs(x) <= N && abs(y) <= N && abs(x + y) <= N;
    }

    void print() const {
        printf("%d %d\n", x, y);
    }
};

Position pos1, pos2;
std::set<Position> used;

void move(Position& pos, int i) {
    pos = pos.move(i);
    used.insert(pos);
}

std::vector<int> getMoves(Position pos) {
    std::vector<int> ans;
    for (int i = 0; i < 6; ++i) {
        Position cur = pos.move(i);

        if (!cur.isCorrect()) {
            continue;
        }
        if (used.find(cur) == used.end() && cur != pos1 && cur != pos2) {
            ans.push_back(i);
        }
    }
    return ans;
}

int move(int x, int y) {
    std::cout << x << ' ' << y << std::endl;
    std::string cmd;
    std::cin >> cmd;

    if (cmd == "win") {
        return 1;
    } else if (cmd == "lose") {
        assert(false);
        throw;
        return -1;
    } else {
        std::cin >> x >> y;
        return 0;
    }
}

void play() {
    Position pos1(-N / 2, 0);

    for (int i = 0; i < N / 2; ++i) {
        if (move(1, 0) == 1) {
            return;
        }
    }   

    if (rnd() % 2 == 0) {
        for (int i = 0; i < N; ++i) {
            if (move(-1, 1) == 1) {
                return;
            }
        }

        for (int i = N - 2; i > 0; i -= 2) {
            if (move(0, -1) == 1) {
                return;
            }

            for (int j = 0; j < i; ++j) {
                if (move(1, -1) == 1) {
                    return;
                }
            }

            if (move(-1, 0) == 1) {
                return;
            }

            for (int j = 0; j < i - 1; ++j) {
                if (move(-1, 1) == 1) {
                    return;
                }
            }
        }

        for (int i = 0; i < 2; ++i) {
            if (move(0, -1) == 1) {
                return;
            }
        }

        if (move(1, -1) == 1) {
            return;
        }

        while (true) {
            for (int i = 0; i < N - 1; ++i) {
                if (move(1, -1) == 1) {
                    return;
                }
            }
            if (move(1, 0) == 1) {
                return;
            }
            for (int i = 0; i < N - 1; ++i) {
                if (move(-1, 1) == 1) {
                    return;
                }
            }
            if (move(1, 0) == 1) {
                return;
            }
        }
    } else {
        for (int i = 0; i < N; ++i) {
            if (move(0, -1) == 1) {
                return;
            }
        }

        for (int i = N - 2; i > 0; i -= 2) {
            if (move(-1, 1) == 1) {
                return;
            }

            for (int j = 0; j < i; ++j) {
                if (move(0, -1) == 1) {
                    return;
                }
            }

            if (move(-1, 0) == 1) {
                return;
            }

            for (int j = 0; j < i - 1; ++j) {
                if (move(0, -1) == 1) {
                    return;
                }
            }
        }

        for (int i = 0; i < 2; ++i) {
            if (move(-1, 1) == 1) {
                return;
            }
        }

        if (move(0, 1) == 1) {
            return;
        }

        while (true) {
            for (int i = 0; i < N - 1; ++i) {
                if (move(0, 1) == 1) {
                    return;
                }
            }
            if (move(1, 0) == 1) {
                return;
            }
            for (int i = 0; i < N - 1; ++i) {
                if (move(0, -1) == 1) {
                    return;
                }
            }
            if (move(1, 0) == 1) {
                return;
            }
        }
    }
}

void run() {
    // int mx = 0;
    // for (int it = 0; it < 100000; ++it) {
    //     used.clear();

    //     pos1 = Position(-N / 2, 0);
    //     pos2 = Position(N / 2, 0);

    //     used.insert(pos1);
    //     used.insert(pos2);

    //     int field = 0;
    //     for (int x = -N; x <= N; ++x) {
    //         for (int y = -N; y <= N; ++y) {
    //             Position cur(x, y);
    //             if (cur.isCorrect()) {
    //                 ++field;
    //             }
    //         }
    //     }

    //     std::cout << field << std::endl;

    //     int cnt = 0;
    //     while (true) {
    //         auto moves = getMoves(pos2);
    //         if (moves.empty()) {
    //             break;
    //         }

    //         ++cnt;

    //         int cur = rnd() % (int)moves.size();
    //         move(pos2, moves[cur]);
    //         // pos2.print();
    //     }

    //     // printf("%d\n", cnt);
    //     mx = std::max(mx, cnt);
    // }

    // printf("%d\n", mx);

    fastIO;
    int t;
    std::cin >> t >> N;

    while (t--) {
        play();
    }
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    auto start = std::chrono::high_resolution_clock::now();
    run();
    auto end = std::chrono::high_resolution_clock::now();

    #ifdef PERVEEVM_LOCAL
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
