#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <complex>
#include <fstream>
#include <unordered_map>
using namespace std;

typedef pair<int, int> pii;


typedef long long ll;


int get_2(int t) {
	int k = 1;
	int cp = t;
	while (k <= t) {
		k *= 2;
	}

	return k;
}


bool can_build(int t, int o) {
	if (t == 0) return true;

	int need = get_2(t) - t - 1;
	if (need > o) {
		return false;
	}

	return true;
}

struct node {
	int l;
	int r;
	unsigned int id;
	int w;
};


vector<node> nodes;


pii split(int o, int t) {
	int n = o + 2 * t;
	for (int i = 0; i <= t; i++) {
		if (2 * i > (n + 1) / 2 || o + 2 * i < n / 2) continue;

		if (o >= (n + 1) / 2 - 2 * i) {
			int nos = (n + 1) / 2 - 2 * i;
			if (can_build(i, nos) && can_build(t - i, o - nos)) {
				return pii(nos, i);
			}
		}

		int nos = n / 2 - 2 * i;
		if (can_build(i, nos) && can_build(t - i, o - nos)) {
			return pii(nos, i);
		}
	}

	return pii(-1, -1);
}



int solve(int n, int k) {
	if (n == 0) {
		return 0;
	}

	if (n == 1) {
		nodes.push_back({ 0, 0, nodes.size() + 1, 1 });
		return nodes.size();
	}

	if (n == 2 && k == 1) {
		nodes.push_back({ 0, 0, nodes.size() + 1, 2 });
		return nodes.size();
	}

	int o = n - 2 * k;
	int t = k;

	if (k > 0) {
		pii s = split(o, t - 1);
		if (s.first != -1) {
			int lid = solve(s.first + s.second * 2, s.second);
			int rid = solve(n - s.first - s.second * 2 - 2, t - 1 - s.second);

			nodes.push_back({ lid, rid, nodes.size() + 1, 2 });
			return nodes.size();
		}
	}

	pii s = split(o - 1, t);

	int lid = solve(s.first + s.second * 2, s.second);
	int rid = solve(n - s.first + s.second * 2 - 1, k - s.second);

	nodes.push_back({ lid, rid, nodes.size() + 1, 1 });
	return nodes.size();
}

int child(int c, int n) {
	if (c == 0) {
		return 0;
	}

	return n - c + 1;
}


void print_tree() {
	int n = nodes.size();
	for (int i = n - 1; i > -1; i--) {
		cout << nodes[i].w << ' ' << child(nodes[i].l, n) << ' ' << child(nodes[i].r, n) << '\n';
	}
}



int main() {
	int ones, twos;
	cin >> ones >> twos;

	if (!can_build(twos, ones)) {
		cout << "-1";
		return 0;
	}

	solve(ones + twos * 2, twos);
	print_tree();
}