#include <algorithm>
#include <bitset>
#include <iostream>
#include <iterator>
#include <random>
#include <set>
#include <vector>

// #define FAST_ALLOCATOR_MEMORY 256000000
// #include "optimization.h"
#include <bits/stdc++.h>

using namespace std;

// #define USE_INT128
// #define int int64_t

// #undef _DEBUG

#define all(x) begin(x), end(x)
#define rall(x) (x).rbegin(), (x).rend()

#ifdef USE_INT128
#define lint __int128
#define ulint __int128
#else
#define lint int64_t
#define ulint int64_t
#endif

typedef long double ld;
// #define f first
// #define s second
typedef pair<int, int> pint;

const int inf = 1 << 30;

template <class T>
T mineq(T& a, const T& b) {
    return a = min(a, b);
}

template <class T>
T maxeq(T& a, const T& b) {
    return a = max(a, b);
}

mt19937 rd(533);
// end of default file

struct myhash {
    hash<int> h = hash<int>();

    std::size_t operator()(const pair<int, int> &p) const {
        h(p.first) + h(p.second);
    }
};

const int N = 200010;
unordered_map<pair<int, int>, int, myhash> fv;

int fvget(int x, int y) {
    int a = 0;
    for (int i = x; i > 0; i = (i & (i + 1)) - 1) {
        for (int j = y; j > 0; j = (j & (j + 1)) - 1) {
            pair<int, int> p = { i, j };
            a += fv[p];
        }
    }
    return a;
}

int fvadd(int x, int y, int a) {
    for (int i = x; i < N; i |= i + 1) {
        for (int j = y; j < N; j |= j + 1) {
            pair<int, int> p = { i, j };
            fv[p] += a;
        }
    }
}

struct node {
    int key;
    int l, r;
    int mx, mn;
};

vector<node> tree;

pair<int, int> calc(int v) {
    if (v == -1) {
        return { inf, -inf };
    }

    node& t = tree[v];

    t.mn = t.mx = t.key;
    if (t.l != -1)
        t.mn = calc(t.l).first;
    if (t.r != -1)
        t.mx = calc(t.r).second;
    return { t.mn, t.mx };
}

int32_t main() {
    srand(5332017);
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cout << fixed;
    cout.precision(1); // !!

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    tree.resize(n);

    set<int> keys;
    for (int i = 0; i < n; i++) {
        int l, r, k;
        node& t = tree[i];
        cin >> tree[i].l >> tree[i].r >> tree[i].key;
        --tree[i].l, --tree[i].r;

        keys.insert(t.key);
        keys.insert(t.key + 1);
        keys.insert(t.key - 1);
    }

    map<int, int> key_num;
    for (auto& k : keys) {
        int sz = key_num.size();
        key_num[k] = sz;
    }
    for (auto& t : tree) {
        t.key = key_num[t.key];
    }

    calc(0);

    for (auto& t : tree) {
        if (t.mx != t.mn)
            fvadd(t.mn, t.mx, 1);
    }

    int q;
    cin >> q;
    for (int qi = 0; qi < q; qi++) {
        int l, r;
        cin >> l >> r;

        l = key_num.lower_bound(l)->second;
        r = key_num.lower_bound(r)->second;
        // x < L,       L <= y <= R
        // L <= x <= R, R < y

        int ans = fvget(r, N - 1) - fvget(r, r) + fvget(l - 1, r) - fvget(l - 1, l - 1);
        cout << 1 + 2 * ans << '\n';
    }
}
