﻿// Author: Igor Smirnov
#ifdef DEBUG_MODE
#define _GLIBCXX_DEBUG 1
#endif
#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef unsigned int ui;
typedef unsigned long long ull;

#define vin(n) vector<int>(n, 0)
#define vvin(n, m) vector<vector<int>>(n, vector<int>(m, 0))
#ifndef CERR_ON
#define cerr if (false) cerr
#endif
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rev(a) reverse(all(a))
#define csp(a) cout << a << ' '
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define next next42

inline void init() {
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

int n;
const int MAXREC = 1000;

bool used[MAXREC + 1][MAXREC + 1];
int res[MAXREC + 1][MAXREC + 1];
const int MAXN = 1e5 + 42;

map<int, bool> can[MAXN];

bool solve(int A, int B) {
    if (A + B <= 1) {
        return true;
    }
    if (can[A].count(B)) {
        return can[A][B];
    }
    if (B > 0) {
        int sum = A + 2 * (B - 1);
        int left = sum / 2;
        int right = sum - left;
        int Bleft = (B - 1) / 2;
        int Bright = (B - 1) - Bleft;
        int needALeft = left - Bleft * 2;
        if (needALeft > A) {
            return can[A][B] = false;
        }
        return can[A][B] = solve(needALeft, Bleft) && solve(A - needALeft, Bright);
    }
    else {
        return true;
    }
}

bool rec(int A, int B) {
    if (A + B <= 1) {
        return true;
    }
    if (used[A][B]) {
        return res[A][B];
    }
    used[A][B] = true;
    int sum = A + 2 * B;
    bool can = false;
    if (A > 0) {
        --A;
        sum -= 1;
        int left = sum / 2;
        int right = sum - left;
        for (int leftA = 0; leftA <= min(A, left); ++leftA) {
            int need = left - leftA;
            if (need % 2 != 0) {
                continue;
            }
            int needB = need / 2;
            if (needB <= B) {
                if (rec(leftA, needB) && rec(A - leftA, B - needB)) {
                    can = true;
                    return res[A + 1][B] = true;
                }
            }
        }
        sum += 1;
        ++A;
    }
    if (B > 0 && !can) {
        --B;
        sum -= 2;
        int left = sum / 2;
        int right = sum - left;
        for (int leftA = 0; leftA <= min(A, left); ++leftA) {
            int need = left - leftA;
            if (need % 2 != 0) {
                continue;
            }
            int needB = need / 2;
            if (needB <= B) {
                if (rec(leftA, needB) && rec(A - leftA, B - needB)) {
                    can = true;
                    return res[A][B + 1] = true;
                }
            }
        }
        sum += 2;
        ++B;
    }
    return res[A][B] = false;
}

vector<vector<int>> ans;

inline int calculate_answer(int A, int B, int vertexLeft, int vertexRight) {
    if (A == 1 && B == 0) {
        assert(vertexLeft == vertexRight);
        ans[vertexLeft] = {1, -1, -1};
        return vertexLeft;
    }
    if (A == 0 && B == 1) {
        assert(vertexLeft == vertexRight);
        ans[vertexLeft] = {2, -1, -1};
        return vertexLeft;
    }
    if (A == 0 && B == 0) {
        return -1;
    }
    if (B > 0) {
        int sum = A + 2 * (B - 1);
        int left = sum / 2;
        int right = sum - left;
        int Bleft = (B - 1) / 2;
        int Bright = (B - 1) - Bleft;
        int needALeft = left - Bleft * 2;
        assert(needALeft <= A);
        int leftLastIndex = vertexLeft + 1 + needALeft + Bleft - 1;
        int leftSon = calculate_answer(needALeft, Bleft, vertexLeft + 1, leftLastIndex);
        int rightSon = calculate_answer(A - needALeft, Bright, leftLastIndex + 1, vertexRight);
        ans[vertexLeft] = {2, leftSon, rightSon};
        return vertexLeft;
    }
    else {
        int aLeft = (A - 1) / 2;
        int leftLastIndex = vertexLeft + 1 + aLeft - 1;
        int leftSon = calculate_answer(aLeft, 0, vertexLeft + 1, leftLastIndex);
        int rightSon = calculate_answer(A - 1 - aLeft, 0, leftLastIndex + 1, vertexRight);
        ans[vertexLeft] = {1, leftSon, rightSon};
        return vertexLeft;
    }

}

int main() {
    init();
    cout.precision(20);
//    for (int A = 0; A <= MAXREC; ++A) {
//        for (int B = 0; B <= MAXREC; ++B) {
//            if (solve(A, B) != rec(A, B)) {
//                cerr << A << ' ' << B << endl;
//            }
//        }
//    }
    int A, B;
    cin >> A >> B;
    if (solve(A, B)) {
        ans.resize(A + B);
        calculate_answer(A, B, 0, A + B - 1);
        forn(i, A + B) {
            cout << ans[i][0] << ' ' << ans[i][1] + 1 << ' ' << ans[i][2] + 1 << '\n';
        }
    }
    else {
        cout << -1 << endl;
    }
}