#include <iostream>
#include <vector>
using namespace std;

void printTree(vector <vector <int> > tree) {
    vector <vector <int> > index(tree.size());
    int id = 1;
    for (int i = 0; i < tree.size(); i++) {
        index[i].resize(tree[i].size());
        for (int j = 0; j < index[i].size(); j++)
            if (tree[i][j] != 0)
                index[i][j] = id++;
    }
    for (int i = 0; i < tree.size(); i++) {
        for (int j = 0; j < tree[i].size(); j++) {
            if (tree[i][j] != 0) {
                int left = 0, right = 0;
                if (i + 1 < tree.size()) {
                    if (tree[i + 1][j * 2] != 0)
                        left = index[i + 1][j * 2];
                    if (tree[i + 1][j * 2 + 1] != 0)
                        right = index[i + 1][j * 2 + 1];
                }
                cout << tree[i][j] << " " << left << " " << right << endl;
            }
        }
    }
}

void print(vector <vector <int> > v) {
    for (auto i : v) {
        for (auto j : i)
            cout << j << " ";
        cout << endl;
    }
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    while (true) {
        int a, b;
        cin >> a >> b;
        int level = 1;
        int count = 0;
        while (count + level <= b) {
            count += level;
            level *= 2;
        }

        int twos = b - count;
        if (twos != 0 && level - twos > a) {
            cout << "-1";
            continue;
        }
        vector <vector <int> > tree;
        tree.reserve(1000);

        for (int i = 0, curCount = 1; curCount < level; i++, curCount *= 2) {
            vector <int> tmp(curCount, 2);
            tree.push_back(tmp);
        }
        vector <int> balance(level, 2);

        int ones = a;
        if (twos > 0) {
            ones -= (level - twos);
            vector <int> meshLevel(level, 1);
            int left = 0, right = level / 2;
            int fills = min(level / 2, twos / 2);

            for (int i = 0; i < fills / 2; i++) {
                meshLevel[left] = 2;
                meshLevel[right] = 2;
                left += 2; right += 2;
            }
            if (twos > fills * 2) {
                twos -= fills * 2;
                left = 1; right = level / 2 + 1;
                for (int i = 0; i < twos / 2; i++) {
                    meshLevel[left] = 2;
                    meshLevel[right] = 2;
                    left += 2; right += 2;
                }
                if (twos % 2 == 1) meshLevel[level - 1] = 2;
            }
            balance = meshLevel;
            tree.push_back(meshLevel);
            level *= 2;
        }

        while (ones >= level) {
            vector <int> nextLevel(level, 1);
            tree.push_back(nextLevel);
            ones -= level;
            level *= 2;
        }

        if (ones > 0) {
            int mult = level / balance.size();
            vector <int> lastLevel(level, 0);
            int minBal = balance[0];
            for (int i = 0; i < balance.size(); i++)
                if (balance[i] < minBal)
                    minBal = balance[i];
            int left = 0, right = balance.size() - 1;
            while (left <= right) {
                while (left < balance.size() && balance[left] != minBal)
                    left++;
                while (right >= 0 && balance[right] != minBal)
                    right--;
                if (left >= balance.size() || right < 0)
                    break;

                if (ones > 0) {
                    lastLevel[left * mult + 1] = 1;
                    balance[left]++;
                    ones--;
                }
                if (ones > 0 && right > left) {
                    lastLevel[right * mult + 1] = 1;
                    balance[right]++;
                    ones--;
                }
                left++; right--;
            }

            int step = level / 2;
            left = 0, right = level - step;
            while (ones > 0) {
                while (left < right) {
                    lastLevel[left] = 1;
                    ones--;
                    if (ones > 0) {
                        lastLevel[right] = 1;
                        ones--;
                    }
                    left += step;
                    right -= step;
                }
                step /= 2;
                left = step;
                right = level - step;
            }

            tree.push_back(lastLevel);
        }
        //print(tree);
        printTree(tree);

        break;
    }

}
