#include <iostream>
#include <fstream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <list>
#include <tuple>
#include <deque>
#include <iomanip>
#include <cmath>
#include <unordered_map>
#include <queue>
#include <unordered_set>

typedef long long ll;
typedef long double ld;
using namespace std;

map<int, char> digits;
map<char, int> chars;

struct node
{
	node(int v, node* p) : parent(p), value(v) {}
	node* parent;
	int value;
	vector<node*> children;
};

void dfs(node* root, vector<int>& ans)
{
	ans.push_back(root->value);
	if (root->parent != nullptr)
	{
		int sz = ans.size() - 2;
		for (int i = sz; i >= 0; --i)
		{
			if (ans[i] == root->parent->value)
				break;
			ans.push_back(ans[i]);
		}
	}
	for (int i = 0; i < root->children.size(); ++i)
	{
		dfs(root->children[i], ans);
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<node*> nodes(n);
	nodes[0] = new node(1, nullptr);
	for (int i = 1; i < n; ++i)
	{
		int parent;
		cin >> parent;
		nodes[i] = new node(i + 1, nodes[parent - 1]);
		nodes[parent - 1]->children.push_back(nodes[i]);
	}
	vector<int> ans;
	dfs(nodes[0], ans);
	cout << ans.size() - 1 << endl;
	for (int i = 1; i < ans.size(); ++i)
		cout << ans[i] << " ";
	cout << endl;

	return 0;
}