#include <bits/stdc++.h>
#include <stdlib.h>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<long long> vll;

#define FOR(i, a, b) for (auto i {a}; i < b; i++) // a = i's initial value, b = limit
#define X first
#define Y second
#define MP make_pair
#define PB push_back
#define all(x) x.begin(), x.end()
#define all_(x) x.rbegin(), x.rend()

const ll MOD = 1000000007;
const int INF = 1034567890;
const ll LL_INF = 1234567890123456789ll;
const double PI = acos(-1);
const long double ERR = 1E-10;

struct node
{
    int data; //node will store an integer
    struct node *right_child; // right child
    struct node *left_child; // left child
};

struct node* search(struct node *root, int x)
{
    if(root==NULL || root->data==x) //if root->data is x then the element is found
        return root;
    else if(x>root->data) // x is greater, so we will search the right subtree
        return search(root->right_child, x);
    else //x is smaller than the data, so we will search the left subtree
        return search(root->left_child,x);
}

//function to find the minimum value in a node
struct node* find_minimum(struct node *root)
{
    if(root == NULL)
        return NULL;
    else if(root->left_child != NULL) // node with minimum value will have no left child
        return find_minimum(root->left_child); // left most element will be minimum
    return root;
}

struct node* find_maximum(struct node *root){
    if(root == NULL)
        return NULL;
    else if(root->right_child != NULL)
        return find_maximum(root->right_child);
    return root;
}

ll cnt = 0;
ll lookup(struct node* root, ll L, ll R){
    cnt++;
    if(root == NULL) return 0;
    if(L <= find_minimum(root)->data && find_maximum(root)->data <= R) return 1;
    if(find_maximum(root)->data < L || R < find_minimum(root)->data) return 0;
    
    ll res = 0;
    if(L <= root->data && root->data <= R) res++;
    
    res += lookup(root->left_child, L, R);
    res += lookup(root->right_child, L, R);
    return res;
}

//function to create a node
struct node* new_node(int x)
{
    struct node *p;
    p = (struct node *)malloc(sizeof(struct node));
    p->data = x;
    p->left_child = NULL;
    p->right_child = NULL;

    return p;
}

struct node* insert(struct node *root, int x)
{
    //searching for the place to insert
    if(root==NULL)
        return new_node(x);
    else if(x>root->data) // x is greater. Should be inserted to right
        root->right_child = insert(root->right_child, x);
    else // x is smaller should be inserted to left
        root->left_child = insert(root->left_child,x);
    return root;
}

void inorder(struct node *root)
{
    if(root!=NULL) // checking if the root is not null
    {
        inorder(root->left_child); // visiting left child
        printf(" %d ", root->data); // printing data at root
        inorder(root->right_child);// visiting right child
    }
}

void add_node(struct node *root, ll ind, vector<vll> v){
    if(v[ind-1][0] > 0){
        root->left_child = new_node(v[v[ind-1][0]-1][2]);
        add_node(root->left_child, v[ind-1][0], v);
    }
    if(v[ind-1][1] > 0){
        root->right_child = new_node(v[v[ind-1][1]-1][2]);
        add_node(root->right_child, v[ind-1][1], v);
    }
}

int main()
{
    int n; cin>> n;
    vector<vll> v;
    int l, r, d;
    FOR(i, 0, n){
        cin>> l>> r>> d;
        v.PB({l, r, d});
    }
    
    struct node * root;
    root = new_node(v[0][2]);
    
    add_node(root, 1, v);
    
    // inorder(root);
    int q; cin>> q;
    ll L, R;
    
    ll pr = 0;
    FOR(i, 0, q){
        cin>> L>> R;
        // cout<< lookup(root, L, R)<< "\n";
        cout << cnt - pr << endl;
        pr = cnt;
    }
    

    return 0;
}