#include <iostream>
#include <cstdio>
#include <string>
#include <cstdlib>
#include <set>
#include <utility>
#include <vector>
#include <list>
#include <algorithm>
#include <regex>
#include <cmath>
#include <map>
#include <iterator>
#include <climits>
#include <numeric>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <valarray>
#include <complex>
#include <random>
#include <functional>
#include <cassert>
#include <chrono>
#include <memory>

using namespace std;

#define int long long
//region TEMPLATE
////@formatter:off
typedef long long ll;
typedef unsigned long long ull;
template<typename T>void __read(T&a){cin >> a;}
template<typename T,typename ... Args>void __read(T&a,Args&... args){cin >> a;__read(args...);}
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(a, n) VI a(n); for(auto&v:(a)) cin >> v;
#define ALL(x) (x).begin(), (x).end()
#define RALL(x) (x).rbegin(), (x).rend()
typedef vector<int> VI;
typedef vector<vector<int>> VVI;
typedef pair<int, int> PII;
constexpr ll M7 = 1000000007;
constexpr ll M9 = 1000000009;
constexpr ll MFFT = 998244353;
constexpr double PI = 3.14159265358979323846;
template<class T> void outv(const T&a,char d=' ', bool nl=false){for(auto&x:a)cout<<x<<d;if(nl)cout<<'\n';}
static mt19937_64 rnd(static_cast<unsigned>(chrono::steady_clock::now().time_since_epoch().count())); // NOLINT(cert-err58-cpp)
auto __fast_io__=(ios_base::sync_with_stdio(false),cin.tie(nullptr)); // NOLINT(cert-err58-cpp,cppcoreguidelines-interfaces-global-init)
////@formatter:on
//endregion

namespace nt {

    template<class T>
    static vector<T> factorize(const T &num) {
        vector<T> res;
        for (T i = 2; i * i <= num; ++i) {
            if (num % i == 0) {
                res.push_back(i);
            }
        }
        if (!res.empty()) {
            for (int32_t i = static_cast<int32_t>(res.size()) - (res.back() * res.back() == num ? 2 : 1); i >= 0; --i) {
                res.push_back(num / res[i]);
            }
        }
        return res;
    }

    template<class T>
    static vector<T> primeFactorize(T num) {
        vector<T> res;
        while (num % 2 == 0) {
            res.push_back(2);
            num /= 2;
        }
        for (T i = 3; i * i <= num; i += 2) {
            while (num % i == 0) {
                res.push_back(i);
                num /= i;
            }
        }
        if (num != 1) {
            res.push_back(num);
        }
        return res;
    }

    //return vector of primes and degrees
    template<class T>
    static vector<pair<T, int32_t>> primeFactorize2(T num) {
        vector<pair<T, int32_t>> res;
        if (num % 2 == 0) {
            num /= 2;
            res.emplace_back(2, 1);
            while (num % 2 == 0) {
                num /= 2;
                res.back().second++;
            }
        }
        for (T i = 3; i * i <= num; i += 2) {
            if (num % i == 0) {
                num /= i;
                res.emplace_back(i, 1);
                while (num % i == 0) {
                    num /= i;
                    res.back().second++;
                }
            }
        }
        if (num != 1) {
            res.emplace_back(num, 1);
        }
        return res;
    }

    template<class T>
    static bool isPrime(const T &num) {
        if (num == 0 || num == 1) {
            return false;
        }
        vector<T> res;
        for (T i = 2; i * i <= num; ++i) {
            if (num % i == 0) {
                return false;
            }
        }
        return true;
    }

    template<class T>
    static T eulerFunction(T num) {
        T res = num;
        for (T i = 2; i * i <= num; ++i) {
            if (num % i == 0) {
                num /= i;
                res -= res / i;
                while (num % i == 0) {
                    num /= i;
                }
            }
        }
        if (num != 1) {
            res -= res / num;
        }
        return res;
    }

    static vector<char> sieve(int32_t n) {
        vector<char> isPrime(n + 1, 1);
        isPrime[0] = isPrime[1] = 0;
        for (int32_t i = 4; i <= n; i += 2) {
            isPrime[i] = 0;
        }
        for (int32_t i = 3; i * i <= n; i += 2) {
            if (isPrime[i]) {
                for (int32_t j = i * i; j <= n; j += i) {
                    isPrime[j] = 0;
                }
            }
        }
        return isPrime;
    }

    //return vector primes and vector min divisors
    template<class T>
    static pair<vector<T>, vector<T>> sieve2(T n) {
        vector<T> primes, d(n + 1);
        d[0] = d[1] = 1;
        for (int32_t i = 2; i <= n; ++i) {
            if (d[i] == 0) {
                d[i] = i;
                primes.push_back(i);
            }
            int64_t dd = i;
            int64_t num;
            for (int32_t j = 0; j < primes.size() && primes[j] <= dd && (num = dd * primes[j]) <= n; ++j) {
                d[num] = primes[j];
            }
        }
        return {primes, d};
    }

    template<class T>
    T gcd(T a, T b) {
        while (b != 0) {
            T t = a % b;
            a = b;
            b = t;
        }
        return a;
    }

    template<class T>
    T gcd(T a, T b, T &x, T &y) {
        if (b == 0) {
            x = 1;
            y = 0;
            return a;
        }
        T g = gcd(b, a % b, y, x);
        y -= a / b * x;
        return g;
    }

    template<class T>
    T lcm(T a, T b) {
        return a / gcd(a, b) * b;
    }

};
//using namespace nt;



int calc(int a, int b, int c) {
    int x, y;
    nt::gcd(a, b, x, y);
    x *= c;
    y *= c;
    if (x <= 0) {
        int cnt = (-x / b) + 1;
        x += cnt * b;
        y -= cnt * a;
    }
    if (y <= 0) {
        int cnt = (-y / a) + 1;
        x -= cnt * b;
        y += cnt * a;
    }
    if (x <= 0 || y <= 0) {
        return 0;
    }

    int cnt = x / b;
    if (x % b == 0){
        cnt--;
    }
    x -= cnt * b;
    y += cnt * a;

    return y / a;
}

void solve(int32_t testNumber) {
    make(int, b, d);
    int g = nt::gcd(b, d);
    int z = b * b;
    b /= g;
    d /= g;
    z /= g;
    cout << calc(b, d, z) << '\n';
}


int32_t main() {
    make(int32_t, testCount);
    for (int32_t testNumber = 0; testNumber < testCount; ++testNumber) {
        solve(testNumber);
    }
    return 0;
}