#include <iostream>
#include <cstdio>
#include <string>
#include <cstdlib>
#include <set>
#include <utility>
#include <vector>
#include <list>
#include <algorithm>
#include <regex>
#include <cmath>
#include <map>
#include <iterator>
#include <climits>
#include <numeric>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <valarray>
#include <complex>
#include <random>
#include <functional>
#include <cassert>
#include <chrono>
#include <memory>

using namespace std;

#define int long long
//region TEMPLATE
////@formatter:off
typedef long long ll;
typedef unsigned long long ull;
template<typename T>void __read(T&a){cin >> a;}
template<typename T,typename ... Args>void __read(T&a,Args&... args){cin >> a;__read(args...);}
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(a, n) VI a(n); for(auto&v:(a)) cin >> v;
#define ALL(x) (x).begin(), (x).end()
#define RALL(x) (x).rbegin(), (x).rend()
typedef vector<int> VI;
typedef vector<vector<int>> VVI;
typedef pair<int, int> PII;
constexpr ll M7 = 1000000007;
constexpr ll M9 = 1000000009;
constexpr ll MFFT = 998244353;
constexpr double PI = 3.14159265358979323846;
template<class T> void outv(const T&a,char d=' ', bool nl=false){for(auto&x:a)cout<<x<<d;if(nl)cout<<'\n';}
static mt19937_64 rnd(static_cast<unsigned>(chrono::steady_clock::now().time_since_epoch().count())); // NOLINT(cert-err58-cpp)
auto __fast_io__=(ios_base::sync_with_stdio(false),cin.tie(nullptr)); // NOLINT(cert-err58-cpp,cppcoreguidelines-interfaces-global-init)
////@formatter:on
//endregion

//region MODULAR
template<int32_t MOD>
struct modular {

    template<class U>
    static modular fpow(const modular &a, const U &b) {
        assert(b >= 0);
        modular x = a, res = 1;
        U p = b;
        while (p > 0) {
            if (p & 1) {
                res *= x;
            }
            x *= x;
            p >>= 1;
        }
        return res;
    }

    int32_t value;

    constexpr modular() : value() {}

    template<typename U>
    modular(const U &x) {
        value = normalize(x);
    }

    template<typename U>
    static int32_t normalize(const U &x) {
        int32_t v;
        if (-MOD <= x && x < MOD) v = static_cast<int32_t>(x);
        else v = static_cast<int32_t>(x % MOD);
        if (v < 0) v += MOD;
        return v;
    }

    const int32_t &operator()() const {
        return value;
    }

    template<typename U>
    explicit operator U() const {
        return static_cast<U>(value);
    }

    constexpr static int32_t mod() {
        return MOD;
    }

    modular &operator+=(const modular &other) {
        value += other.value;
        if (value >= MOD) {
            value -= MOD;
        }
        return *this;
    }

    modular &operator-=(const modular &other) {
        value -= other.value;
        if (value < 0) {
            value += MOD;
        }
        return *this;
    }

    modular &operator++() {
        return *this += 1;
    }

    modular &operator--() {
        return *this -= 1;
    }

    const modular operator++(int32_t) {
        modular result(*this);
        *this += 1;
        return result;
    }

    const modular operator--(int32_t) {
        modular result(*this);
        *this -= 1;
        return result;
    }

    modular operator-() const {
        return modular(-value);
    }

    modular &operator*=(const modular &other) {
        value = normalize(static_cast<int64_t>(value) * static_cast<int64_t>(other));
        return *this;
    }

    modular inverse() const {
        return fpow(*this, MOD - 2);
    }

    modular &operator/=(const modular &other) {
        return *this *= modular(other.inverse());
    }

    static vector<modular<MOD>> inverse(int32_t n) {
        vector<modular<MOD>> inv(n);
        inv[1] = 1;
        for (int32_t i = 2; i < n; ++i) {
            inv[i] = -MOD / i * inv[MOD % i];
        }
        return inv;
    }

    static vector<modular<MOD>> factorial(int32_t n) {
        vector<modular<MOD>> fact(n);
        fact[0] = 1;
        for (int32_t i = 1; i < n; ++i) {
            fact[i] = fact[i - 1] * i;
        }
        return fact;
    }

    static vector<modular<MOD>> invFactorial(int32_t n) {
        modular<MOD> f = 1;
        for (int32_t i = 2; i < n; ++i) {
            f *= i;
        }
        vector<modular<MOD>> invFact(n);
        invFact[n - 1] = f.inverse();
        for (int32_t i = n - 2; i > 0; --i) {
            invFact[i] = invFact[i + 1] * (i + 1);
        }
        return invFact;
    }

    template<int32_t MODU>
    friend bool operator==(const modular<MODU> &l, const modular<MODU> &r);

    template<int32_t MODU>
    friend bool operator<(const modular<MODU> &l, const modular<MODU> &r);

    template<int32_t MODU>
    friend std::istream &operator>>(std::istream &stream, modular<MODU> &number);
};

template<int32_t MOD>
bool operator==(const modular<MOD> &l, const modular<MOD> &r) {
    return l.value == r.value;
}

template<int32_t MOD, typename U>
bool operator==(const modular<MOD> &l, U r) {
    return l == modular<MOD>(r);
}

template<int32_t MOD, typename U>
bool operator==(U l, const modular<MOD> &r) {
    return modular<MOD>(l) == r;
}

template<int32_t MOD>
bool operator!=(const modular<MOD> &l, const modular<MOD> &r) {
    return l.value != r.value;
}

template<int32_t MOD, typename U>
bool operator!=(const modular<MOD> &l, U r) {
    return !(l == r);
}

template<int32_t MOD, typename U>
bool operator!=(U l, const modular<MOD> &r) {
    return !(l == r);
}

template<int32_t MOD>
bool operator<(const modular<MOD> &l, const modular<MOD> &r) {
    return l.value < r.value;
}

template<int32_t MOD>
modular<MOD> operator+(const modular<MOD> &l, const modular<MOD> &r) {
    return modular<MOD>(l) += r;
}

template<int32_t MOD, typename U>
modular<MOD> operator+(const modular<MOD> &l, U &r) {
    return modular<MOD>(l) += r;
}

template<int32_t MOD, typename U>
modular<MOD> operator+(U l, const modular<MOD> &r) {
    return modular<MOD>(l) += r;
}

template<int32_t MOD>
modular<MOD> operator-(const modular<MOD> &l, const modular<MOD> &r) {
    return modular<MOD>(l) -= r;
}

template<int32_t MOD, typename U>
modular<MOD> operator-(const modular<MOD> &l, U r) {
    return modular<MOD>(l) -= r;
}

template<int32_t MOD, typename U>
modular<MOD> operator-(U l, const modular<MOD> &r) {
    return modular<MOD>(l) -= r;
}

template<int32_t MOD>
modular<MOD> operator*(const modular<MOD> &l, const modular<MOD> &r) {
    return modular<MOD>(l) *= r;
}

template<int32_t MOD, typename U>
modular<MOD> operator*(const modular<MOD> &l, U r) {
    return modular<MOD>(l) *= r;
}

template<int32_t MOD, typename U>
modular<MOD> operator*(U l, const modular<MOD> &r) {
    return modular<MOD>(l) *= r;
}

template<int32_t MOD>
modular<MOD> operator/(const modular<MOD> &l, const modular<MOD> &r) {
    return modular<MOD>(l) /= r;
}

template<int32_t MOD, typename U>
modular<MOD> operator/(const modular<MOD> &l, U r) {
    return modular<MOD>(l) /= r;
}

template<int32_t MOD, typename U>
modular<MOD> operator/(U l, const modular<MOD> &r) {
    return modular<MOD>(l) /= r;
}

template<int32_t MOD>
std::ostream &operator<<(std::ostream &stream, const modular<MOD> &number) {
    return stream << number();
}

template<int32_t MOD>
std::istream &operator>>(std::istream &stream, modular<MOD> &number) {
    int64_t x;
    stream >> x;
    number.value = modular<MOD>::normalize(x);
    return stream;
}

using mint = modular<M7>;
//endregion

struct point {
    int x, y;

    point(int x = 0, int y = 0) : x(x), y(y) {}
};

inline int area(point a, point b, point c) {
    return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

inline int sgn(int x){
    if (x < 0) return -1;
    if (x == 0) return 0;
    return 1;
}

inline bool intersect_1(int a, int b, int c, int d) {
    if (a > b) swap(a, b);
    if (c > d) swap(c, d);
    return max(a, c) <= min(b, d);
}

bool intersect(point a, point b, point c, point d) {
    int asda = sgn(area(a, b, c)) * sgn(area(a, b, d));
    int qweq = sgn(area(c, d, a)) * sgn(area(c, d, b)) ;
    return intersect_1(a.x, b.x, c.x, d.x)
           && intersect_1(a.y, b.y, c.y, d.y)
           && sgn(area(a, b, c)) * sgn(area(a, b, d)) <= 0
           && sgn(area(c, d, a)) * sgn(area(c, d, b)) <= 0;
}

int32_t main() {
    make(int, t);
    auto f = mint::factorial(2001000);
    auto invf = mint::invFactorial(2001000);
    invf[0] = 1;
    auto C = [&](int n, int k) {
        if (k < 0 || n < 0 || n < k) return mint(0);
        return f[n] * invf[k] * invf[n - k];
    };
    auto sum = [&](int l, int r, int k) {
        return C(r + 1, k + 1) - C(l, k + 1);
    };
    while (t--) {
        vector<point> a(3);
        for (auto&[x, y] : a) {
            cin >> x >> y;
            int tx = x, ty = y;
            x = tx + ty;
            y = ty - tx;
        }
        mint ans = 0;
        for (int cx = 0; cx <= 2'000'100; cx += 2) {
            vector<pair<int, int>> z;
            for (int i = 0; i < 3; ++i) {
                auto&[sx, sy] = a[i];
                auto&[ex, ey] = a[(i + 1) % 3];
                if (sx != ex && intersect({cx, -2001000}, {cx, 2'001'000}, {sx, sy}, {ex, ey})) {
                    int A = ey - sy;
                    int B = sx - ex;
                    int c = -(A * sx + B * sy);
                    z.emplace_back(-c - A * cx, B);
                }
            }
            if (!z.empty()) {
                for(auto& [x, y] : z){
                    if (y < 0){
                        x *= -1;
                        y *= -1;
                    }
                }
                sort(ALL(z), [](const PII& a, const PII& b){
                   return a.first * b.second < a.second * b.first;
                });

                PII mn = z[0], mx = z.back();
                if (mn.second < 0){
                    mn.first *= -1;
                    mn.second *= -1;
                }
                if (mx.second < 0){
                    mx.first *= -1;
                    mx.second *= -1;
                }
                if (mn.first * mx.second > mx.first * mn.second) {
                    swap(mn, mx);
                }
                if (mx.first * mx.second < 0){
                    continue;
                }
                int l = max(0ll, (mn.first + mn.second - 1) / mn.second);
                if (l % 2 == 1) {
                    l++;
                }
                int r = mx.first / mx.second;
                if (r % 2 == 1) {
                    r--;
                }
                if (l <= r) {
                    ans += sum(l / 2 + cx / 2, r / 2 + cx / 2, cx / 2);
                }
            }
        }
        cout << ans << '\n';

    }


    return 0;
}