#include <iostream>
#include <cstdio>
#include <string>
#include <cstdlib>
#include <set>
#include <utility>
#include <vector>
#include <list>
#include <algorithm>
#include <regex>
#include <cmath>
#include <map>
#include <iterator>
#include <climits>
#include <numeric>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <valarray>
#include <complex>
#include <random>
#include <functional>
#include <cassert>
#include <chrono>
#include <memory>

using namespace std;

#define int long long
//region TEMPLATE
////@formatter:off
typedef long long ll;
typedef unsigned long long ull;
template<typename T>void __read(T&a){cin >> a;}
template<typename T,typename ... Args>void __read(T&a,Args&... args){cin >> a;__read(args...);}
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(a, n) VI a(n); for(auto&v:(a)) cin >> v;
#define ALL(x) (x).begin(), (x).end()
#define RALL(x) (x).rbegin(), (x).rend()
typedef vector<int> VI;
typedef vector<vector<int>> VVI;
typedef pair<int, int> PII;
constexpr ll M7 = 1000000007;
constexpr ll M9 = 1000000009;
constexpr ll MFFT = 998244353;
constexpr double PI = 3.14159265358979323846;
template<class T> void outv(const T&a,char d=' ', bool nl=false){for(auto&x:a)cout<<x<<d;if(nl)cout<<'\n';}
static mt19937_64 rnd(static_cast<unsigned>(chrono::steady_clock::now().time_since_epoch().count())); // NOLINT(cert-err58-cpp)
auto __fast_io__=(ios_base::sync_with_stdio(false),cin.tie(nullptr)); // NOLINT(cert-err58-cpp,cppcoreguidelines-interfaces-global-init)
////@formatter:on
//endregion

VVI tree;

void build(int pos, int l, int r, VVI &v) {
    if (l == r) {
        tree[pos] = v[l];
        return;
    }
    int npos = pos * 2;
    int mid = (l + r) / 2;
    build(npos, l, mid, v);
    build(npos + 1, mid + 1, r, v);
    tree[pos].resize(tree[npos].size() + tree[npos + 1].size());
    merge(ALL(tree[npos]), ALL(tree[npos + 1]), tree[pos].begin());
}

int query(int pos, int l, int r, int ql, int qr, int b) {
    if (l > qr || ql > r) return 0;
    if (l >= ql && r <= qr) {
        int i = lower_bound(ALL(tree[pos]), b) - tree[pos].begin();
        return tree[pos].size() - i;
    }
    int npos = pos * 2;
    int mid = (l + r) / 2;
    int res1 = query(npos, l, mid, ql, qr, b);
    int res2 = query(npos + 1, mid + 1, r, ql, qr, b);
    return res1 + res2;
}

int32_t main() {
    make(int, n);
    VI z;
    VI L(n), R(n), v(n);
    for (int i = 0; i < n; ++i) {
        cin >> L[i] >> R[i] >> v[i];
        z.push_back(v[i]);
        L[i]--, R[i]--;
    }
    make(int, q);
    vector<pair<int, int>> qr(q);
    for (auto&[l, r] : qr) {
        cin >> l >> r;
        z.push_back(l);
        z.push_back(r);
    }
    sort(ALL(z));
    z.resize(unique(ALL(z)) - z.begin());
    int sz = z.size();

    VI mn(ALL(v)), mx(ALL(v));
    function<void(int)> dfs = [&](int v) {
        if (L[v] != -1) {
            dfs(L[v]);
            mn[v] = min(mn[v], mn[L[v]]);
        }
        if (R[v] != -1) {
            dfs(R[v]);
            mx[v] = max(mx[v], mx[R[v]]);
        }
    };
    dfs(0);

    VVI rv(sz);
    for (int i = 0; i < n; ++i) {
        int j = lower_bound(ALL(z), mn[i]) - z.begin();
        rv[j].push_back(mx[i]);
    }
    for(auto& b : rv){
        sort(ALL(b));
    }
    tree.assign(sz * 4, {});
    build(1, 0, sz - 1, rv);

    for (auto&[l, r] : qr) {
        int li = lower_bound(ALL(z), l) - z.begin();
        int ri = lower_bound(ALL(z), r) - z.begin();
        int res = li == 0 ? 0 : query(1, 0, sz - 1, 0, li - 1, l);
        res += query(1, 0, sz - 1, li, ri, r + 1);
        cout << res * 2 + 1 << '\n';
    }


    return 0;
}