﻿#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("tune=native")

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <utility>
#include <algorithm>
#include <assert.h>
#include <string>
#include <stack>
#include <queue>
#include <tuple>
#include <numeric>
#include <fstream>
#include <ctime>
#include <array>
#include <random>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAX_N = 32;

vector<int> g[MAX_N];
bool direction[MAX_N];
bool colored[MAX_N];
int parent[MAX_N];

bool nextcoloring(int v, int& changed)
{
	if (direction[v])
	{
		// 1->0
		if (!colored[v])
		{
			direction[v] = !direction[v];
			return false;
		}
		
		for (int u : g[v])
			if (nextcoloring(u, changed))
				return true;
		colored[v] = !colored[v];
		changed = v;
		return true;
	}
	else
	{
		//0->1
		if (!colored[v])
		{
			colored[v] = !colored[v];
			changed = v;
			return true;
		}

		for (int u : g[v])
			if (nextcoloring(u, changed))
				return true;

		direction[v] = !direction[v];
		return false;
	}
}

bool checkIt(int v, bool canbecolored)
{
	if (colored[v] && !canbecolored) return false;
	if (!colored[v]) canbecolored = false;

	for (auto u : g[v])
		if (!checkIt(u, canbecolored))
			return false;

	return true;
}

int32_t main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	for (int i = 1; i < n; i++)
	{
		int p;
		cin >> p;
		g[p - 1].push_back(i);
		parent[i] = p - 1;
	}

	colored[0] = true;

	int changed = -1;
	vector<int> result;
	while (nextcoloring(0, changed))
	{
		result.push_back(changed + 1);
	}

	cout << result.size() << endl;
	for (auto e : result)
		cout << e << ' ';
	cout << endl;

	return 0;
}