#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

#include <algorithm>
#include <cmath>
#include <functional>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <vector>
#include <random>

using namespace std;

using LL = long long;
using pii = pair<int, int>;

#define X first
#define Y second

void cerr_printer(bool start) {}
template<typename T, typename ... Args>
void cerr_printer(bool start, const T& x, const Args& ... args) {
    if (!start) cerr << ", ";
    cerr << x;
    cerr_printer(false, args...);
}

template<typename ... Args>
void dbg(const char * name, int line, const Args& ... args) {
    cerr << "[" << line << "] (" << name << ") = (";
    cerr_printer(true, args...);
    cerr << ")" << endl;
}

#define DBG(...) { dbg(#__VA_ARGS__, __LINE__, __VA_ARGS__); }

const int MAX = 2e5 + 10;
vector<int> graf[MAX];

map<int, int> g;
int mn[MAX], mx[MAX];
int l[MAX], r[MAX];
int col[MAX];

void dfs(int v) {
    if (v == 0) {
        return;
    }
    dfs(l[v]);
    dfs(r[v]);

    mn[v] = l[v] ? mn[l[v]] : col[v];
    mx[v] = r[v] ? mx[r[v]] : col[v];
}

struct Fenv {
    vector<int> tree;

    Fenv(int n) {
        tree.resize(n + 1);
    }

    void set(int i, int dx) {
        for (; i < tree.size(); i |= i + 1) {
            tree[i] += dx;
        }
    }

    int get(int i) {
        int res = 0;

        for (; i > 0; i = (i & (i + 1)) - 1) {
            res += tree[i];
        }

        return res;
    }

    int obrGet(int i) {
        return get(tree.size() - 1) - get(i - 1);
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    int n;
    cin >> n;

    int k;
    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i] >> col[i];
        g[col[i]] = 0;
    }

    int m;
    cin >> m;
    vector<pair<pair<int, int>, int>> q(m);


    for (int i = 0; i < m; ++i) {
        cin >> q[i].first.first >> q[i].first.second;
        q[i].second = i;
        g[q[i].first.first] = 0;
        g[q[i].first.second] = 0;
    }


    int cnt = 0;

    for (auto& it : g) {
        it.second = ++cnt;
    }

    for (int i = 0; i < m; ++i) {
        q[i].first.first = g[q[i].first.first];
        q[i].first.second = g[q[i].first.second];
    }

    dfs(1);

    Fenv lef(g.size()), rig(g.size());

    priority_queue<pair<int, int>> h;

    for (int i = 1; i <= n; ++i) {
        int n = g[mn[i]], x = g[mx[i]];
        lef.set(n, +1);
        rig.set(x, +1);
        h.emplace(n, x);
    }

    sort(q.begin(), q.end());

    vector<int> res(m);

    for (auto s : q) {
        int id = s.second;
        auto pr = s.first;

        int curRes = rig.get(pr.first - 1) + lef.obrGet(pr.second + 1);

        res[id] += curRes;
    }

    Fenv inp(g.size());

    reverse(q.begin(), q.end());

    for (auto s : q) {
        int id = s.second;
        auto pr = s.first;

        while (!h.empty() && h.top().first >= pr.first) {
            inp.set(h.top().second, +1);
            h.pop();
        }

        int curRes = inp.get(pr.first, pr.second);

        res[id] += curRes;
    }

    for (auto it : res) {
        cout << (n - it) * 2 + 1 << endl;
    }
}

void fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    fast();
    //gen();
    //freopen("file.txt", "r", stdin);

    //clock_t start = clock();
    int k = 1;
    //cin >> k;
    while (k-- > 0) {
        solve();
    }
    //clock_t end = clock();
    //double seconds = (double)(end - start) / CLOCKS_PER_SEC;
    //printf("The time: %f seconds\n", seconds);
}