//#define FILEINOUT

// includes
#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;

// files
#ifdef FILEINOUT
ifstream In("Input.txt");
ofstream Out("Output.txt");
#else
#define In cin
#define Out cout
#endif

// macross
// loops
#define fori(x) for (ll i = 0; i < (x); i++)
#define fordi(x) for (ll i = (x - 1); i >= 0; i--)
#define forj(x) for (ll j = 0; j < (x); j++)
#define fordj(x) for (ll j = (x - 1); j >= 0; j--)
#define forn(i, n) for (ll i = 0; i < (n); i++)
#define fordn(i, n) for (ll i = (n - 1); i >= 0; i--)
#define FOR(i, a, b) for (ll i = (a); i < (b); i++)
#define FORD(i, a, b) for (ll i = (a); i >= (b); i--)
#define forin(x) for (auto &t : (x))
#define For(i, start, cond, dif) for (ll i = (start); (cond); (dif))

// short names
#define fi first
#define se second
#define pb push_back
#define ppb pop_back
#define rz resize
#define sz size()
#define asg assign
#define ins insert
#define clr clear()

// upgraded funcs
#define min3(a, b, c) min(ll(a), min(ll(b), ll(c)))
#define max3(a, b, c) max(ll(a), max(ll(b), ll(c)))
#define abs0(x) max(L0, ll(x))
#define pow2(x) ((x) * (x))
#define pow3(x) ((x) * (x) * (x))
#define all(x) (x).begin(), (x).end()
#define dosort(x) sort(all(x))
#define doreverse(x) reverse(all(x))
#define doperm(x) next_permutation(all(x))

// my funcs
#define read(x) for (auto &t : (x)) In >> t
#define write(x) for (auto &t : (x)) Out << t << ' ';
#define watch(x) cout << (#x) << " --> " << (x) << endl
#define in(x) ll x; In >> x
#define improve(a, b) (a = (a < (b) ? (b) : a))
#define deimprove(a, b) (a = (a > (b) ? (b) : a))

// olympic funcs
#define close_int(x) (ll)((ld)(x) + 0.5)
#define is_2_power() (x && (!(x & (x - 1)))
#define fastIO ios::sync_with_stdio(NULL); In.tie(NULL); Out.tie(NULL)
#define endl '\n'

// solution templates
#define tests(q) in(q); while (q--)
#define classic tests(q) { in(n); vi v(n); read(v); solve(v); }
#define matrix in(n); in(m); vvi v(n, vi(m)); fori(n) forj(m) In >> v[i][j];

typedef long long  ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef pair<ll, ii> iii;
typedef pair<double, double> dd;
typedef vector<ll> vi;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<string> vs;
typedef vector<double> vd;
typedef vector<ii> vii;
typedef vector<dd> vdd;
typedef vector<vi> vvi;
typedef vector<vb> vvb;
typedef vector<vc> vvc;
typedef set<ll> si;
typedef set<double> sd;
typedef set<string> ss;
typedef set<char> sc;
typedef map<ll, ll> mii;
typedef map<ll, double> mid;
typedef map<string, ll> msi;
typedef unordered_set<ll> usi;
typedef unordered_set<double> usd;
typedef unordered_set<string> uss;
typedef unordered_set<char> usc;
typedef unordered_map<ll, ll> umii;
typedef unordered_map<ll, double> umid;
typedef unordered_map<string, ll> umsi;
typedef queue<ll> qi;
typedef priority_queue<ll> maxheap;
typedef priority_queue <ll, vi, greater<ll> > minheap;
typedef deque<ll> deqi;

const ld ZERO = 1e-15;
const ld EPS = 1e-10;
const ll N = 100500;
const ll MOD = 1000000007;
const ll INF9 = 1e9;
const ll INF = 2 * 1e18;
const ll L0 = 0;
const ll L1 = 1;
const ld PI = acos(-1);
const ld SQ2 = sqrt(2.0);


// ------------------    FUNCTIONS    ------------------ //

bool is_prime(ll n) {
    if (n == 1) return false;
    ll cnt = 0;
    For(i, 2, i * i <= n, ++i) {
        cnt += !(n % i);
    }
    return !cnt;
}

// z[i] is length of the longest common prefix and i-th suffix
// z[0] = 0
vi z_func(vi& v) {
    ll n = v.size();
    vi z(n);
    for (ll i=1, l=0, r=0; i<n; ++i) {
        if (i <= r) z[i] = min(r - i + 1, z[i - l]);
        while (i + z[i] < n && v[z[i]] == v[i + z[i]]) ++z[i];
        if (i + z[i] - 1 > r) l = i, r = i + z[i] -1;
    }
    return z;
}

// pf[i] is length of the longest suffix v[0...i] which equals to its prefix
// pf[0] = 0
vi prefix_func(vi& v) {
    ll n = v.size();
    vi pf(n, 0);
    FOR(i, 1, n) {
        ll j = pf[i - 1];
        while (j > 0 && v[i] != v[j]) j = pf[j - 1];
        if (v[i] == v[j]) ++j;
        pf[i] = j;
    }
    return pf;
}

// returns (a ^ p) % m
ll modulo_power(ll a, ll p, ll m) {
    ll x = 1;
    ll y = a;
    while (p > 0) {
        if (p & 1) x = (x * y) % m;
        y = (y * y) % m;
        p >>= 1;
    }
    return x;
}

// returns factorisation of number
vii prime_divisors_extended(ll number) {
    vii divisors;
    if (number % 2 == 0) {
        ll cnt = 0;
        while (number % 2 == 0) { number /= 2; ++cnt; }
        if (cnt) divisors.push_back({2, cnt});
    }
    ll start_number = number;
    for (ll p = 3; p <= number && p * p <= start_number; p += 2) {
        ll cnt = 0;
        while (number % p == 0) { number /= p; ++cnt; }
        if (cnt) divisors.push_back({p, cnt});
    }
    if (number != 1) divisors.push_back({number, 1});
    return divisors;
}

// returns sorted list of all prime divisors of number
vi prime_divisors(ll number) {
    vi divisors;
    if (number % 2 == 0) {
        divisors.push_back(2);
        while (!(number % 2)) number /= 2;
    }
    ll start_number = number;
    for (ll p = 3; p <= number && p * p <= start_number; p += 2) {
        if (number % p) continue;
        divisors.push_back(p);
        while (!(number % p)) number /= p;
    }
    if (number - 1) divisors.push_back(number);
    return divisors;
}

// returns list of all divisors of number
vi all_divisors(ll number) {
    vi divisors;
    if (number % 2 == 0) {
        divisors.push_back(2);
        if (4 != number) { divisors.push_back(number / 2); }
    }
    for (ll p = 3; p * p <= number; p += 2) {
        ll t = p;
        if (number % t == 0) {
            divisors.push_back(p);
            if (p * p != number) { divisors.push_back(number / p); }
        }
    }
    return divisors;
}

// returns list of all primes <= number
class prime_sieve {
private:
    static const ll MAX = 100000010;
    static const ll LMT = 10000;
    unsigned flag[MAX/64];
    unsigned primes_list[MAX/10];
#define ifC(n) (flag[n>>6]&(1<<((n>>1)&31)))
#define isC(n) (flag[n>>6]|=(1<<((n>>1)&31)))

public:
    vi primes(ll number) {
        unsigned i, j, k, l;
        for(j = 9; j < MAX; j+=6) {
            isC(j);
        }
        for(i = 5; i < LMT; i+=6) {
            l=i+2;
            if(!ifC(i)) {
                for(j = i * i, k = 2 * i; j < MAX; j += k) {
                    isC(j);
                }
            }
            if(!ifC(l)) {
                for(j = l * l, k = 2 * l; j < MAX; j += k) {
                    isC(j);
                }
            }
        }
        primes_list[0]=2;
        primes_list[1]=3;
        for(k = 5, j = 1; k < number; k+=6) {
            if(!ifC(k))
                primes_list[++j] = k;
            if(!ifC(k+2))
                primes_list[++j] = k+2;
        }
        vi v;
        forin(primes_list) if (t) v.push_back(t);
        return v;
    }
};

// returns cycle permutation (1234)->(2341) [step = 1]
void cycle_perm_with_step(string& s, ll step) {
    char f = s[0];
    fori(s.size()) {
        s[i] = s[(i + step) % s.sz];
    }
    s[s.sz - step] = f;
    return;
}

// returns cycle permutation (1234)->(2341)
void cycle_perm(string& s) {
    cycle_perm_with_step(s, 1);
    return;
}

// returns GCD(a, b) [GCD(0, 0) = 1]
ll gcd(ll a, ll b) {
    if (!(a || b)) return 1;
    return (b ? gcd(b, a % b) : a);
}

// returns number of combination for N choose K
ll combinations(ll n, ll k) {
    return (k && n - k) ? combinations(n - 1, k) + combinations(n - 1, k - 1) : 1;
}

// returns factorial of N (N!)
ll factorial(ll n) {
    return (n > 1) ? n * factorial(n - 1) : 1;
}

// struct of segment tree with operations: sum, min, max and segment updating
class segmentTree {

private:
    bool have_delts;
    bool have_sums;
    bool have_mins;
    bool have_maxs;
    vi delts;
    vi sums;
    vi mins;
    vi maxs;
    vi arr;
    ll size;
    ll len;
    ll get_tree_size(ll n) { return 1 << ((ll)log2(2 * n - 1) + 1); }
    void calculate_vertex(ll apex, ll left_child, ll right_child) {
        if (have_sums) sums[apex] = sums[left_child] + sums[right_child];
        if (have_mins) mins[apex] = min(mins[left_child], mins[right_child]);
        if (have_maxs) maxs[apex] = min(maxs[left_child], maxs[right_child]);
    }
    void change_vertex(ll apex, ll value) {
        if (have_sums) sums[apex] = value;
        if (have_mins) mins[apex] = value;
        if (have_maxs) maxs[apex] = value;
    }
    void build(ll apex, ll l, ll r) {
        if (l == r)
            change_vertex(apex, arr[l]);
        else {
            ll left_child = (apex << 1) + 1;
            ll right_child = left_child + 1;
            ll mid = (l + r) >> 1;
            build(left_child, l, mid);
            build(right_child, mid + 1, r);
            calculate_vertex(apex, left_child, right_child);
        }
    }
    void update(ll apex, ll l, ll r, ll index, ll delt) {
        if (l == r) {
            arr[index] += delt;
            change_vertex(apex, arr[index]);
        }
        else {
            ll left_child = (apex << 1) + 1;
            ll right_child = left_child + 1;
            ll mid = (l + r) >> 1;

            if (l <= index && index <= mid) update(left_child, l, mid, index, delt);
            else update(right_child, mid + 1, r, index, delt);

            calculate_vertex(apex, left_child, right_child);
        }
    }
    void update_interval(ll apex, ll l, ll r, ll ql, ll qr, ll delt) {
        if (qr < l || r < ql) return;
        if (ql <= l && r <= qr) { delts[apex] += delt; return; }
        ll left_child = (apex << 1) + 1;
        ll right_child = left_child + 1;
        ll mid = (l + r) >> 1;
        update_interval(left_child, l, mid, ql, qr, delt);
        update_interval(right_child, mid + 1, r, ql, qr, delt);
    }
    ll sum_query(ll apex, ll l, ll r, ll ql, ll qr) {
        if (qr < l || r < ql) return 0;
        if (ql <= l && r <= qr) return sums[apex];
        ll left_child = (apex << 1) + 1;
        ll right_child = left_child + 1;
        ll mid = (l + r) >> 1;
        ll left_query = sum_query(left_child, l, mid, ql, qr);
        ll right_query = sum_query(right_child, mid + 1, r, ql, qr);
        return (left_query + right_query) + delts[apex];
    }
    ll min_query(ll apex, ll l, ll r, ll ql, ll qr) {
        if (qr < l || r < ql) return INF;
        if (ql <= l && r <= qr) return mins[apex];
        ll left_child = (apex << 1) + 1;
        ll right_child = left_child + 1;
        ll mid = (l + r) >> 1;
        ll left_query = min_query(left_child, l, mid, ql, qr);
        ll right_query = min_query(right_child, mid + 1, r, ql, qr);
        return min(left_query, right_query) + delts[apex];
    }
    ll max_query(ll apex, ll l, ll r, ll ql, ll qr) {
        if (qr < l || r < ql) return -INF;
        if (ql <= l && r <= qr) return maxs[apex];

        ll left_child = (apex << 1) + 1;
        ll right_child = left_child + 1;
        ll mid = (l + r) >> 1;

        ll left_query = max_query(left_child, l, mid, ql, qr);
        ll right_query = max_query(right_child, mid + 1, r, ql, qr);

        return max(left_query, right_query) + delts[apex];
    }

public:
    segmentTree(bool have_delt, bool have_sum, bool have_min, bool have_max, vi& v) {
        size = get_tree_size(v.size());
        arr = v;
        len = arr.size();
        have_delts = have_delt;
        have_sums = have_sum;
        have_mins = have_min;
        have_maxs = have_max;
        if (have_delts) delts.assign(size, 0);
        if (have_sums) sums.assign(size, 0);
        if (have_mins) mins.assign(size, INF);
        if (have_maxs) maxs.assign(size, -INF);
        build(0, 0, v.size() - 1);
    }

    ll get_sum(ll l, ll r) {
        return have_sums ? sum_query(0, 0, len - 1, l, r) : INF;
    }
    ll get_min(ll l, ll r) {
        return have_mins ? min_query(0, 0, len - 1, l, r) : INF;
    }
    ll get_max(ll l, ll r) {
        return have_maxs ? max_query(0, 0, len - 1, l, r) : INF;
    }
    void change_by(ll index, ll delt) {
        if (have_delts) update(0, 0, arr.size() - 1, index, delt);
    }
    void change_to(ll index, ll to) {
        ll delt = to - arr[index];
        if (have_delts) update(0, 0, arr.size() - 1, index, delt);
    }
    void change_interval_by(ll l, ll r, ll delt) {
        if (have_delts) update_interval(0, 0, len - 1, l, r, delt);
    }
};

// ------------------    CODE    ------------------ //

struct node {
    ll left = -1;
    ll right = -1;
    ll w = 1;
    ll st = 1;
};

void solve() {

    in(one); in(two);

    if (!one && two % 2 - 1) {
        Out << -1;
        return;
    }

    ll n = one + two;
    vector<node> tree(n);

    fori(n) {
        ll l = i + tree[i].st;
        ll r = i + 2 * tree[i].st;

        tree[i].right = l;
        tree[i].left = r;
        tree[l].st = 2 * tree[i].st;
        tree[r].st = 2 * tree[i].st;
    }

    ll ind = 0;
    fori(two) tree[ind++].w = 2;

    fori(n) {
        ll l = tree[i].left + 1;
        if (l > n) l = 0;
        ll r = tree[i].right + 1;
        if (r > n) r = 0;
        Out << tree[i].w << ' ' << l << ' ' << r << endl;
    }

    return;
}

int main() {
    fastIO;

    solve();

    return 0;
}