#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)

mt19937 rnd(239);

const int MOD = 1e9 + 7;

int sum_mod(int a, int b) {
    if (a + b >= MOD) {
        return a + b - MOD;
    }
    return a + b;
}

int sum(int a, int b, int p) {
    if (a + b >= p) {
        return a + b - p;
    }
    return a + b;
}

int sub_mod(int a, int b) {
    if (a < b) {
        return a - b + MOD;
    }
    return a - b;
}

int sub(int a, int b, int p) {
    if (a < b) {
        return a - b + p;
    }
    return a - b;
}

int mul_mod(int a, int b) {
    return 1LL * a * b % MOD;
}

int mul(int a, int b, int p) {
    return 1LL * a * b % p;
}

int power_mod(int a, int k) {
    if (k == 0) {
        return 1;
    }
    int t = power_mod(a, k >> 1);
    t = mul_mod(t, t);
    if (k & 1) {
        t = mul_mod(t, a);
    }
    return t;
}

int power(int a, int k, int p) {
    if (k == 0) {
        return 1;
    }
    int t = power(a, k >> 1, p);
    t = mul(t, t, p);
    if (k & 1) {
        t = mul(t, a, p);
    }
    return t;
}

const int M = 6e5 + 239;
const int X = 2e7 + 239;

ll f[M];
ll a, b, c, n;
int ans;

bool is_prime[X];

int f1, f0, p;

pair<int, int> mul(pair<int, int> x, pair<int, int> y) {
    int r1 = sum(mul(x.second, y.first, p), mul(y.second, x.first, p), p);
    int r0 = mul(x.second, y.second, p);
    int ml = mul(x.first, y.first, p);
    r0 = sum(r0, mul(ml, f0, p), p);
    r1 = sum(r1, mul(ml, f1, p), p);
    return make_pair(r1, r0);
}

pair<int, int> power(pair<int, int> x, int k) {
    if (k == 1) {
        return x;
    }
    pair<int, int> t = power(x, k >> 1);
    t = mul(t, t);
    if (k & 1) {
        t = mul(t, x);
    }
    return t;
}

int get_cnt(int p) {
    int ca = a % p;
    int cb = b % p;
    int cc = c % p;
    if (ca == 0 && cb == 0 && cc != 0) {
        return 0;
    }
    if (p == 2 || (ca == 0 && cb == 0)) {
        int ans = 0;
        for (int i = 0; i < n; i++) {
            while (f[i] % (ll)p == 0) {
                f[i] /= (ll)p;
                ans++;
            }
        }
        return ans;
    }
    if (ca == 0) {
        int need = mul(sub(0, cc, p), power(cb, p - 2, p), p);
        int ans = 0;
        for (int i = need; i < n; i += p) {
            while (f[i] % (ll)p == 0) {
                f[i] /= (ll)p;
                ans++;
            }
        }
        return ans;
    }
    f1 = mul(sub(0, cb, p), power(ca, p - 2, p), p);
    f0 = mul(sub(0, cc, p), power(ca, p - 2, p), p);
    //cerr << f1 << " " << f0 << "\n";
    int dd = sum(mul(f1, f1, p), mul(4, f0, p), p);
    if (dd != 0 && power(dd, (p - 1) / 2, p) != 1) {
        return 0;
    }
    ::p = p;
    int some = -1;
    while (true) {
        int add = rnd() % p;
        pair<int, int> cur = power(make_pair(1, add), (p - 1) / 2);
        cur.second = sub(cur.second, 1, p);
        if (cur.first != 0) {
            some = mul(sub(0, cur.second, p), power(cur.first, p - 2, p), p);
            if (mul(some, some, p) == sum(mul(some, f1, p), f0, p)) {
                break;
            }
        }
    }
    if (some == -1) {
        return 0;
    }
    //cerr << p << "\n";
    int other = sub(f1, some, p);
    int ans = 0;
    for (int i = some; i < n; i += p) {
        while (f[i] % (ll)p == 0) {
            f[i] /= (ll)p;
            ans++;
        }
    }
    if (other != some) {
        for (int i = other; i < n; i += p) {
            while (f[i] % (ll)p == 0) {
                f[i] /= (ll)p;
                ans++;
            }
        }
    }
    return ans;
}

void upd(int p) {
    int cnt = get_cnt(p);
    for (int i = 0; i < (cnt / 2); i++) {
        ans = mul_mod(ans, p);
    }
}

namespace pollard {
    //using math::p; // p - array of first primes: 2, 3, 5, ...
    // pc - their count
    // maxP - maximal prime in p
    vector<pair<ll, int>> getFactors(ll N) {
        vector<ll> primes;
        const int MX = 1e5;
        const ll MX2 = MX * (ll)MX;
        //assert(MX <= math::maxP && math::pc > 0);
        function<void(ll)> go = [&go, &primes](ll n) {
            for (ll x : primes) while (n % x == 0) n /= x;
            if (n == 1) return;
            if (n > MX2) {
                auto F = [&](ll x) {
                    ll k = ((long double)x * x) / n;
                    ll r = (x * x - k * n + 3) % n;
                    return r < 0 ? r + n : r;
                };
                ll x = mt19937_64()() % n, y = x;
                const int C = 3 * pow(n, 0.25);
                ll val = 1;
                for (int it = 0; it < C; it++) {
                    x = F(x), y = F(F(y));
                    if (x == y) continue;
                    ll delta = abs(x - y);
                    ll k = ((long double)val * delta) / n;
                    val = (val * delta - k * n) % n;
                    if (val < 0) val += n;
                    if (val == 0) {
                        ll g = gcd(delta, n);
                        go(g), go(n / g);
                        return;
                    }
                    if ((it & 255) == 0) {
                        ll g = gcd(val, n);
                        if (g != 1) {
                            go(g), go(n / g);
                            return;
                        }
                    }
                }
            }
            primes.push_back(n);
        };
        ll n = N;
        /*for (int i = 0; i < math::pc && p[i] < MX; ++i)
            if (n % p[i] == 0) {
                primes.push_back(p[i]);
                while (n % p[i] == 0) n /= p[i];
            }*/
        go(n);
        sort(primes.begin(), primes.end());
        vector<pair<ll, int>> res;
        for (ll x : primes) {
            int cnt = 0;
            while (N % x == 0) {
                cnt++;
                N /= x;
            }
            res.push_back({x, cnt});
        }
        return res;
    }
}

ll mult(ll a, ll b, ll m) {
    ll x = (ld)a * (ld)b / (ld)m;
    x = a * b - x * m;
    x %= m;
    if (x < 0) {
        x += m;
    }
    return x;
}

ll power_my(ll a, ll b, ll m) {
    if (b == 0) {
        return 1LL;
    }
    ll t = power_my(a, (b >> 1), m);
    ll sub = mult(t, t, m);
    if (b & 1) {
        return mult(a, sub, m);
    }
    return sub;
}

bool prime_test(ll a, ll n) {
    ll k = 0;
    ll x = n - 1;
    while ((x & 1) == 0) {
        k++;
        x >>= 1;
    }
    ll s = power_my(a, x, n);
    if (power_my(s, (1 << k), n) != 1) {
        return false;
    }
    for (int i = (1 << (k - 1)); i >= 1; i >>= 1) {
        ll now = power_my(s, i, n);
        if (now == n - 1) {
            return true;
        }
        if (now != 1) {
            return false;
        }
    }
    return true;
}

bool is_prime_f(ll n) {
    for (int i = 0; i < 4; i++) {
        ll a = rnd() % n;
        if (!prime_test(a, n)) {
            return false;
        }
    }
    return true;
}

map<ll, int> cnt;

void upd_poll(ll x) {
    if (is_prime_f(x)) {
        cnt[x]++;
        return;
    }
    vector<pair<ll, int>> v = pollard::getFactors(x);
    for (const auto& t : v) {
        cnt[t.first] += t.second;
    }
}

int main() {
#ifdef ONPC
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> a >> b >> c >> n;
    for (ll i = 0; i < n; i++) {
        f[i] = a * i * i + b * i + c;
    }
    for (int i = 2; i < X; i++) {
        is_prime[i] = true;
    }
    for (int i = 2; i * i <= X; i++) {
        if (is_prime[i]) {
            for (int j = i + i; j < X; j += i) {
                is_prime[j] = false;
            }
        }
    }
    ans = 1;
    for (int i = 2; i < X; i++) {
        //cerr << i << "\n";
        if (is_prime[i]) {
            upd(i);
        }
    }
    /*for (int i = 0; i < n; i++) {
        cerr << f[i] << " ";
    }
    cerr << "\n";*/
    cerr << "hello\n";
    int bad = 0;
    for (int i = 0; i < n; i++) {
        if (f[i] > 1) {
            bad++;
            upd_poll(f[i]);
        }
    }
    /*for (int i = 11; i <= 100; i++) {
        if (is_prime_f(i)) {
            cerr << i << "\n";
        }
    }*/
    for (const auto& t : cnt) {
        for (int i = 0; i < (t.second / 2); i++) {
            ans = mul_mod(ans, (t.first % MOD));
        }
    }
    cout << mul_mod(ans, ans) << "\n";
    cerr << bad << " bad numbers\n";
    cerr << TIME << "\n";
    return 0;
}
