#include <bits/stdc++.h>

using namespace std;

#define y1 kekek

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)

const int dx[6] = {1, 0, -1, -1, 0, 1};
const int dy[6] = {0, 1, 1, 0, -1, -1};
const int BIG = 1e9 + 239;

const int M = 50;

mt19937 rnd(239);
mt19937 player(239);

int n = 20;

bool check_inside(int x, int y) {
    if (x <= 0 && y >= 0) {
        return abs(x) <= n && abs(y) <= n;
    }
    if (x >= 0 && y <= 0) {
        return abs(x) <= n && abs(y) <= n;
    }
    if (x >= 0 && y >= 0) {
        return x + y <= n;
    }
    return x + y >= -n;
}

int x1, y1;
int x2, y2;

bool bad[50][50];

bool random_move(int& gx, int& gy) {
    vector<int> can;
    for (int d = 0; d < 6; d++) {
        int nx2 = x2 + dx[d];
        int ny2 = y2 + dy[d];
        if (check_inside(nx2, ny2) && !bad[nx2 + n][ny2 + n]) {
            can.push_back(d);
        }
    }
    shuffle(can.begin(), can.end(), rnd);
    if (can.empty()) {
        return false;
    }
    gx = dx[can[0]];
    gy = dy[can[0]];
    return true;
}

bool ch[M][M];

bool used[M][M];
int sz;

void dfs(int x, int y) {
    used[x + n][y + n] = true;
    sz++;
    for (int d = 0; d < 6; d++) {
        int xn = x + dx[d];
        int yn = y + dy[d];
        if (check_inside(xn, yn) && !used[xn + n][yn + n] && !ch[xn + n][yn + n]) {
            dfs(xn, yn);
        }
    }
}

int getsize(int x, int y) {
    sz = 0;
    memset(used, 0, sizeof(used));
    dfs(x, y);
    return sz;
}

vector<pair<int, int>> possible_good_directions() {
    vector<pair<int, int>> can;
    for (int d = 0; d < 6; d++) {
        int nx = x1 + dx[d];
        int ny = y1 + dy[d];
        if (check_inside(nx, ny) && !bad[nx + n][ny + n]) {
            memcpy(ch, bad, sizeof(bad));
            ch[x1 + n][y1 + n] = true;
            can.emplace_back(getsize(nx, ny), d);
        }
    }
    sort(can.rbegin(), can.rend());
    return can;
}

vector<int> possible_directions() {
    vector<int> can;
    for (int d = 0; d < 6; d++) {
        int nx = x1 + dx[d];
        int ny = y1 + dy[d];
        if (check_inside(nx, ny) && !bad[nx + n][ny + n]) {
            can.push_back(d);
        }
    }
    shuffle(can.begin(), can.end(), player);
    return can;
}

int move_id;

int make_move(int d) {
    int nx1 = x1 + dx[d];
    int ny1 = y1 + dy[d];
#ifdef ONPC
    if (!check_inside(nx1, ny1)) {
        cerr << "we are failed!\n";
        exit(0);
    }
    if (bad[nx1 + n][ny1 + n]) {
        cerr << "we are failed!\n";
        exit(0);
    }
#endif
    bad[x1 + n][y1 + n] = true;
    int gx, gy;
#ifndef ONPC
    cout << dx[d] << " " << dy[d] << endl;
    string res;
    cin >> res;
    if (res == "win") {
        return 1;
    }
    if (res == "move") {
        x1 = nx1;
        y1 = ny1;
        cin >> gx >> gy;
        x2 += gx;
        y2 += gy;
        bad[x2 + n][y2 + n] = true;
        return 0;
    }
    cerr << "we are failed!\n";
    exit(0);
#else
    if (!random_move(gx, gy)) {
        cerr << "cool!\n";
        return 1;
    }
    x1 = nx1;
    y1 = ny1;
    x2 += gx;
    y2 += gy;
    bad[x2 + n][y2 + n] = true;
#endif
    for (int d = 0; d < 6; d++) {
        if (dx[d] == gx && dy[d] == gy) {
            move_id = d;
            break;
        }
    }
    return 0;
}

/*int dist(int a, int b, int c, int d) {
    return abs(a - c) + abs(b - d);
}*/

int dst[M][M];

int dist(int a, int b, int c, int d) {
    for (int i = 0; i < M; i++) {
        for (int j = 0; j < M; j++) {
            dst[i][j] = BIG;
        }
    }
    dst[c + n][d + n] = 0;
    queue<pair<int, int>> q;
    q.push(make_pair(c, d));
    while (!q.empty()) {
        int x = q.front().first;
        int y = q.front().second;
        q.pop();
        for (int d = 0; d < 6; d++) {
            int xn = x + dx[d];
            int yn = y + dy[d];
            if (check_inside(xn, yn) && !bad[xn + n][yn + n]) {
                if (dst[xn + n][yn + n] > dst[x + n][y + n] + 1) {
                    dst[xn + n][yn + n] = dst[x + n][y + n] + 1;
                    q.push(make_pair(xn, yn));
                }
            }
        }
    }
    return dst[a + n][b + n];
    //return abs(a - c) + abs(b - d);
}

void play_game() {
    x1 = -(n / 2);
    y1 = 0;
    x2 = (n / 2);
    y2 = 0;
    memset(bad, 0, sizeof(bad));
    bad[x1 + n][y1 + n] = true;
    bad[x2 + n][y2 + n] = true;
    move_id = 0;
    while (true) {
        auto to = possible_good_directions();
        if (to.empty()) {
            cerr << "sad!\n";
            exit(0);
        }
        int mx = to[0].first;
        vector<tuple<int, int>> can;
        for (pair<int, int> t : to) {
            if (t.first == mx) {
                can.emplace_back(dist(x1 + dx[t.second], y1 + dy[t.second], x2, y2), t.second);
            }
        }

        sort(can.rbegin(), can.rend());
        if (make_move(get<1>(can[0])) != 0) {
            break;
        }
    }
}

int main() {
#ifdef ONPC
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int unused;
    int t;
    cin >> t >> unused;
    while (t--) {
        play_game();
    }
    return 0;
}
