/*
    author:  Maksim1744
    created: 13.12.2020 12:40:33
*/

#include "bits/stdc++.h"

using namespace std;

#define ll   long long
#define ld   long double

#define mp   make_pair
#define pb   push_back
#define eb   emplace_back

#define sum(a)     ( accumulate ((a).begin(), (a).end(), 0ll))
#define mine(a)    (*min_element((a).begin(), (a).end()))
#define maxe(a)    (*max_element((a).begin(), (a).end()))
#define mini(a)    ( min_element((a).begin(), (a).end()) - (a).begin())
#define maxi(a)    ( max_element((a).begin(), (a).end()) - (a).begin())
#define lowb(a, x) ( lower_bound((a).begin(), (a).end(), (x)) - (a).begin())
#define uppb(a, x) ( upper_bound((a).begin(), (a).end(), (x)) - (a).begin())

template<typename T>             vector<T>& operator--            (vector<T>& v){for (auto& i : v) --i;            return  v;}
template<typename T>             vector<T>& operator++            (vector<T>& v){for (auto& i : v) ++i;            return  v;}
template<typename T>             istream& operator>>(istream& is,  vector<T>& v){for (auto& i : v) is >> i;        return is;}
template<typename T>             ostream& operator<<(ostream& os,  vector<T>& v){for (auto& i : v) os << i << ' '; return os;}
template<typename T, typename U> istream& operator>>(istream& is, pair<T, U>& p){is >> p.first >> p.second;        return is;}
template<typename T, typename U> ostream& operator<<(ostream& os, pair<T, U>& p){os << p.first << ' ' << p.second; return os;}
template<typename T, typename U> pair<T,U> operator-(pair<T,U> a, pair<T,U> b){return mp(a.first-b.first, a.second-b.second);}
template<typename T, typename U> pair<T,U> operator+(pair<T,U> a, pair<T,U> b){return mp(a.first+b.first, a.second+b.second);}
template<typename T, typename U> void umin(T& a, U b){if (a > b) a = b;}
template<typename T, typename U> void umax(T& a, U b){if (a < b) a = b;}

#ifdef HOME
#define TAG_LENGTH       25
#define LR_LEFT          left
#define LR_RIGHT         right
#define LR_VALUE         value
#define LR_SECOND_VALUE  mn
#include "C:/C++ libs/print.cpp"
#else
#define showl            42;
#define shows            42;
#define show(...)        42;
#define showm(...)       42;
#define showt(...)       42;
#define printTree(...)   42;
#define printGraph(...)  42;
#define printLRTree(...) 42;
#define printMatrix(...) 42;
#define printWGraph(...) 42;
#define debug     if (false)
#endif

const ld inf = 1e9;

struct rat {
    ll a, b;
    rat(ll a = 0, int b = 1) : a(a), b(b) {
        norm();
    }

    void norm() {
        if (b < 0) {
            b *= -1;
            a *= -1;
        }
        ll d = gcd(abs(a), abs(b));
        a /= d;
        b /= d;
        if (a == 0) b = 1;
    }

    bool operator < (const rat &other) const {
        rat r = *this - other;
        return r.a < 0;
    }

    bool operator > (const rat &other) const {
        rat r = *this - other;
        return r.a > 0;
    }

    bool operator <= (const rat &other) const {
        rat r = *this - other;
        return r.a <= 0;
    }

    bool operator >= (const rat &other) const {
        rat r = *this - other;
        return r.a >= 0;
    }

    rat operator - (const rat &other) const {
        rat r;
        r.b = b * other.b;
        r.a = a * other.b - b * other.a;
        r.norm();
        return r;
    }

    rat operator + (const rat &other) const {
        rat r;
        r.b = b * other.b;
        r.a = a * other.b + b * other.a;
        r.norm();
        return r;
    }

    rat operator * (const rat &other) const {
        return rat(a * other.a, b * other.b);
    }

    rat operator / (const rat &other) const {
        return rat(a * other.b, b * other.a);
    }

    bool operator == (const rat &other) const {
        return a == other.a && b == other.b;
    }

    bool operator != (const rat &other) const {
        return a != other.a || b != other.b;
    }

    ld sqrt() const {
        return std::sqrt((ld)a) / std::sqrt((ld)b);
    }

    ld to_ld() const {
        return (ld)a / (ld)b;
    }
};

string to_string(const rat &r) {
    stringstream ss;
    ss << r.a << "/" << r.b;
    return ss.str();
}

rat sdist(const pair<rat, rat> &a, const pair<rat, rat> &b) {
    auto dx = a.first - b.first;
    auto dy = a.second - b.second;
    return dx * dx + dy * dy;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    int n, L;
    cin >> n >> L;
    vector<int> d(n);
    cin >> d;
    d.insert(d.begin(), 0);
    vector<int> h(d);
    cin >> h;
    vector<pair<rat, rat>> corners;
    for (int i = 0; i < n; ++i) {
        corners.eb(rat(d[i], 1), rat(h[i]));
        corners.eb(rat(d[i + 1], 1), rat(h[i], 1));
    }

    map<rat, bool> isup;
    map<rat, rat> maxh;
    for (int i = 1; i < n; ++i) {
        isup[rat(d[i])] = (h[i - 1] < h[i]);
        maxh[rat(d[i])] = rat(max(h[i - 1], h[i]));
    }

    auto cmp = [&](const pair<rat, rat> &a, const pair<rat, rat> &b) {
        if (a.first != b.first) return a.first < b.first;
        if (!isup.count(a.first)) return a.second < b.second;
        // show(a, b, a.second<b.second);
        // show(a, b, a.second>b.second);
        // show(isup[a.first]);
        if (isup[a.first]) return a.second < b.second;
        return a.second > b.second;
    };

    auto can_seg = [&](pair<rat, rat> ca, pair<rat, rat> cb) {
        if (ca.first > cb.first) swap(ca, cb);
        if (ca.first == cb.first) return true;
        for (auto cc : corners) {
            if (cc.first == ca.first && cc.second > ca.second) {
                return false;
            }
            if (cc.first == cb.first && cc.second > cb.second) {
                return false;
            }
            if (cc.first > ca.first && cc.first < cb.first) {
                rat y = (cb.second - ca.second) / (cb.first - ca.first) * (cc.first - ca.first) + ca.second;
                if (y < cc.second) return false;
            }
        }
        return true;
    };

    auto points = corners;

    for (auto ca : corners) {
        for (auto cb : corners) {
            if (ca.first >= cb.first) continue;
            if (ca.second == cb.second) continue;
            if (!can_seg(ca, cb)) continue;
            for (int i = 0; i < n; ++i) {
                if (rat(h[i]) == ca.second || rat(h[i]) == cb.second) continue;
                rat x = (ca.first - cb.first) / (ca.second - cb.second) * (rat(h[i]) - cb.second) + cb.first;
                if (x <= d[i] || x >= d[i + 1]) continue;
                // show(ca, cb, x, h[i]);
                points.eb(x, h[i]);
            }
        }
    }

    sort(points.begin(), points.end(), cmp);

    points.erase(unique(points.begin(), points.end()), points.end());

    show(points);
    show(isup);

    vector<ld> ans(points.size(), inf);
    ans[0] = 0;
    for (int i = 0; i < points.size(); ++i) {
        if (isup.count(points[i].first) && points[i].second == maxh[points[i].first]) {
            int j = i - 1;
            while (j >= 0) {
                while (j >= 0 && !can_seg(points[i], points[j])) --j;

                if (j == -1) break;

                bool ok = false;
                if (points[j].second < points[i].second) {
                    auto dd = sdist(points[i], points[j]);
                    if (dd.a <= dd.b * L * L) {
                        ans[i] = min(ans[i], ans[j] + dd.sqrt());
                        ok = true;
                    }
                }

                while (j - 1 >= 0 && points[j - 1].second == points[j].second) {
                    --j;
                    if (points[j].second < points[i].second && ok) {
                        auto dd = sdist(points[i], points[j]);
                        if (dd.a <= dd.b * L * L) {
                            ans[i] = min(ans[i], ans[j] + dd.sqrt());
                        } else {
                            if (points[i].second - points[j].second > rat(L)) continue;
                            ld dx = abs((points[j].first - points[i].first).to_ld());
                            ld dy = abs((points[j].second - points[i].second).to_ld());
                            ld jy = sqrt(max(0.0l, (ld)L * L - dy * dy));
                            // show(points[i], points[j], dx, dy, jy, (dx - jy) + L);
                            ans[i] = min(ans[i], ans[j] + (dx - jy) + L);
                        }
                    }
                }
                --j;
            }
        }
        for (int j = i + 1; j < points.size(); ++j) {
            if (j == i + 1 && points[i].second == points[j].second) {
                ans[j] = min(ans[j], ans[i] + (points[j].first - points[i].first).to_ld());
            }
            if (!can_seg(points[i], points[j])) continue;
            auto dd = sdist(points[i], points[j]);
            if (dd.a <= dd.b * L * L) {
                ans[j] = min(ans[j], ans[i] + dd.sqrt());
                continue;
            }

            // jump and walk
        }
        if (isup.count(points[i].first) && points[i].second == maxh[points[i].first]) {
            int j = i + 1;
            while (j < points.size()) {
                while (j < points.size() && !can_seg(points[i], points[j])) ++j;

                if (j == points.size()) break;

                bool ok = false;
                if (points[j].second < points[i].second) {
                    auto dd = sdist(points[i], points[j]);
                    if (dd.a <= dd.b * L * L) {
                        ans[j] = min(ans[j], ans[i] + dd.sqrt());
                        ok = true;
                    }
                }

                while (j + 1 < points.size() && points[j + 1].second == points[j].second) {
                    ++j;
                    if (points[j].second < points[i].second && ok) {
                        auto dd = sdist(points[i], points[j]);
                        if (dd.a <= dd.b * L * L) {
                            ans[j] = min(ans[j], ans[i] + dd.sqrt());
                        } else {
                            if (points[i].second - points[j].second > rat(L)) continue;
                            ld dx = abs((points[j].first - points[i].first).to_ld());
                            ld dy = abs((points[j].second - points[i].second).to_ld());
                            ld jy = sqrt(max(0.0l, (ld)L * L - dy * dy));
                            // show(points[i], points[j], dx, dy, jy, (dx - jy) + L);
                            ans[j] = min(ans[j], ans[i] + (dx - jy) + L);
                        }
                    }
                }
                ++j;
            }
        }
        if (isup.count(points[i].first) && points[i].second == maxh[points[i].first]) {
            for (int j = i + 1; j < points.size(); ++j) {
                if (isup.count(points[j].first) && points[j].second == maxh[points[j].first]) {
                    for (int k = 0; k < n; ++k) {
                        auto p2 = points[j];
                        p2.second = rat(h[k]) - (points[j].second - rat(h[k]));
                        auto ca = points[i];
                        auto cb = p2;
                        vector<pair<rat, rat>> oth;
                        for (int u = 0; u < n; ++u) {
                            if (rat(h[u]) == ca.second || rat(h[u]) == cb.second) continue;
                            rat x = (ca.first - cb.first) / (ca.second - cb.second) * (rat(h[u]) - cb.second) + cb.first;
                            if (x <= d[u] || x >= d[u + 1]) continue;
                            // show(ca, cb, x, h[u]);
                            oth.eb(x, rat(h[u]));
                        }
                        for (auto p : oth) {
                            if (can_seg(points[i], p) && can_seg(p, points[j])) {
                                auto dd1 = sdist(points[i], p);
                                auto dd2 = sdist(points[j], p);
                                if (dd1 <= rat(L * L) && dd2 <= rat(L * L)) {
                                    ans[j] = min(ans[j], ans[i] + sqrt(dd1.to_ld()) + sqrt(dd2.to_ld()));
                                }
                            }
                        }
                    }


                    for (int k = 0; k < n; ++k) {
                        if (rat(d[k]) < points[i].first) continue;
                        if (rat(d[k + 1]) > points[j].first) continue;
                        if (rat(h[k]) >= points[i].second) continue;
                        if (rat(h[k]) >= points[j].second) continue;
                        show(points[i], points[j]);
                        int ind1 = lower_bound(points.begin(), points.end(), mp(rat(d[k]), rat(h[k])), cmp) - points.begin();
                        show(points[ind1]);
                        while (ind1 < points.size() && points[ind1].second == rat(h[k]) && !can_seg(points[i], points[ind1])) ++ind1;
                        if (ind1 == points.size() || points[ind1].second != rat(h[k])) continue;
                        show(points[i], points[j]);


                        int ind2 = lower_bound(points.begin(), points.end(), mp(rat(d[k + 1]), rat(h[k])), cmp) - points.begin();
                        show(points[ind2]);
                        while (ind2 >= 0 && points[ind2].second == rat(h[k]) && !can_seg(points[j], points[ind2])) --ind2;
                        if (ind2 == -1 || points[ind2].second != rat(h[k])) continue;
                        show(points[i], points[j]);

                        show(ind1, ind2);

                        if (ind1 > ind2) continue;
                        auto dd1 = sdist(points[i], points[ind1]);
                        if (dd1 > rat(L * L)) continue;
                        auto dd2 = sdist(points[j], points[ind2]);
                        if (dd2 > rat(L * L)) continue;
                        ld dy1 = (points[i].second - points[ind1].second).to_ld();
                        ld dy2 = (points[j].second - points[ind2].second).to_ld();
                        ld x1 = points[i].first.to_ld() + sqrt((ld)L * L - dy1 * dy1);
                        ld x2 = points[j].first.to_ld() - sqrt((ld)L * L - dy2 * dy2);
                        ans[j] = min(ans[j], ans[i] + abs(x1 - x2) + L * 2);
                    }
                }
            }
        }
    }
    if (ans.back() == inf) {
        cout << -1 << '\n';
    } else {
        cout << fixed << setprecision(20) << ans.back() << '\n';
    }

    return 0;
}
