
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define sz(a) ((int)(a).size())
#define X first
#define Y second

using ll = long long;
using ull = unsigned long long;
using dbl = long double;
using pii = pair<int, int>;

const int N = (int)2e5 + 5;
const int C = 3*N;

struct query{
    int l, r, id;
};

struct item{
    int l, r, w;
};

struct Coord{
    vector<int> x;
    Coord(vector<int> _vals):x(_vals){
        sort(all(x));
        x.erase(unique(all(x)), x.end());
    }
    int get(int c)const{
        return lower_bound(all(x), c) - x.begin();
    }
};

struct Fenwick{
    int t[C];
    void inc(int x, int w){
        ++x;
        while(x < C){
            t[x] += w;
            x += x&-x;
        }
    }
    int get(int pref){
        ++pref;
        int ans = 0;
        while(pref){
            ans += t[pref];
            pref -= pref&-pref;
        }
        return ans;
    }
};

int n, q;
int ans[N];
int p[N];
int mi[N], ma[N];
int ch[N];
query qu[N];
item segs[N];
vector<int> ri[N];
int L[N], R[N], key[N];
int sch = 0;
int cl[3*N], cr[3*N];
int cl1[3*N], cr1[3*N];
Fenwick tr;

void dfs(int v){
    mi[v] = ma[v] = key[v];
    if(L[v] != -1){
        ++ch[v];
        dfs(L[v]);
        mi[v] = min(mi[v], mi[L[v]]);
        ma[v] = max(ma[v], ma[L[v]]);
    }
    if(R[v] != -1){
        ++ch[v];
        dfs(R[v]);
        mi[v] = min(mi[v], mi[R[v]]);
        ma[v] = max(ma[v], ma[R[v]]);
    }
}

void solve() {
    vector<int> coords;
    fill(L, L + N, -1);
    fill(R, R + N, -1);
    cin >> n;
    for(int i = 0; i < n; i++){
        cin >> L[i] >> R[i] >> key[i];
        coords.push_back(key[i]);
        --L[i]; --R[i];
        if(L[i] != -1)
            p[L[i]] = i;
        if(R[i] != -1)
            p[R[i]] = i;
    }
    dfs(0);
    cin >> q;
    for(int i = 0; i < q; i++){
        cin >> qu[i].l >> qu[i].r;
        coords.push_back(qu[i].l);
        coords.push_back(qu[i].r);
        qu[i].id = i;
    }
    Coord comp(coords);
    for(int i = 0; i < n; i++){
        ch[i] = 2;
        sch += ch[i];
//        cout << i << ' ' << mi[i] << ' ' << ma[i] << ' ' << ch[i] << endl;
        mi[i] = comp.get(mi[i]);
        ma[i] = comp.get(ma[i]);
        ++cl[ma[i]];
        cl1[ma[i]] += ch[i];
        ++cr[mi[i]];
        cr1[mi[i]] += ch[i];
    }
    for(int i = 1; i < 3*N; i++){
        cl[i] += cl[i - 1];
        cl1[i] += cl1[i - 1];
    }
    for(int i = 3*N - 2; i >= 0; i--){
        cr[i] += cr[i + 1];
        cr1[i] += cr1[i + 1];
    }
    for(int i = 0; i < q; i++){
        qu[i].l = comp.get(qu[i].l);
        qu[i].r = comp.get(qu[i].r);
    }
    for(int i = 0; i < n; i++){
        segs[i] = item{mi[i], ma[i], ch[i]};
    }
    sort(segs, segs + n, [](const item & l, const item & r){return l.r < r.r;});
    sort(qu, qu + q, [](const query & l, const query & r){return l.r < r.r;});
    int ptr = 0;
    int sum = 0;
    for(int i = 0; i < q; i++){
        int l = qu[i].l, r = qu[i].r, id = qu[i].id;
        //cerr << "processing " << l << ' ' << r << endl;
        while(ptr < n && segs[ptr].r <= r){
            //cerr << "adding " << segs[ptr].l << ' ' << segs[ptr].r << ' ' << segs[ptr].w << endl;
            tr.inc(segs[ptr].l, segs[ptr].w);
            sum += segs[ptr++].w;
        }
        //cerr << id << ' ' << sum << ' ' << tr.get(l - 1) << endl;
        int badc = (l ? cl1[l - 1] : 0) + (r + 1 < 3*N ? cr1[r + 1] : 0) + sum - tr.get(l - 1);
        int goodc = sch - badc;
        ans[id] = goodc + 1;
    }
    for(int i = 0; i < q; i++)
        cout << ans[i] << '\n';
}

signed main() {
#ifdef LOCAL
     assert(freopen("input.txt", "r", stdin));
     //assert(freopen("output.txt", "w", stdout));
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);
    int T;
    T = 1;
    while(T--)
	    solve();

#ifdef LOCAL
    cout << endl << endl << "time = " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
}


