#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <sstream>
#include <deque>
#include <queue>
#include <complex>
#include <random>
#include <cassert>
#include <chrono>
#include <functional>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define FIXED cout << fixed << setprecision(12)
#define ll __int128
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define f first
#define s second
#define hashmap unordered_map
#define hashset unordered_set
#define mod 1000000007
#define inf 3000000000000000007ll
#define sz(a) signed((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef DEBUG
    mt19937 gen(857204);
#else
    mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

void flush() { cout << flush; }
void flushln() { cout << endl; }
void println() { cout << '\n'; }
template<class T> void print(const T &x) { cout << x; }
template<class T> void read(T &x) { cin >> x; }
template<class T, class ...U> void read(T &x, U& ... u) { read(x); read(u...); }
template<class T, class ...U> void print(const T &x, const U& ... u) { print(x); print(u...); }
template<class T, class ...U> void println(const T &x, const U& ... u) { print(x); println(u...); }

#ifdef DEBUG
    template<class T> void pdbg(const T &x) { print(x); }
    template<class T, class U> void pdbg(const pair<T, U> &p) {
        print('{');
        pdbg(p.f);
        print(',');
        pdbg(p.s);
        print('}');
    }
    void pdbg(const string &s) { print("\"" + s + "\""); }
    template<class It> void pdbg(It begin, It end, string d);
    template<class T> void pdbg(const vector<T> &a) { pdbg(all(a), ""); }
    template<class T> void pdbg(const vector<vector<T>> &a) { pdbg(all(a), "\n"); }
    template<class T> void pdbg(const vector<vector<vector<T>>> &a) { pdbg(all(a), "\n\n"); }
    template<class T> void pdbg(const set<T> &a) { pdbg(all(a), ""); }
    template<class T> void pdbg(const hashset<T> &a) { pdbg(all(a), ""); }
    template<class T, class U> void pdbg(const map<T, U> &a) { pdbg(all(a), ""); }
    template<class T, class U> void pdbg(const hashmap<T, U> &a) { pdbg(all(a), ""); }
    template<class It> void pdbg(It begin, It end, string d) {
        print('{');
        if (begin != end) pdbg(*begin++);
        while (begin != end)
            print(",", d), pdbg(*begin++);
        print('}');
    }
    template<class T> void dbgout(const T &x) { pdbg(x); }
    template<class T, class... U>
    void dbgout(T const &t, const U &... u) {
        pdbg(t);
        print(", ");
        dbgout(u...);
    }
    #define dbg(...) print("[", #__VA_ARGS__, "] = "), dbgout(__VA_ARGS__), flushln()
#else
    #define dbg(...) 0
#endif

template<class T, class U> inline bool chmin(T &x, const U& y) { return y < x ? x = y, 1 : 0; }
template<class T, class U> inline bool chmax(T &x, const U& y) { return y > x ? x = y, 1 : 0; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &p) { return str >> p.f >> p.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }
template<class T> inline T sorted(T a) { sort(a); return a; }

istream& operator>>(istream& str, ll &a) { long long x; str >> x; a = x; return str; }
ostream& operator<<(ostream& str, ll a) { long long x = a; str << x; a = x; return str; }
#ifdef DEBUG
    ll abs(ll x) {
        if (x < 0) return -x;
        return x;
    }
#endif

struct vec {
    ll x, y;
    vec() {}
    vec(ll x, ll y) { this->x = x; this->y = y; }
    vec operator+=(const vec &v) { x += v.x; y += v.y; return *this; }
    vec operator-=(const vec &v) { x -= v.x; y -= v.y; return *this; }
    vec operator*=(const ll &k) { x *= k; y *= k; return *this; }
    vec operator-() const { return vec(-x, -y); }
    vec orth() const { return vec(-y, x); }
    ll len2() const { return x * x + y * y; }
    friend vec operator+(vec a, const vec &b) { return a += b; }
    friend vec operator-(vec a, const vec &b) { return a -= b; }
    friend vec operator*(vec a, const ll &k) { return a *= k; }
    friend ll operator*(const vec &a, const vec &b) { return a.x * b.x + a.y * b.y; }
    friend ll operator/(const vec &a, const vec &b) { return a.x * b.y - a.y * b.x; }
    friend istream& operator>>(istream& str, vec &v) { return str >> v.x >> v.y; }
    friend ostream& operator<<(ostream& str, const vec &v) { return str << v.x << ' ' << v.y; }
    friend bool operator<(const vec &a, const vec &b) { return a.x == b.x ? a.y < b.y : a.x < b.x; }
    friend bool operator==(const vec &a, const vec &b) { return a.x == b.x && a.y == b.y; }
    friend bool operator!=(const vec &a, const vec &b) { return a.x != b.x || a.y != b.y; }
};

struct line {
    ll a, b, c;
    line(vec p1, vec p2) {
        a = p2.y - p1.y;
        b = p1.x - p2.x;
        c = p1.x * (p1.y - p2.y) + p1.y * (p2.x - p1.x);
    }
};

ll det (ll a, ll b, ll c, ll d) {
    return a * d - b * c;
}

bool intersect (line m, line n, pair<ll, bool> &res) {
    ll zn = det (m.a, m.b, n.a, n.b);
    if (abs(zn) == 0)
        return false;
    res.f = -det(m.c, m.b, n.c, n.b);
    if (zn < 0) res.f = -res.f, zn = -zn;
    res.s = false;
    if (res.f % zn == 0) {
        res.f /= zn;
    } else {
        if (res.f < 0) res.f /= zn, --res.f;
        else res.f /= zn;
        res.s = true;
    }
    return true;
}


struct zet {
    int val;
    explicit operator int() const { return val; }
    zet(ll x = 0) { val = (x >= -mod && x < mod ? x : x % mod); if (val < 0) val += mod; }
    zet(ll a, ll b) { *this += a; *this /= b; }

    zet& operator+=(zet const &b) { val += b.val; if (val >= mod) val -= mod; return *this; }
    zet& operator-=(zet const &b) { val -= b.val; if (val < 0) val += mod; return *this; }
    zet& operator*=(zet const &b) { val = (val * (ll)b.val) % mod; return *this; }

    friend zet mypow(zet a, ll n) {
        zet res = 1;
        while (n) { if (n & 1) res *= a; a *= a; n >>= 1; }
        return res;
    }
    friend zet inv(zet a) { return mypow(a, mod - 2); }
    zet& operator/=(zet const& b) { return *this *= inv(b); }
    friend zet operator+(zet a, const zet &b) { return a += b; }
    friend zet operator-(zet a, const zet &b) { return a -= b; }
    friend zet operator-(zet a) { return 0 - a; }
    friend zet operator*(zet a, const zet &b) { return a *= b; }
    friend zet operator/(zet a, const zet &b) { return a /= b; }
    friend istream& operator>>(istream& stream, zet &a) { return stream >> a.val; }
    friend ostream& operator<<(ostream& stream, const zet &a) { return stream << a.val; }
    friend bool operator==(zet const &a, zet const &b) { return a.val == b.val; }
    friend bool operator!=(zet const &a, zet const &b) { return a.val != b.val; }
    friend bool operator<(zet const &a, zet const &b) { return a.val < b.val; }
};

const int N = 2e6 + 100;
zet fact[N], ifact[N];

zet C(int n, int k) {
    if (k > n) return 0;
    if (n >= N) return 0;
    return fact[n] * ifact[k] * ifact[n - k];
}

ll sq2(vec a, vec b, vec c) {
    return abs((b - a) / (c - a));
}

ll ceil(pair<ll, bool> p) {
    return p.f + p.s;
}

ll floor(pair<ll, bool> p) {
    return p.f;
}

bool differ(vec a, vec b, vec c, vec d) {
    ll sa = (c - a) / (d - a);
    ll sb = (c - b) / (d - b);
    return sa == 0 || sb == 0 || sa < 0 && sb > 0 || sa > 0 && sb < 0;
}

bool intersect(vec a, vec b, vec c, vec d) {
    return differ(a, b, c, d) && differ(c, d, a, b);
}

void solve() {
    vec p1, p2, p3;
    read(p1, p2, p3);
    line l1(p1, p2);
    line l2(p2, p3);
    line l3(p3, p1);
    vec t(2000000, 2000000);
    zet ans = 0;
    for (int diag = 0; diag <= 1e6; ++diag) {
        vec a = vec(-diag, diag) - t;
        vec b = vec(-diag, diag) + t;
        line l(a, b);
        vector<pair<ll, bool>> inter;
        pair<ll, bool> pos;
        if (intersect(l1, l, pos) && intersect(a, b, p1, p2) == 1) inter.pb(pos);
        if (intersect(l2, l, pos) && intersect(a, b, p2, p3) == 1) inter.pb(pos);
        if (intersect(l3, l, pos) && intersect(a, b, p3, p1) == 1) inter.pb(pos);
        sort(inter);
        if (sz(inter) >= 2) {
            ll mn = (ll)(ceil(inter.front()));
            ll mx = (ll)(floor(inter.back()));
            mn += diag;
            mx += diag;
            chmax(mn, 0);
            chmax(mx, -1);
            chmin(mx, N - 1);
            if (mn <= mx) {
                ans += C(diag + mx + 1, mx);
                if (mn > 0) {
                    --mn;
                    ans -= C(diag + mn + 1, mn);
                }
            }
        }
    }
    println(ans);
}

signed main() {
    FAST; FIXED;
    fact[0] = ifact[0] = 1;
    for (int i = 1; i < N; ++i) {
        fact[i] = fact[i - 1] * i;
        ifact[i] = ifact[i - 1] / i;
    }
    int t;
    read(t);
    while (t--) solve();
    #ifdef DEBUG
        cerr << "Runtime is: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
    #endif
    return 0;
}