#include <bits/stdc++.h>

using namespace std;

short int n = 20;

#define x first
#define y second

bool valid(short int x, short int y) {
    return -n <= y && y <= n && -n <= x && x <= n && x <= n - y && -n - y <= x;
}

vector<pair<short int, short int>> D = {{-1, 1}, {-1, 0}, {0, 1}, {1, -1}, {0, -1}, {1, 0}};

short int LOSE = 0;
short int WIN  = 0;

bool check_dead(int x, int y, map<pair<short int, short int>, bool> & was) {
    for (short int i = 0; i < 8; ++i) {
        pair<short int, short int> new_pos = {x + D[i].x, y + D[i].y};
        if (valid(new_pos.x, new_pos.y) && !was[new_pos])
            return false;
    }
    return true;
}

pair<short int, short int> my_pos;
pair<short int, short int> enemy_pos;

int dist2(pair<short int, short int> a, pair<short int, short int> b) {
    return (a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y);
}

bool cmp(pair<short int, short int> a, pair<short int, short int> b) {
    return dist2(a, enemy_pos) > dist2(b, enemy_pos);
}

void game() {
    map<pair<short int, short int>, bool> was;

    for (short int x = -n; x <= n; ++x)
    for (short int y = -n; y <= n; ++y) {
        if (valid(x, y))
            was[{x, y}] = false;
    }
    was[{-(n/2), 0}] = true;
    was[{ (n/2), 0}] = true;

    my_pos = {-(n/2), 0};
    enemy_pos = { (n/2), 0};
    while (1) {
        vector<pair<short int, short int>> pos_pos;
        for (short int i = 0; i < 8; ++i) {
            pair<short int, short int> new_pos = {my_pos.x + D[i].x, my_pos.y + D[i].y};
            if (valid(new_pos.x, new_pos.y) && !was[new_pos]) {
                pos_pos.push_back(new_pos);
            }
        }
        if (pos_pos.empty()) {
            LOSE++;
            exit(1);
        }
        if (rand() % 200)
            sort(pos_pos.begin(), pos_pos.end(), cmp);
        bool flag = false;
        for (int i = 0; i < pos_pos.size(); ++i) {
            if (!check_dead(pos_pos[i].x, pos_pos[i].y, was)) {
                cout << pos_pos[i].x - my_pos.x << ' ' << pos_pos[i].y - my_pos.y << endl;
                my_pos = pos_pos[i];
                was[my_pos] = true;
                flag = true;
                break;
            }
        }
        if (!flag) {
            cout << pos_pos[0].x - my_pos.x << ' ' << pos_pos[0].y - my_pos.y << endl;
            my_pos = pos_pos[0];
            was[my_pos] = true;
            flag = true;
        }
        string s;
        cin >> s;
        if (s == "lose")
            exit(0);
        else if (s == "win")
            return;
        else if (s == "move") {
            int dx, dy;
            cin >> dx >> dy;
            enemy_pos = {enemy_pos.x + dx, enemy_pos.y + dy};
            was[enemy_pos] = true;
        }
    }
}

int main() {
    srand(time(NULL));
    int t, q;
    cin >> t >> q;
    while (t--)
        game();
}