#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <sstream>
#include <deque>
#include <queue>
#include <complex>
#include <random>
#include <cassert>
#include <chrono>
#include <functional>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define FIXED cout << fixed << setprecision(12)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define f first
#define s second
#define hashmap unordered_map
#define hashset unordered_set
#define eps 1e-9
#define mod 1000000007
#define inf 3000000000000000007ll
#define sz(a) signed((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef DEBUG
    mt19937 gen(857204);
#else
    mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

void flush() { cout << flush; }
void flushln() { cout << endl; }
void println() { cout << '\n'; }
template<class T> void print(const T &x) { cout << x; }
template<class T> void read(T &x) { cin >> x; }
template<class T, class ...U> void read(T &x, U& ... u) { read(x); read(u...); }
template<class T, class ...U> void print(const T &x, const U& ... u) { print(x); print(u...); }
template<class T, class ...U> void println(const T &x, const U& ... u) { print(x); println(u...); }

#ifdef DEBUG
    template<class T> void pdbg(const T &x) { print(x); }
    template<class T, class U> void pdbg(const pair<T, U> &p) {
        print('{');
        pdbg(p.f);
        print(',');
        pdbg(p.s);
        print('}');
    }
    void pdbg(const string &s) { print("\"" + s + "\""); }
    template<class It> void pdbg(It begin, It end, string d);
    template<class T> void pdbg(const vector<T> &a) { pdbg(all(a), ""); }
    template<class T> void pdbg(const vector<vector<T>> &a) { pdbg(all(a), "\n"); }
    template<class T> void pdbg(const vector<vector<vector<T>>> &a) { pdbg(all(a), "\n\n"); }
    template<class T> void pdbg(const set<T> &a) { pdbg(all(a), ""); }
    template<class T> void pdbg(const hashset<T> &a) { pdbg(all(a), ""); }
    template<class T, class U> void pdbg(const map<T, U> &a) { pdbg(all(a), ""); }
    template<class T, class U> void pdbg(const hashmap<T, U> &a) { pdbg(all(a), ""); }
    template<class It> void pdbg(It begin, It end, string d) {
        print('{');
        if (begin != end) pdbg(*begin++);
        while (begin != end)
            print(",", d), pdbg(*begin++);
        print('}');
    }
    template<class T> void dbgout(const T &x) { pdbg(x); }
    template<class T, class... U>
    void dbgout(T const &t, const U &... u) {
        pdbg(t);
        print(", ");
        dbgout(u...);
    }
    #define dbg(...) print("[", #__VA_ARGS__, "] = "), dbgout(__VA_ARGS__), flushln()
#else
    #define dbg(...) 0
#endif

template<class T, class U> inline bool chmin(T &x, const U& y) { return y < x ? x = y, 1 : 0; }
template<class T, class U> inline bool chmax(T &x, const U& y) { return y > x ? x = y, 1 : 0; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &p) { return str >> p.f >> p.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }
template<class T> inline T sorted(T a) { sort(a); return a; }

graph G;
vector<int> v;
vector<int> sub, sval, mn, mx, ind;

void orient(int v) {
    static int currt = 0;
    if (sz(G[v])) {
        orient(G[v][0]);
    }
    mn[v] = mx[v] = ind[v] = currt++;
    sval.pb(v);
    if (sz(G[v])) {
        orient(G[v][1]);
        chmin(mn[v], mn[G[v][0]]);
        chmax(mx[v], mx[G[v][1]]);
    }
}

bool intersect(pii a, pii b) {
    return a.f < b.f && a.s > b.f || a.f < b.s && a.s > b.s;
}

template<class T> struct Fenv {
    int N, LOG;
    T *fenv;
    Fenv(int N) {
        this->N = N;
        LOG = log2(N);
        fenv = new T[N];
        for (int i = 0; i < N; ++i) fenv[i] = 0;
    }
    ~Fenv() { delete [] fenv; }
    void add(int r, T x) { //adds x to a[r]
        for (; r < N; r |= r + 1) fenv[r] += x;
    }
    T get(int r) { //sum of [0, r]
        T ans = 0;
        for (; r >= 0; r = (r & r + 1) - 1)
            ans += fenv[r];
        return ans;
    }
    T get(int l, int r) { //sum of [l, r]
        return get(r) - get(l - 1);
    }
    int lb(T k) { //first index which sum is >= k
        int ans = -1;
        for (int l = LOG; l >= 0; --l) {
            int next = ans + (1 << l);
            if (next < N && k > fenv[next]) {
                ans = next;
                k -= fenv[next];
            }
        }
        return ans + 1;
    }
};

vector<int> both(vector<pii> segm, vector<pii> query) {
    int mx = 0;
    for (auto i : segm)
        chmax(mx, i.s);
    for (auto i : query)
        chmax(mx, i.s);
    vector<int> iq(sz(query));
    iota(all(iq), 0);
    sort(all(iq), [&](int i, int j) {
        return query[i].f < query[j].f;
    });
    sort(all(segm));
    int ptr = 0;
    Fenv<int> cnt(mx + 1);
    vector<int> ans(sz(query));
    for (auto i : iq) {
        while (ptr < sz(segm) && segm[ptr].f < query[i].f) {
            cnt.add(segm[ptr].s, 1);
            ++ptr;
        }
        ans[i] = cnt.get(query[i].s + 1, mx);
    }
    return ans;
}

signed main() {
    FAST; FIXED;
    int n;
    read(n);
    G = graph(n);
    v = vector<int>(n);
    int sn = n;
    for (int i = 0; i < sn; ++i) {
        int l, r, k;
        read(l, r, k);
        --l, --r;
        v[i] = k;
        if (l == -1 && r == -1) continue;
        if (l == -1 || r == -1) {
            G.pb(vector<int>());
            v.pb(k);
            if (l == -1) G[i].pb(n), G[i].pb(r);
            if (r == -1) G[i].pb(l), G[i].pb(n);
            ++n;
        } else {
            G[i].pb(l);
            G[i].pb(r);
        }
    }
    ind = vector<int>(n);
    mn = vector<int>(n, mod);
    mx = vector<int>(n, -mod);
    orient(0);
    vector<pii> segm;
    for (int i = 0; i < n; ++i) {
        segm.pb({mn[i], mx[i]});
    }
    for (auto &i : segm) {
        i.f = i.f * 2 + 2;
        i.s = i.s * 2 + 2;
    }
    dbg(segm);
    int q;
    read(q);
    vector<pii> query(q);
    auto x = v;
    sort(x);
    for (int i = 0; i < q; ++i) {
        int ql, qr;
        read(ql, qr);
        int l =
        query[i].f = lower_bound(all(x), ql) - x.begin();
        query[i].s = upper_bound(all(x), qr) - x.begin() - 1;
    }
    for (auto &i : query) {
        i.f = 2 * i.f + 1;
        i.s = 2 * i.s + 3;
    }
    int mx = 0;
    for (auto i : segm)
        chmax(mx, i.s);
    for (auto i : query)
        chmax(mx, i.s);
    Fenv<int> cnt(mx + 1);
    for (auto i : segm) {
        cnt.add(i.f, 1);
        cnt.add(i.s + 1, -1);
    }
    vector<int> ans(q);
    for (int i = 0; i < q; ++i) {
        ans[i] = cnt.get(query[i].f) + cnt.get(query[i].s);
    }
    vector<int> ans2 = both(segm, query);
    for (int i = 0; i < q; ++i) ans[i] -= ans2[i];
    for (auto i : ans) println(2 * i + 1);
    #ifdef DEBUG
        cerr << "Runtime is: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
    #endif
    return 0;
}