#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define dbl double
#define rep(i, a, b) for(int i = a; i < b; ++i)
typedef array <int, 2> pt;
typedef array <dbl, 2> pd;


int debug = 0;

dbl INF = 1e9, eps = 1e-9;

const int N = 2e6 + 10, mod = 1e9 + 7;
int fac[N], fin[N];
pt tr[4];

int pw(int x, int p) {
    if (p == 0) return 1;
    if (p % 2) return pw(x, p - 1) * x % mod;
    int res = pw(x, p / 2);
    return res * res % mod;
}

int inv(int x) {
    return pw(x, mod - 2);
}

void precalc() {
    fac[0] = 1;
    rep(i, 1, N) {
        fac[i] = fac[i - 1] * i % mod;
    }
    rep(i, 0, N) {
        fin[i] = inv(fac[i]);
    }
}

int C(int n, int k) {
    if (n < k) return 0;
    return (fac[n] * fin[k] % mod) * fin[n - k] % mod;
}

pt operator - (pt a, pt b) {
    return {a[0] - b[0], a[1] - b[1]};
}

int vec(pt a, pt b) {
    return a[0] * b[1] - a[1] * b[0];
}

int scal(pt a, pt b) {
    return a[0] * b[0] + a[1] * b[1];
}

int sign(int x) {
    return (x > 0) ? 1 : (x < 0) ? -1 : 0;
}

bool belongSide(pt p, pt a, pt b) { // we have a, b, p on one line
    return scal(a - p, b - p) <= 0;
}

bool belong(pt p) {
    int sgnAll = sign(vec(tr[0] - p, tr[1] - p));
    rep(i, 0, 3) {
        int sgn = sign(vec(tr[i] - p, tr[(i+1)%3] - p));
        if (sgn == 0) {
            return belongSide(p, tr[i], tr[i + 1]);
        }
        if (sgn != sgnAll && sgnAll != 0) {
            return 0;
        }
    }
    return 1;
}

bool dblBelong(pd p, pt A, pt B) {
    pd PA = {(dbl)A[0] - p[0], (dbl)A[1] - p[1]};
    pd PB = {(dbl)B[0] - p[0], (dbl)B[1] - p[1]};
    return PA[0] * PB[0] + PA[1] * PB[1] <= 0;
}

pd intersect(pt A, pt B, pt C, pt D) { 
    // Line AB represented as a1x + b1y = c1 
    int a1 = B[1] - A[1]; 
    int b1 = A[0] - B[0]; 
    int c1 = a1*(A[0]) + b1*(A[1]); 
  
    // Line CD represented as a2x + b2y = c2 
    int a2 = D[1] - C[1]; 
    int b2 = C[0] - D[0]; 
    int c2 = a2*(C[0])+ b2*(C[1]); 
    int determinant = a1*b2 - a2*b1; 
    if (determinant == 0)  { 
        // The lines are parallel. This is simplified 
        // by returning a pair of FLT_MAX 
        return {INF, INF}; 
    }  else { 
        dbl x = (dbl)(b2*c1 - b1*c2)/(dbl)determinant; 
        dbl y = (dbl)(a1*c2 - a2*c1)/(dbl)determinant;
        pd res = {x, y};
        if (dblBelong(res, A, B) && dblBelong(res, C, D)) {
            return res;
        } else {
            return {INF, INF};
        }
    } 
} 

bool equal(pd p, pd q) {
    return abs(p[0] - q[0]) < eps && abs(p[1] - q[1]) < eps;
}

int f(int i, int R) {
    if (R < 0) return 0;
    return C(R + i + 1, i + 1);
}

void solve() {
    rep(i, 0, 3) {
        cin >> tr[i][0] >> tr[i][1];   
    }
    tr[3][0] = tr[0][0];
    tr[3][1] = tr[0][1];
    int ans = 0;

    rep(i, 0, N) {
        pt A = {-i - N, i - N}, B = {-i + N, i + N};
        /*if (debug && i < 3) {
            cerr << '\n';
            cerr << " A: " << A[0] << ' ' << A[1] << " B: " << B[0] << ' ' << B[1] << '\n';
        }*/
        vector <pd> inter;
        rep(j, 0, 3) {
            pt C = tr[j], D = tr[(j + 1) % 3];
            auto res = intersect(A, B, C, D);
            if (debug && i < 3) {
                //cerr << " i: " << i <<  " inter " << res[0] << ' ' << res[1] << '\n';
            }
            if (abs(res[0] - INF) > eps) {
                inter.push_back(res);
            }
        }
        vector <pd> inter2;
        for (auto p : inter) {
            int flag = 0;
            for (auto q : inter2) {
                if (equal(p, q)) {
                    flag = 1;
                    break;
                }
            }
            if (!flag) {
                inter2.push_back(p);
            }
        }
        int m = inter2.size();
        assert(0 <= m && m <= 2);
        sort(inter2.begin(), inter2.end());
        int L = -1, R = -1;
        if (m == 1) {
            int x = (int)(inter2[0][0]), y = (int)(inter2[0][1]);
            int inf = 1e9;
            L = inf, R = -inf;
            int pos = x + i;
            rep(delta, -5, 5) {
                int x = -i + pos + delta;
                int y = i + pos + delta;
                if (belong({x, y})) {
                    L = min(L, y - i);
                    R = max(R, y - i);
                }
            }
            if (L == inf) L = R = -1;
            /*if (abs((dbl)x - inter2[0][0]) > eps || abs((dbl)y - inter2[0][1]) > eps) {
                L = R = -1;
            } else {
                L = R = y - i;
            }*/
        } else if (m == 2) {
            L = (int)ceil(inter2[0][1]) - i;
            R = (int)(inter2[1][1]) - i;
            rep(delta, -3, 3) {
                if (belong({-i + L + delta, i + L + delta})) {
                    L += delta;
                    break;
                }
            }
            for (int delta = 3; delta > -3; --delta) {
                if (belong({-i + R + delta, i + R + delta})) {
                    R += delta;
                    break;
                }
            }
        }
        if (!(L == -1 && R == -1) && L <= R) {
            ans = (ans + f(i, R) - f(i, L - 1) + mod * 10) % mod; 
        }

        if (0 && i < 5) {
            cerr << " i: " << i << " L: " << L << " R: " << R << '\n';
            cerr << "    f(i, R): " << f(i, R) << ' ' << f(i, L - 1) << '\n';
            cerr << " inter2: ";
            for (auto i : inter2) cerr << i[0] << ' ' << i[1] << "  ";
            cerr << '\n';
        }
    }
    cout << ans << '\n';
}

main() {
    int t;
    precalc();
    cin >> t;
    while (t--) {
        solve();
    }
}