#include <bits/stdc++.h>

using namespace std;
using Graph = vector<vector<int>>;
typedef long long ll;
#define all(x) (x).begin(), (x).end()

template<class T>
std::ostream &operator<<(std::ostream &os, const std::vector<T> &V) {
    os << "[";
    for (int i = 0; i < V.size(); ++i) {
        if (i > 0) os << ", ";
        os << V[i];
    }
    os << "]";
    return os;
}

template<class A, class B>
std::ostream &operator<<(std::ostream &os, const std::pair<A, B> &V) {
    os << "{" << V.first << ", " << V.second << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::map<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D, class E>
std::ostream &operator<<(std::ostream &os, const std::unordered_map<A, B, C, D, E> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C>
std::ostream &operator<<(std::ostream &os, const std::set<A, B, C> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::unordered_set<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

void debug_func() {}

template<class Head, class...Tail>
void debug_func(Head H, Tail... T) {
    std::cout << " " << H;
    debug_func(T...);
}

#ifdef OCHKO
#define debug(...) std::cout << "[" << #__VA_ARGS__ "]:"; debug_func(__VA_ARGS__);cout << endl;
#else
#define debug(...) 3;
#endif

int nxt = 1;
int color[200010];

int solve(vector<vector<int>>& ans, int a, int b) {
    if (a == 0 && b == 0) return 0;
    int cur = nxt++;
    if (b % 2 == 1) {
        int left = solve(ans, a / 2, b / 2);
        int right = solve(ans, a / 2 + a % 2, b / 2);
        if (left == -1 || right == -1) return -1;
        ans[cur].push_back(left);
        ans[cur].push_back(right);
        color[cur] = 2;
        return cur;
    } else if (a == 0) {
        return -1;
    } else {
        int left = solve(ans, (a - 1) / 2 + (a - 1) % 2, b / 2);
        int right = solve(ans, (a - 1) / 2, b / 2);
        if (left == -1 || right == -1) return -1;
        ans[cur].push_back(left);
        ans[cur].push_back(right);
        color[cur] = 1;
        return cur;
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef OCHKO
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int a, b;
    cin >> a >> b;
    vector<vector<int>> ans(a + b + 1);
    int res = solve(ans, a, b);
    if (res == -1) {
        cout << -1 << "\n";
        return 0;
    }
    for (int i = 1; i <= a + b; ++i) {
        cout << color[i] << ' ';
        for (int i : ans[i]) cout << i << ' ';
        cout << "\n";
    }
	return 0;
}

