#include <bits/stdc++.h>

using namespace std;
using Graph = vector<vector<int>>;
typedef long long ll;

template<class T>
std::ostream &operator<<(std::ostream &os, const std::vector<T> &V) {
    os << "[";
    for (int i = 0; i < V.size(); ++i) {
        if (i > 0) os << ", ";
        os << V[i];
    }
    os << "]";
    return os;
}

template<class A, class B>
std::ostream &operator<<(std::ostream &os, const std::pair<A, B> &V) {
    os << "{" << V.first << ", " << V.second << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::map<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D, class E>
std::ostream &operator<<(std::ostream &os, const std::unordered_map<A, B, C, D, E> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C>
std::ostream &operator<<(std::ostream &os, const std::set<A, B, C> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::unordered_set<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

void debug_func() {}

template<class Head, class...Tail>
void debug_func(Head H, Tail... T) {
    std::cout << " " << H;
    debug_func(T...);
}

#ifdef OCHKO
#define debug(...) std::cout << "[" << #__VA_ARGS__ "]:"; debug_func(__VA_ARGS__);cout << endl;
#else
#define debug(...) 3;
#endif

unordered_map<int, char> d2c;
unordered_map<char, int> c2d;
string a, b;

unordered_set<string> good;
unordered_set<string> bad;

void generate(const vector<char>& S, unordered_set<int>& unused, int ind) {
    if (ind == S.size()) {
        long long first = 0, second = 0;
        long long pw = 1;
        for (int i = a.length() - 1; i >= 0; --i) {
            first += pw * c2d[a[i]];
            pw *= 10;
        }
        pw = 1;
        for (int i = b.length() - 1; i >= 0; --i) {
            second += pw * c2d[b[i]];
            pw *= 10;
        }

        long long result = first + second;
        string kek;
        char mem = '1';
        vector<int> todel;
        while (result > 0) {
            int dig = result % 10;
            result /= 10;
            if (d2c.count(dig)) kek += d2c[dig];
            else {
                kek += mem;
                d2c[dig] = mem++;
                todel.push_back(dig);
            }
        }
        reverse(kek.begin(), kek.end());
        for (int i : todel) d2c.erase(i);


        if (!bad.count(kek) && !good.count(kek)) {
            good.insert(kek);
        } else if (good.count(kek)){
            good.erase(kek);
            bad.insert(kek);
        }
        return;
    }

    if (c2d.count(S[ind])) {
        generate(S, unused, ind + 1);
    } else {
        auto unused2 = unused;
        for (int i : unused) {
            d2c[i] = S[ind];
            c2d[S[ind]] = i;
            unused2.erase(i);
            generate(S, unused2, ind + 1);
            unused2.insert(i);
            d2c.erase(i);
        }
        c2d.erase(S[ind]);
    }

}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef OCHKO
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    cin >> a >> b;
    unordered_map<char, int> M;
    set<char> S;
    for (char q : a) {
        S.insert(q);
    }
    for (char q : b) {
        S.insert(q);
    }
    if (S.size() > 10) {
        cout << -1;
        return 0;
    }

    unordered_set<int> unused(10);
    for (int i = 0; i < 10; ++i) unused.insert(i);
    vector<char> order{S.begin(), S.end()};
    generate(order, unused, 0);
    int t;
    cin >> t;
    vector<string> ans;
    while (t--) {
        string mem;
        cin >> mem;
        string mem2 = mem;
        unordered_map<char, char> her;
        char rr = '1';
        for (int i = mem.length() - 1; i >= 0; --i) {
            if (!her.count(mem[i]) && !S.count(mem[i])) {
                her[mem[i]] = rr;
                mem[i] = rr++;
            }
        }
        if (good.count(mem)) {
            ans.push_back(mem2);
        }
    }
    cout << ans.size() << "\n";
    for (auto& i : ans) cout << i << "\n";
	return 0;
}

