#/usr/bin/python3
import sys
import subprocess
import os

input = sys.stdin.readline

def gcd(a, b):
    if a == 0:
        return b, 0, 1
    d, x1, y1 = gcd(b % a, a)
    x = y1 - (b // a) * x1
    y = x1
    return d, x, y


def find_any(a, b, c):
    g, x0, y0 = gcd(abs(a), abs(b))
    if c % g != 0:
        return None
    x0 *= c // g
    y0 *= c // g
    if a < 0:
        x0 = -x0
    if b < 0:
        y0 = -y0
    return g, x0, y0


def shift(x, y, a, b, cnt):
    x += cnt * b
    y -= cnt * a
    return x, y


def find_all(a, b, c, minx, maxx, miny, maxy):
    fa = find_any(a, b, c)
    if fa is None:
        return 0
    g, x, y = fa

    a //= g
    b //= g

    sign_a = 1 if a > 0 else -1
    sign_b = 1 if b > 0 else -1

    x, y = shift(x, y, a, b, (minx - x) // b)
    if x < minx:
        x, y = shift(x, y, a, b, sign_b)
    if x > maxx:
        return 0

    lx1 = x
    x, y = shift(x, y, a, b, (maxx - x) // b)
    if (x > maxx):
        x, y = shift(x, y, a, b, -sign_b)
    rx1 = x

    ####

    x, y = shift(x, y, a, b, -(miny - y) // a)
    if y < miny:
        x, y = shift(x, y, a, b, -sign_a)
    if y > maxy:
        return 0

    lx2 = x
    x, y = shift(x, y, a, b, -(maxy - y) // a)
    if (y > maxy):
        x, y = shift(x, y, a, b, sign_a)
    rx2 = x

    if lx2 > rx2:
        lx2, rx2 = rx2, lx2

    lx = max(lx1, lx2)
    rx = min(rx1, rx2)

    return (rx - lx) // abs(b) + 1

def main():
    n = int(input())
    for i in range(n):
        b, d = map(int, input().split())
        print(find_all(b, d, b ** 2, 1, int(1e18), 1, int(1e18)))

main()
