#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()

typedef long long ll;

const int N = 1e6;
const ll INF = 1e18;

__int128 myabs(__int128 a) {
  if (a >= 0) return a;
  else return -a;
}

__int128 gcd (__int128 a, __int128 b, __int128 & x, __int128 & y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	__int128 x1, y1;
	__int128 d = gcd (b%a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

bool find_any_solution (__int128 a, __int128 b, __int128 c, __int128 & x0, __int128 & y0, __int128 & g) {
	g = gcd (myabs(a), myabs(b), x0, y0);
	if (c % g != 0)
		return false;
	x0 *= c / g;
	y0 *= c / g;
	if (a < 0)   x0 *= -1;
	if (b < 0)   y0 *= -1;
	return true;
}

void shift_solution (__int128 & x, __int128 & y, __int128 a, __int128 b, __int128 cnt) {
	x += cnt * b;
	y -= cnt * a;
}

__int128 find_all_solutions (__int128 a, __int128 b, __int128 c, __int128 minx, __int128 maxx, __int128 miny, __int128 maxy) {
	__int128 x, y, g;
	if (! find_any_solution (a, b, c, x, y, g))
		return 0;
	a /= g;  b /= g;

	__int128 sign_a = a>0 ? +1 : -1;
	__int128 sign_b = b>0 ? +1 : -1;

	shift_solution (x, y, a, b, (minx - x) / b);
	if (x < minx)
		shift_solution (x, y, a, b, sign_b);
	if (x > maxx)
		return 0;
	__int128 lx1 = x;

	shift_solution (x, y, a, b, (maxx - x) / b);
	if (x > maxx)
		shift_solution (x, y, a, b, -sign_b);
	__int128 rx1 = x;

	shift_solution (x, y, a, b, - (miny - y) / a);
	if (y < miny)
		shift_solution (x, y, a, b, -sign_a);
	if (y > maxy)
		return 0;
	__int128 lx2 = x;

	shift_solution (x, y, a, b, - (maxy - y) / a);
	if (y > maxy)
		shift_solution (x, y, a, b, sign_a);
	__int128 rx2 = x;

	if (lx2 > rx2)
		swap (lx2, rx2);
	__int128 lx = max (lx1, lx2);
	__int128 rx = min (rx1, rx2);

	return (rx - lx) / myabs(b) + 1;
}

void print(__int128 a) {
  if (a == 0) {
    cout << "0\n"; return;
  }
  vector<int> vt;
  while (a) {
    vt.push_back(a % 10); a /= 10;
  }
  reverse(all(vt));
  for (auto x : vt) cout << x; cout << "\n";
}

void solve() {
  ll b, d; cin >> b >> d;
  __int128 ans = find_all_solutions(d, b, b * b, 1, INF, 1, INF);
  print(ans);
  // ll nans = ans;
  // cout << nans << "\n";
}

int main() {
  ios::sync_with_stdio(NULL), cin.tie(0), cout.tie(0);
  cout.setf(ios::fixed), cout.precision(20);
  //cout << 1.0 * clock() / CLOCKS_PER_SEC << endl;
  int t; cin >> t; while (t--) solve();
}
